// -*-c++-*-

#ifndef _PRINTER_COMPONENT_H__
#define _PRINTER_COMPONENT_H__

// PrinterComponent.h: Interface of the printer 
// component for the outside world. This is a
//  portable component.  There is nothing here
// that relates to any specific framework. 
// This component provides a String_idl port and
// uses a String_idl port. The component itself 
// implements the provides port (so it inherits
// from ProvidesString_idlPort)
// --Madhu

#include "../../../../framework/idl/string/string_idl.h"
#include "../../../../framework/ccacore/Component.h"
#include "../../../../framework/idl/string/ProvidesString_idlPort.h"

class Services;
class PrinterComponent: public Component, public ProvidesString_idlPort{
private:
  Services *core;
public:
  PrinterComponent();
  void setServices(Services *cc);
  int setString(char *);
  void execute();
};
#endif //  _PRINTER_COMPONENT_H__
