#include "PrinterComponentHome.h"
#include "../../../../framework/idl/string/CCAT_string_idl.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool PrinterComponentHome::initFlag = false;

PrinterComponent* PrinterComponentHome::instantiate() {
  init();
  return new PrinterComponent();
}

void PrinterComponentHome::init() {
  cout << "PrinterComponentHome::init()\n" << flush;
  // registering ports
  CCATUsesString_idlSkel::registerSelf();
  CCATProvidesString_idlSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "PrinterComponentHome: registering printer component\n" << flush;
    initFlag = true;

    myString compName("MyPrinterComponent");
    PrinterComponent *dummyComp = 0;
    PrinterComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
