#ifndef CCAT_ASSEMBLE_COMPONENT_H
#define CCAT_ASSEMBLE_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"


class Services;
class SolutionVector;
class SolutionVector_impl;
class Geometry;
class Geometry_impl;
class AssembleParms_impl;

class AssembleComponent : public Component {

    friend SolutionVector_impl;
    friend Geometry_impl;
    friend AssembleParms_impl;

    public:

        AssembleComponent();
        virtual ~AssembleComponent();
        void setServices(Services *cc);

    private:
        
        void startComputation(SolutionVector *sv, Geometry *);
        void compute(SolutionVector *sv, Geometry *);
        static void *compute_wrapper(void *);

    private:

        Services *m_core;
        SolutionVector_impl *m_solutionVectorPort;
        Geometry_impl *m_geometryPort;
	AssembleParms_impl *m_assembleParmsPort;


	SolutionVector *m_sv_save;
	Geometry *m_geom_save;

        pthread_mutex_t m_lock;
        pthread_cond_t m_cv;
        pthread_attr_t m_threadAttr;

        bool m_computing;
	bool m_stopped;
};



#endif
