#include "AssembleComponentHome.h"
#include "../../../../framework/idl/geometry/ProvidesGeometrySkel.h"
#include "../../../../framework/idl/solutionVector/ProvidesSolutionVectorSkel.h"
#include "../../../../framework/idl/runItAgain/UsesRunItAgainSkel.h"
#include "../../../../framework/idl/runItAgain/ProvidesRunItAgainSkel.h"
#include "../../../../framework/idl/assembleParms/ProvidesAssembleParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool AssembleComponentHome::initFlag = false;

AssembleComponent* AssembleComponentHome::instantiate() {
  init();
  return new AssembleComponent();
}

void AssembleComponentHome::init() {

  cout << "AssembleComponentHome::init()\n" << flush;

  ProvidesSolutionVectorSkel::registerSelf();
  ProvidesGeometrySkel::registerSelf();
  UsesRunItAgainSkel::registerSelf();
  ProvidesRunItAgainSkel::registerSelf();
  ProvidesAssembleParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "AssembleComponentHome: registering Assemble component\n" << flush;
    initFlag = true;
    myString compName("MyAssembleComponent");
    AssembleComponent *dummyComp = 0;
    AssembleComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
