#include "Geometry_impl.h"
#include "AssembleComponent.h"

Geometry_impl::Geometry_impl(AssembleComponent *c)
 : m_component(c) {}

Geometry_impl::~Geometry_impl() {}

int
Geometry_impl::sendGeometry(Geometry *g) {
const char *xfn = "Geometry_impl::sendGeometry";
    
    cout << xfn << " called." << endl << flush;

    pthread_mutex_lock(&m_component->m_lock);

    while (m_component->m_computing  || m_component->m_geom_save != NULL) {
		assert(m_component->m_geom_save == NULL
		 || m_component->m_sv_save == NULL);
        pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
    }
    assert(!m_component->m_computing);
	assert(m_component->m_geom_save == NULL);

	if (m_component->m_sv_save != NULL) {

		m_component->m_computing = true;
		m_component->startComputation(m_component->m_sv_save, g);
		m_component->m_sv_save = NULL;

	} else {

		m_component->m_geom_save = g;
	}

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}
