#include "SolutionVector_impl.h"
#include "AssembleComponent.h"

SolutionVector_impl::SolutionVector_impl(AssembleComponent *c)
 : m_component(c) {}

SolutionVector_impl::~SolutionVector_impl() {}

void
SolutionVector_impl::sendSolutionVector(SolutionVector *sv) {
const char *xfn = "SolutionVector_impl::sendSolutionVector";
    
    cout << xfn << " called." << endl << flush;

    pthread_mutex_lock(&m_component->m_lock);

    while (m_component->m_computing || m_component->m_sv_save != NULL) {
		// Call me if this asserts.  -kec
		assert(m_component->m_geom_save == NULL
		 || m_component->m_sv_save == NULL);                                    
        pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
    }
    assert(!m_component->m_computing);
	assert(m_component->m_sv_save == NULL);

    if (m_component->m_geom_save != NULL) {

        m_component->m_computing = true;
        m_component->startComputation(sv, m_component->m_geom_save);
        m_component->m_geom_save = NULL;

    } else {

        m_component->m_sv_save = sv;
    }

    pthread_mutex_unlock(&m_component->m_lock);

    cout << xfn << " returned." << endl << flush;

    // return 0;
}
