#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <Geometry.h>

#ifdef REMOVE_
#define getgeometry_ getgeometry
#endif

// ------------------
// Fortran functions:
// ------------------
extern "C" {
  void getgeometry_(int* job, int *M, int *N, 
	double* x, double* y, 
	double* top, 
	double* bottom, 
	double* left, 
	double* right);

};

Geometry* getGeometry() {
	int job 	= 0;
	int M = 0; int N = 0;
	double *x 	= NULL;
	double *y 	= NULL;
	double *top 	= NULL;
	double *bottom 	= NULL;
	double *left 	= NULL;
	double *right 	= NULL;
	Geometry* geom 	= new Geometry();
	
        getgeometry_(&job, &M, &N, 
	         x,  y, top, bottom, left, right);

	// cout << "M = "<< M<< " and N = " << N 
        //      << " in getGeometry" << endl;
	x = new double[M+1];
	y = new double[N+1];
	top = new double[M+1];
	bottom = new double[M+1];
	left = new double[N-1];
	right = new double[N-1];
	if (x == NULL || y == NULL ||
	    top  == NULL || bottom == NULL ||
	    left == NULL || right == NULL ) {
          cout << "Outta memory in getGeometry\n";
          return NULL;
	}
	
	job = 1;
        getgeometry_(&job, &M, &N, 
	         x,  y, top, bottom, left, right);
	// cout << "M = "<< M<< " and N = " << N 
        //      << " in getGeometry" << endl;

	geom->M = M;
	geom->N = N;
	geom->size = (M+1)*(N+1);
	geom->x = x;
	geom->y = y;
	geom->left = left;
	geom->right = right;
	geom->top = top;
	geom->bottom = bottom;
	return geom;
}
