/*  
//
//  Test driver for Assembler.  Algorithm is:
//  
//  k = 0;
//  while (keep_going(k))
//	GetGeometry // From a port
//	GetSolution; // From a file.
//	Assemble it into an array
//	k = k + 1;
//      Send array to Matlab for visualization
//  end while
//
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Fri Nov 12 14:04:19 EST 1999
//  ---------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <mmio.h>
#include <KeepOnTruckin.h>
#include <Assembler.h>
#include <getGeometry.h>
#include <getSolution.h>

int main(int argc, char *argv[]) {

  int ErrorCode;
  int k = 0;  // Number of times through

  while (KeepOnTruckin(k)) {

      // ----------------------------------------
      // Replace the following with a port access.
      // -----------------------------------------
      Geometry *geom = getGeometry();

      int size = (geom->M-1)*(geom->N-1);
	// cout << "In main, size = " << size << endl;
	// cout << "In main, M = " << geom->M << endl;
	// cout << "In main, N = " << geom->N << endl;

      double *sol    = getSolution(size);

      // cout << "Calling assembler\n";
      double* Z = Assembler(geom, sol);
      if (Z == NULL){
	cout << "Assembler failed to get storage\n";
	return -1;
	}

	// At this point need to send to Matlab.

	  // Done in destructor.
      // FreeGeometryStorage(geom);
      k++;

  }

  return 0;
}
