#ifndef BASICINFO_H
#define BASICINFO_H

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <math.h>
#include "gd.h"
#include <iomanip.h>
#include <ctype.h>
#include <SparseLinearSystem.h>
#include <BasicInfoParms.h>
#include <minmax.h>

#ifdef REMOVE_
#define getinfo_      getinfo
#endif

char  CharBuffer[100];

extern "C" {
   void getinfo_(int* m,  // Beware: this may actually require m=n,
                 int* n,  // i.e., only for square matrices.
                 int* iout,

                 double* a,
                 int* ja,
                 int* ia,

                 double* ao,
                 int* jao,
                 int* iao,
                 double* info);
};

int BasicInfo(BasicInfoParms& parms, SparseLinearSystem* sls);
char* FormatInteger( int value, int field, int base) ;
char* FormatScientific( double value, int field, int precision) ;
int CreateGif (double* values,
	 int* colinds,
	 int* rowptrs,
	 int n, int nnz,
	 double* Info) ;
int Round(double value) ;
int CreateHtml(double* values, int* colinds,
               int* rowptrs, int n, int nnz, 
               char* title, double* Info) ;

#endif
