#ifndef CCAT_BASIC_INFO_COMPONENT_H
#define CCAT_BASIC_INFO_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"


class Services;
class SparseLinearSystem;
class SparseLinearSystem_impl;
class BasicInfoParms;
class BasicInfoParms_impl;

class BasicInfoComponent : public Component {

	friend SparseLinearSystem_impl;
	friend BasicInfoParms_impl;

	public:

		BasicInfoComponent();
		virtual ~BasicInfoComponent();
		void setServices(Services *cc);

	private:
		
		void startComputation(SparseLinearSystem *sls, BasicInfoParms *);
		void compute(SparseLinearSystem *sls, BasicInfoParms *);
		static void *compute_wrapper(void *);

	private:

		Services *m_core;
		SparseLinearSystem_impl *m_sparseLinearSystemPort;
		BasicInfoParms_impl *m_basicInfoParmsPort;

		BasicInfoParms *m_parms_cache;

		pthread_mutex_t m_lock;
		pthread_cond_t m_cv;
		pthread_attr_t m_threadAttr;

		bool m_computing;
		bool m_stopped;

		int whichone;
};



#endif
