#include "BasicInfoComponentHome.h"
#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/basicInfoParms/ProvidesBasicInfoParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool BasicInfoComponentHome::initFlag = false;

BasicInfoComponent* BasicInfoComponentHome::instantiate() {
  init();
  return new BasicInfoComponent();
}

void BasicInfoComponentHome::init() {
  cout << "BasicInfoComponentHome::init()\n" << flush;

  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesSparseLinearSystemSkel::registerSelf();
  ProvidesBasicInfoParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "BasicInfoComponentHome: registering BasicInfo component\n" << flush;
    initFlag = true;
    myString compName("MyBasicInfoComponent");
    BasicInfoComponent *dummyComp = 0;
    BasicInfoComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
