#include "BasicInfoParms_impl.h"
#include "BasicInfoComponent.h"
#include "BasicInfoParms.h"

const int BasicInfoParms_impl::maxDirectoryNameLength = 128;

BasicInfoParms_impl::BasicInfoParms_impl(BasicInfoComponent *c) : m_component(c) {
  int ec = -1;
  ec = pthread_attr_init(&m_threadAttr);
  assert(ec == 0);
  ec = pthread_attr_setdetachstate(&m_threadAttr, PTHREAD_CREATE_DETACHED);
  assert(ec == 0);
  m_directoryName = "basicinfo/";
}

BasicInfoParms_impl::~BasicInfoParms_impl() {
}

int
BasicInfoParms_impl::sendBasicInfoParms(BasicInfoParms *sp) {

  pthread_mutex_lock(&m_component->m_lock);

  assert(m_component->m_parms_cache != NULL);
  delete m_component->m_parms_cache;
  m_component->m_parms_cache = sp;

  pthread_mutex_unlock(&m_component->m_lock);

  return 0;
}


// the port has received a signal to start executing.
// set the condition variable m_stopped = false.
int
BasicInfoParms_impl::start() {

    pthread_mutex_lock(&m_component->m_lock);

    m_component->m_stopped = false;
    pthread_cond_broadcast(&m_component->m_cv);

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}

int
BasicInfoParms_impl::stop() {

  cout << "BasicInfoParms_impl::stop() has been called !! " << endl;
    pthread_mutex_lock(&m_component->m_lock);

    m_component->m_stopped = true;

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;

}

// The easiest cleanup that can be done !!
// int
// BasicInfoParms_impl::kill() {
//     cout << "BasicInfoParms_impl::kill() has been called !! " << endl;
    
//     exit(1);

//     return 0;
// }

int
BasicInfoParms_impl::kill() {
  pthread_t tid;
  cout << "BasicInfoParms_impl::kill() has been called !! " << endl;
  int afterHowManyIterations = 10;
  pthread_create(&tid, &m_threadAttr, killInANewThread, &afterHowManyIterations);
  cout << "BasicInfoParms_impl::kill() returning !! " << endl;
  return 0;
}

char*
BasicInfoParms_impl::getOutputURL() {
  cout << "BasicInfoParmsParms_impl::getOutputURL() has been called !! " << endl;
  char *buffer = new char[maxDirectoryNameLength];
  sprintf(buffer,"/%s",m_directoryName);
  return buffer;
}

// wait for a few seconds before dying. This looks like
// a hack. However, I believe this is just a good design
// practice. The user of a the CCAT composition engine needs
// to have some time to disconnect other components before this
// component dies. Note, that other components that have a 
// startpoint to this component will get error signals if they aren't
// disconnected before this component dies. 

void *BasicInfoParms_impl::killInANewThread(void *howManyIterations) {
  int secondsToSleep = *(static_cast<int *>(howManyIterations));
  // cout << "BasicInfoParms_impl::killInANewThread() after " << secondsToSleep << " seconds " << endl;
  // Need to figure out why howManyIterations is recieved as 0
  // For now the sleeping time has been fixed to 10 seconds.
  secondsToSleep = 10;
  unsigned int didntSleepFor = sleep(secondsToSleep);
  cout << "BasicInfoParms_impl::killInANewThread() done waiting , didn't sleep for " << didntSleepFor << " !! seconds " << endl;
  exit(1);
  return NULL;
}

 
