/*  
//
//  Test driver for BasicInfo.  Algorithm is:
//  
//  k = 0;
//  while (keep_going(k))
//	GetSparseSystem;
//	GetBasicInfoParms;
//	call BasicInfo()
//	k = k + 1;
//      PutSparseSystem;
//	FreeStorage;
//  end while
//
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Mon Nov  8 10:50:09 EST 1999
//  --------------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <mmio.h>
#include <SparseLinearSystem.h>
#include <GetSparseSystem.h>
#include <PutSparseSystem.h>
#include <FreeStorage.h>
#include <KeepOnTruckin.h>
#include <BasicInfo.h>
#include <BasicInfoParms.h>

int main(int argc, char *argv[]) {

  int ErrorCode = 0;
  int k = 0;  // Number of times through

  while (KeepOnTruckin(k)) {

      BasicInfoParms p = getParameters();

      SparseLinearSystem *InputSystem;


      // --------------------------------------------------
      // Replace the following with a provides port access.
      // Now it just calls readmt_(), a Fortran H/B reader.
      // --------------------------------------------------

      InputSystem = GetSparseSystem();

      // ------------------------------------------
      // Call BasicInfo to analyze this system.
      // ------------------------------------------

      ErrorCode = BasicInfo(p, InputSystem); 

      cout << "ErrorCode from BasicInfo is: " << ErrorCode << endl;

      // --------------------------------------------------
      // Now call PutSparseSystem to output to next module
      // --------------------------------------------------

      int errflag = PutSparseSystem(InputSystem);

      FreeStorage(InputSystem);

      k++;

  }

  return 0;
}
