/*
//  Various possible sparse matrix data structures for 
//  the square sparse matrix in CCAT.  Only CSR is 
//  implemented currently.  Note also that dns = dense
//  is not really a sparse matrix data structure.
//  
*/

enum ds_type
{
  NILL,		// Matrix is all zeros
  CSR,		// Compressed sparse row
  MSR,		// Modified sparse row
  COO,		// Coordinatewise 
  TCSR,		// 
  BND,		// Banded (see Lapack for this)
  DNS,		// Dense; a full two-dimensional array
  MSRLU,	// MSR, with LU factors implicitly stored
  SSORDS,	// SSOR type data structure; a diagonal
  ILU0DS	// ILU with zero levels of fill; again diagonal
};
