#include "SolutionVector.h"
#include <stdio.h>

SolutionVector::SolutionVector() {
  this->lengthOfDoubleArray = 0;
  this->solutionDoubleArray = NULL;
}

SolutionVector::SolutionVector(int n, double *a) {

  lengthOfDoubleArray = n;
  solutionDoubleArray = new double[n];
  assert(solutionDoubleArray != NULL);

  for (int i = 0; i < n; i++) {
	solutionDoubleArray[i] = a[i];
}
}

SolutionVector::SolutionVector(const SolutionVector& source) {
const char *xfn = "SolutionVector::SolutionVector";

  /*
  printf("%s: length of in solution vector is %d\n", xfn,
   source.lengthOfDoubleArray);
  */

  if (source.solutionDoubleArray != NULL) {
    this->solutionDoubleArray = new double[source.lengthOfDoubleArray];
	lengthOfDoubleArray = source.lengthOfDoubleArray;
    for (int i=0; i<source.lengthOfDoubleArray; i++) {
      (this->solutionDoubleArray)[i] = (source.solutionDoubleArray)[i];
    }
  } else {
    this->solutionDoubleArray = NULL;
    this->lengthOfDoubleArray = 0;
  }

  //printf("%s: length of solution vector is %d\n", xfn, lengthOfDoubleArray);
}

SolutionVector& SolutionVector::operator=(const SolutionVector& source) {
  if (this ==  &source)
    return const_cast<SolutionVector &>(source);
  if (solutionDoubleArray != NULL)
    delete [] solutionDoubleArray;
  if (source.solutionDoubleArray != NULL) {
    this->solutionDoubleArray = new double[source.lengthOfDoubleArray];
    for (int i=0; i<source.lengthOfDoubleArray; i++) {
      (this->solutionDoubleArray)[i] = (source.solutionDoubleArray)[i];
    }
  } else {
    this->solutionDoubleArray = NULL;
    this->lengthOfDoubleArray = 0;
  }
  return *this;
}
double* SolutionVector::getSolutionArray() const {
  return solutionDoubleArray;
}

int SolutionVector::getLength() const {
  return lengthOfDoubleArray;
}


SolutionVector::~SolutionVector() {
  if (solutionDoubleArray != NULL)
    delete [] solutionDoubleArray;
  solutionDoubleArray = NULL;
}

void hpcxx_pack(HPCxx_Buffer& buffer, SolutionVector *s, int count) {
  for(int i=0; i<count; i++) {
    int lengthOfArray = s->getLength();
printf("packing solution vector of length %d\n", count);
    hpcxx_pack(buffer, &lengthOfArray, 1);
    hpcxx_pack(buffer, s->getSolutionArray(), lengthOfArray);
	s++;
  }
}

void hpcxx_unpack(HPCxx_Buffer& buffer, SolutionVector *s, int count) {

	for(int i=0; i<count; i++) {

		int lengthOfArray;

		hpcxx_unpack(buffer, &lengthOfArray, 1);
		s->lengthOfDoubleArray = lengthOfArray;

		s->solutionDoubleArray = new double[lengthOfArray];
		assert(s->solutionDoubleArray != NULL);
printf("unpacking solution vector of length %d\n", lengthOfArray);
		hpcxx_unpack(buffer, s->solutionDoubleArray, lengthOfArray);

		s++;
	}
}
