// -*-c++-*-
#ifndef _SOLUTION_VECTOR_H__
#define _SOLUTION_VECTOR_H__

#include <hpcxx_rts.h>

class SolutionVector {
  friend void hpcxx_pack(HPCxx_Buffer& buffer, SolutionVector *s, int count);
  friend void hpcxx_unpack(HPCxx_Buffer& buffer, SolutionVector *s, int count);
public:
  SolutionVector();
  SolutionVector(int n, double *a);
  SolutionVector(const SolutionVector&);
  SolutionVector& operator=(const SolutionVector&);
  double* getSolutionArray() const;
  int getLength() const;
  void freeMemory();
  ~SolutionVector();
public:
  // need to be public so that 
  // pack and unpack can access these
  int lengthOfDoubleArray;
  double* solutionDoubleArray;
};
#endif // _SOLUTION_VECTOR_H__
