#include <iomanip.h>
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <TimeStep.h>
#include "../../../../framework/util/hpcxx_byte.h"
#include "../../../../framework/util/HPCxx_String.h"

TimeStep::TimeStep(){
  M = 10;
  N = 10;
  time = 0.0;
}

TimeStep::TimeStep(int M_, int N_, double time_)
{
  this->M = M_;
  this->N = N_;
  this->time = time_;
};

TimeStep::~TimeStep(){
};

// Return a control parameter object to driver

/*
TimeStep getParameters(){
	int M, N;
	double time;
        TimeStep* p = new TimeStep;
	getparms_(&M, &N, &time);
        p->M 	= M;
        p->N 	= N;
        p->time = time;
	return *p;
}
*/

void hpcxx_pack(HPCxx_Buffer& b, TimeStep *sp, int count) {
  for(int i=0; i<count; i++) {
    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_pack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.timeStepParms.TimeStepParms");
    hpcxx_pack(b, &FQN, 1);
    hpcxx_pack (b, &(sp[i].M), 1);
    hpcxx_pack (b, &(sp[i].N), 1);
    hpcxx_pack (b, &(sp[i].time), 1);
  }
}

void hpcxx_unpack(HPCxx_Buffer& b, TimeStep *sp, int count) {
  for(int i=0; i<count; i++) {
    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_unpack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.timeStepParms.TimeStepParms");
    hpcxx_unpack(b, &FQN, 1);
    hpcxx_unpack (b, &(sp[i].M), 1);
    hpcxx_unpack (b, &(sp[i].N), 1);
    hpcxx_unpack (b, &(sp[i].time), 1);
  }
}
