#ifndef TIME_STEP_H
#define TIME_STEP_H

// Control parameters for Discretizer

#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>

#include <hpcxx_rts.h>

#ifdef REMOVE_
#define getparms_ getparms
#endif

// ------------------
// Fortran functions:
// ------------------
/*
extern "C" {
  void getparms_( int* M, int* N, double* time);
}
*/

class TimeStep {
 public:
  int M; 	// Number of mesh points in x-direction
  int N; 	// Number of mesh points in y-direction
  double time;	// Time step value
 public:
  TimeStep();
  TimeStep(int M, int N, double time);
  ~TimeStep();

  friend void hpcxx_pack(HPCxx_Buffer& b, TimeStep *sp, int count);
  friend void hpcxx_unpack(HPCxx_Buffer& b, TimeStep *sp, int count);
};

#endif // TIME_STEP_H


