#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <strings.h>
#include <Discretizer.h>
// --------------------------------------------------
// Function that does a discretization of a PDE,
// given a single double corresponding to a simulated
// time value.  This function produces a Geometry
// object which gets sent to some visualizer, and
// a sparse linear system object which gets sent to
// some solver system.
//
// Not a lot went into this ... it's a throwaway.
//
//     Randall Bramley
//     Department of Computer Science
//     Indiana University
//     Phone: (812) 855-7790
//     email: bramley@cs.indiana.edu
//     Thu Nov 11 16:57:20 EST 1999
//
// --------------------------------------------------

double **setup(int M, int N, double time);

int Discretizer(int M, int N, double time, 
		SparseLinearSystem* sls, Geometry* geom){

	int k = 0;
	double **lhs;    // Stack up the return values
	double *boundary;  // Boundary values in single array

	lhs = setup(M, N, time);

	// -------------------------------------------------------
	// Unpack the return arguments into the SparseLinearSystem
	// -------------------------------------------------------
	sls->values  = lhs[0];

	sls->rowptrs = (int *) lhs[1];

	sls->colinds = (int *) lhs[2];

	sls->rhs     = lhs[3];

	sls->nnz     = *( (int *) lhs[4] );

	sls->n       = (M-1)*(N-1);
	for (k = 0; k < sls->n+1; k++) sls->rowptrs[k]++;
	for (k = 0; k < sls->nnz; k++) sls->colinds[k]++;

	boundary     = lhs[5];

	// -------------------------------------------------
	// Assign things that setup doesn't muck around with 
	// -------------------------------------------------
	sls->titlelen = 73;
	sls->keylen = 9;
	sls->title = new char[73];
	sls->key   = new char[9];
        strcpy(sls->title, "Regular mesh PDE from Centered Differences");
        strcpy(sls->key,   "SC99Demo");

	sls->nparts = 1;
        sls->bstarts = new int[2];
	sls->bstarts[0] = 1;
	sls->bstarts[1] = sls->n+1;

	// ------------------------
	// Pack the Geometry object
	// ------------------------
	cout << "M, N = " << M << ", " << N << endl;
	cout << "packing geom object ... \n";
	cout.flush();

	geom->bottom = &boundary[0];
	cout << "geom->bottom[0] = " << geom->bottom[0] << endl;
	cout.flush();

	geom->top    = &boundary[M+1];
	cout << "geom->top[0] = " << geom->top[0] << endl;
	cout.flush();

	geom->left   = &boundary[2*M+2];
	cout << "geom->left[0] = " << geom->left[0] << endl;
	cout.flush();

	geom->right  = &boundary[2*M+N+1];
	cout << "geom->right[0] = " << geom->right[0] << endl;
	cout.flush();

	geom->M = M;
	cout << "geom->M = " << geom->M << endl;
	cout.flush();

	geom->N = N;
	cout << "geom->N = " << geom->N << endl;
	cout.flush();

	geom->size = (M+1)*(N+1);
	cout << "geom->size = " << geom->size << endl;
	cout.flush();

	geom->x = new double[M+1];
	geom->y = new double[N+1];
	for (k = 0; k < M+1; k++) geom->x[k] = (double)k / (double)M;
	for (k = 0; k < N+1; k++) geom->y[k] = (double)k / (double)N;
	return 0;

}
