#ifndef DISCRETIZER_H
#define DISCRETIZER_H
#include <SparseLinearSystem.h>
#include <Geometry.h>
#include <BC.h>

// Function that does a discretization of a PDE,
// given a single double corresponding to a simulated
// time value.  This function produces a Geometry
// object which gets sent to some visualizer, and
// a sparse linear system object which gets sent to
// some solver system.

int Discretizer(int M, int N, double time, 
		SparseLinearSystem* sls, Geometry* geom);

#endif
