#ifndef CCAT_DISCRETIZER_COMPONENT_H
#define CCAT_DISCRETIZER_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"


class Services;
class SparseLinearSystem;
class TimeStep;
class TimeStep_impl;
class DiscretizerParms_impl;

class DiscretizerComponent : public Component {

    friend TimeStep_impl;
    friend DiscretizerParms_impl;

    public:

        DiscretizerComponent();
        virtual ~DiscretizerComponent();
        void setServices(Services *cc);

    private:
        
        void startComputation(TimeStep *ts);
        void compute(TimeStep *ts);
        static void *compute_wrapper(void *);

    private:

        Services *m_core;
        TimeStep_impl *m_timeStepPort;
	DiscretizerParms_impl *m_discretizerParmsPort;

        pthread_mutex_t m_lock;
        pthread_cond_t m_cv;
        pthread_attr_t m_threadAttr;

        bool m_computing;
        bool m_stopped;
};



#endif
