#include "DiscretizerComponentHome.h"

#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/geometry/UsesGeometrySkel.h"
#include "../../../../framework/idl/geometry/ProvidesGeometrySkel.h"
#include "../../../../framework/idl/timeStep/UsesTimeStepSkel.h"
#include "../../../../framework/idl/timeStep/ProvidesTimeStepSkel.h"
#include "../../../../framework/idl/discretizerParms/ProvidesDiscretizerParmsSkel.h"

#include "../../../../framework/creation/ComponentFactory.h"

bool DiscretizerComponentHome::initFlag = false;

DiscretizerComponent* DiscretizerComponentHome::instantiate() {
  init();
  return new DiscretizerComponent();
}

void DiscretizerComponentHome::init() {

  cout << "DiscretizerComponentHome::init()\n" << flush;

  UsesSparseLinearSystemSkel::registerSelf();
  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesGeometrySkel::registerSelf();
  ProvidesGeometrySkel::registerSelf();
  UsesTimeStepSkel::registerSelf();
  ProvidesTimeStepSkel::registerSelf();
  ProvidesDiscretizerParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "DiscretizerComponentHome: registering Discretizer component\n" << flush;
    initFlag = true;
    myString compName("MyDiscretizerComponent");
    DiscretizerComponent *dummyComp = 0;
    DiscretizerComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
