#include "TimeStep_impl.h"
#include "DiscretizerComponent.h"
#include "TimeStep.h"

TimeStep_impl::TimeStep_impl(DiscretizerComponent *c) : m_component(c) {
}

TimeStep_impl::~TimeStep_impl() {
}

int
TimeStep_impl::sendTimeStep(TimeStep *ts) {
const char *xfn = "TimeStep_impl::sendTimeStep";
    
    cout << xfn << " called" << endl << flush;

    pthread_mutex_lock(&m_component->m_lock);

    while (m_component->m_computing || m_component->m_stopped) {
        pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
    }
    assert(!m_component->m_computing);
    assert(!m_component->m_stopped);

    // If we made it past here, then must be ready to compute.
    m_component->m_computing = true;
    m_component->startComputation(ts);

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}

