/*  
//
//  Test driver for Discretizer.  Algorithm is:
//  
//  k = 0;
//  while (keep_going(k))
//	GetTimeValue  // From a port
//	GetDiscretizerParms; // From a file.
//	call Discretizer()
//	k = k + 1;
//      PutSparseSystem;
//      PutGeometry
//	FreeStorage;
//  end while
//
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Thu Nov 11 16:02:04 EST 1999
//  ---------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <mmio.h>
#include <SparseLinearSystem.h>
#include <GetSparseSystem.h>
#include <PutSparseSystem.h>
#include <PutGeometry.h>
// Done in destructors now.
//#include <FreeStorage.h>
//#include <FreeGeometryStorage.h>
#include <KeepOnTruckin.h>
#include <DiscretizerParms.h>
#include <Discretizer.h>

int main(int argc, char *argv[]) {

  int ErrorCode;
  int k = 0;  // Number of times through

  while (KeepOnTruckin(k)) {

      DiscretizerParms p = getParameters();

      SparseLinearSystem *sls = new SparseLinearSystem();
      Geometry *geom          = new Geometry();

      // ----------------------------------------
      // Replace the following with a port access.
      // -----------------------------------------

      cout << "Calling discretizer \n";
      cout.flush();

      ErrorCode = Discretizer(p.M, p.N, p.time, sls, geom);

      cout << "ErrorCode from Discretizer is: " << ErrorCode << endl;
      cout.flush();

      // --------------------------------------------------
      // Now call PutSparseSystem to output to LSA modules
      // --------------------------------------------------
      int errflag = PutSparseSystem(sls);
      cout << "errflag from PutSparseSystem is: " << errflag << endl;

      // ---------------------------------------------
      // Now call PutGeometry to output to vis modules
      // ---------------------------------------------
      errflag = PutGeometry(geom);
      cout << "errflag from PutGeometry is: " << errflag << endl;

	  // Done in destructor now.
      //FreeStorage(sls);
      //FreeGeometryStorage(geom);
      k++;

  }

  return 0;
}
