#include "GetSystemFromFileComponent.h"
#include "../../../../framework/idl/sparseLinearSystem/SparseLinearSystem_idl.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystem.h"
#include "../../../../framework/ccacore/DefaultPortInfo.h"
#include "../../../../framework/util/macros.h"
#include "GetSystemFromFileParms_impl.h"
#include "GetSparseSystem.h"



GetSystemFromFileComponent::GetSystemFromFileComponent() : m_core(NULL) {

    m_getSystemFromFileParmsPort = new GetSystemFromFileParms_impl;
}

GetSystemFromFileComponent::~GetSystemFromFileComponent() {

	DELETE(m_getSystemFromFileParmsPort);
}

void
GetSystemFromFileComponent::setServices(Services *cc) {

    if (cc == NULL) {

		DELETE(m_core);
		m_getSystemFromFileParmsPort->m_core = NULL;
        return;

    } else {

        m_core = cc;
		m_getSystemFromFileParmsPort->m_core = cc;

        m_core->addProvidesPort(m_getSystemFromFileParmsPort,
         new DefaultPortInfo("inputGetSystemFromFileParms",
		 "GetSystemFromFileParms_idl"));
        m_core->registerUsesPort(new DefaultPortInfo("outputSLS",
         "SparseLinearSystem_idl"));
    }
}

#if 0
///////////////////////////////////////
void
GetSystemFromFileComponent::waitAndExec() {
const char *xfn = "GetSystemFromFileComponent::waitAndExec";

    //extern "C" void sleep(int);
    sleep(15);

    SparseLinearSystem *sls = GetSparseSystem((char *) "xiaoge");
    assert(sls != NULL);
    UsesSparseLinearSystem *up = dynamic_cast<UsesSparseLinearSystem *>(m_core
     ->getPort((char *) "outputSLS"));
    int i = up->sendSparseLinearSystem(sls);
    cout << "GetSystemFromFile :: up->sendSparseLinearSystem " << endl;

    FreeStorage(sls);
}
#endif
