#include "GetSystemFromFileComponentHome.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/getSystemFromFileParms/ProvidesGetSystemFromFileParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool GetSystemFromFileComponentHome::initFlag = false;

GetSystemFromFileComponent* GetSystemFromFileComponentHome::instantiate() {
  init();
  return new GetSystemFromFileComponent();
}

void GetSystemFromFileComponentHome::init() {

  cout << "GetSystemFromFileComponentHome::init()\n" << flush;

  ProvidesGetSystemFromFileParmsSkel::registerSelf();
  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesSparseLinearSystemSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "GetSystemFromFileComponentHome: registering GetSystemFromFile component\n" << flush;
    initFlag = true;
    myString compName("MyGetSystemFromFileComponent");
    GetSystemFromFileComponent *dummyComp = 0;
    GetSystemFromFileComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
