#include <GetSystemFromFileParms.h>
#include <string.h>
#include <hpcxx.h>
#include "../../../../framework/util/HPCxx_String.h"

#ifdef sgi
extern "C" char *strdup(const char *);
#endif



// Control parameters for GetSparseSystem 
// Returns the name of the file from which
// to get the sparse matrix.

GetSystemFromFileParms::GetSystemFromFileParms() {
	HBFileName = strdup("matrix");
}

GetSystemFromFileParms::GetSystemFromFileParms(const char *FN) {
    assert(FN != NULL);
	HBFileName = strdup(FN);
}

GetSystemFromFileParms::GetSystemFromFileParms(
 const GetSystemFromFileParms &p) {
    assert(p.HBFileName != NULL);
    HBFileName = strdup(p.HBFileName);
}

GetSystemFromFileParms::~GetSystemFromFileParms(){
    assert(HBFileName != NULL);
    free(HBFileName);
    HBFileName = NULL;
}

// Return a control parameter object to driver
GetSystemFromFileParms getParameters(char *FN){
    GetSystemFromFileParms* p = new GetSystemFromFileParms(FN);
    return *p;
}

void
hpcxx_pack(HPCxx_Buffer& buffer, GetSystemFromFileParms* p, int count) {

    assert(count > 0);
    assert(p != NULL);
	assert(p->HBFileName != NULL);

    for(int i = 0; i < count; i++) {
        HPCxx_String name(p->HBFileName);
        hpcxx_pack(buffer, &name, 1);
        p++;
    }
}

void
hpcxx_unpack(HPCxx_Buffer& buffer, GetSystemFromFileParms* p, int count) {

    assert(p != NULL);
    assert(count > 0);

    for(int i = 0; i < count; i++) {
        HPCxx_String name;
        hpcxx_unpack(buffer, &name, 1);
		assert(p->HBFileName != NULL);
		free(p->HBFileName);
        p->HBFileName = strdup(name);
        p++;
    }
}
