#include "GetSystemFromFileParms_impl.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystem.h"
#include "../../../../framework/ccacore/Services.h"
#include "../../../../framework/util/macros.h"
#include "GetSystemFromFileParms.h"
#include "GetSparseSystem.h"
#include <signal.h>



GetSystemFromFileParms_impl::GetSystemFromFileParms_impl() : m_core(NULL) {
}

GetSystemFromFileParms_impl::~GetSystemFromFileParms_impl() {
}

int
GetSystemFromFileParms_impl::sendGetSystemFromFileParms(
 GetSystemFromFileParms *sp) {
const char *xfn = "GetSystemFromFileParms_impl::sendGetSystemFromFileParms";

	assert(m_core != NULL);

	printf("%s: reading SLS from %s.\n", xfn, sp->HBFileName);

	SparseLinearSystem *sls = GetSparseSystem(sp->HBFileName);
	assert(sls != NULL);

	UsesSparseLinearSystem *up = dynamic_cast<UsesSparseLinearSystem *>(m_core
	 ->getPort((char *) "outputSLS"));
	up->sendSparseLinearSystem(sls);
	cout << xfn << " sent system." << endl;

	DELETE(sls);
	DELETE(sp);

	return 0;
}
