#ifndef CCAT_PUT_SOLUTION_TO_FILE_COMPONENT_H
#define CCAT_PUT_SOLUTION_TO_FILE_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"



class Services;
class SolutionVector;
class SolutionVector_impl;
class PutSolutionToFileParms;
class PutSolutionToFileParms_impl;



class PutSolutionToFileComponent : public Component {

		friend SolutionVector_impl;
		friend PutSolutionToFileParms_impl;

	public:

		PutSolutionToFileComponent();
		~PutSolutionToFileComponent();
		void setServices(Services *cc);

    private:

        void startComputation(SolutionVector *sv, PutSolutionToFileParms *p);
        void compute(SolutionVector *sls, PutSolutionToFileParms *);
        static void *compute_wrapper(void *);

	private:

		Services *m_core;

        SolutionVector_impl *m_solutionVectorPort;
        PutSolutionToFileParms_impl *m_putSolutionToFileParmsPort;

        SolutionVector *m_sv_cache;
        PutSolutionToFileParms *m_parms_cache;

        pthread_mutex_t m_lock;
        pthread_cond_t m_cv;
        pthread_attr_t m_threadAttr;

        bool m_computing;
};



#endif
