#include "PutSolutionToFileParms.h"
#include <iostream.h>
#include "../../../../framework/util/macros.h"
#include "../../../../framework/util/HPCxx_String.h"
#include <hpcxx_rts.h>

#ifdef sgi
extern "C" char *strdup(const char *);
#endif


PutSolutionToFileParms::PutSolutionToFileParms() {
	fileName = strdup("solution");
}

PutSolutionToFileParms::PutSolutionToFileParms(
 const PutSolutionToFileParms &p) {
	assert(p.fileName != NULL);
	fileName = strdup(p.fileName);
}

PutSolutionToFileParms::~PutSolutionToFileParms(){

	assert(fileName != NULL);
	free(fileName);
	fileName = NULL;
}

void
hpcxx_pack(HPCxx_Buffer& buffer, PutSolutionToFileParms* p, int count){

	assert(count > 0);
	assert(p != NULL);
	assert(p->fileName != NULL);

    for(int i = 0; i < count; i++) {
		HPCxx_String name(p->fileName);
        hpcxx_pack(buffer, &name, 1);
		p++;
    }
}

void
hpcxx_unpack(HPCxx_Buffer& buffer, PutSolutionToFileParms* p, int count){

	assert(p != NULL);
	assert(count > 0);

    for(int i = 0; i < count; i++) {
		HPCxx_String name;
        hpcxx_unpack(buffer, &name, 1);
		assert(p->fileName != NULL);
		free(p->fileName);
		p->fileName = strdup(name);
		p++;
    }
}
