#include "PutSolutionToFileParms_impl.h"
#include "PutSolutionToFileComponent.h"

PutSolutionToFileParms_impl::PutSolutionToFileParms_impl(
 PutSolutionToFileComponent *c) : m_component(c) {
}

PutSolutionToFileParms_impl::~PutSolutionToFileParms_impl() {
}

int
PutSolutionToFileParms_impl::sendPutSolutionToFileParms(
 PutSolutionToFileParms *parms) {

	pthread_mutex_lock(&m_component->m_lock);

	while (m_component->m_computing || m_component->m_parms_cache != NULL) {
		pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
	}
	assert(!m_component->m_computing);
	assert(m_component->m_parms_cache == NULL);

	if (m_component->m_sv_cache) {

		m_component->m_computing = true;
		m_component->startComputation(m_component->m_sv_cache, parms);
		m_component->m_sv_cache = NULL;
		pthread_cond_broadcast(&m_component->m_cv);

	} else {

		m_component->m_parms_cache = parms; 
	}

	pthread_mutex_unlock(&m_component->m_lock);

	return 0;
}
