#include "SolutionVector_impl.h"
#include "PutSolutionToFileComponent.h"

SolutionVector_impl::SolutionVector_impl(PutSolutionToFileComponent *c)
 : m_component(c) {}

SolutionVector_impl::~SolutionVector_impl() {}

void
SolutionVector_impl::sendSolutionVector(SolutionVector *sv) {
const char *xfn = "SolutionVector_impl::sendSolutionVector";

	cout << xfn << " called" << endl;

	pthread_mutex_lock(&m_component->m_lock);

    while (m_component->m_computing || m_component->m_sv_cache != NULL) {
        pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
    }
	assert(!m_component->m_computing);
	assert(m_component->m_sv_cache == NULL);

    if (m_component->m_parms_cache) {

        m_component->m_computing = true;
        m_component->startComputation(sv, m_component->m_parms_cache);
        m_component->m_parms_cache = NULL;
		pthread_cond_broadcast(&m_component->m_cv);

    } else {

        m_component->m_sv_cache = sv;
    }

    pthread_mutex_unlock(&m_component->m_lock);

    //	return 0;
}
