#ifndef CCAT_REORDER_COMPONENT_H
#define CCAT_REORDER_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"


class Services;
class SparseLinearSystem;
class SparseLinearSystem_impl;
class ReorderParms;
class ReorderParms_impl;

class ReorderComponent : public Component {

	friend SparseLinearSystem_impl;
	friend ReorderParms_impl;

	public:

		ReorderComponent();
		virtual ~ReorderComponent();
		void setServices(Services *cc);

	private:
		
		void startComputation();
		void compute(SparseLinearSystem *sls, ReorderParms *);
		static void *compute_wrapper(void *);

	private:

		Services *m_core;
		SparseLinearSystem_impl *m_sparseLinearSystemPort;
		ReorderParms_impl *m_reorderParmsPort;

		SparseLinearSystem *m_sls_cache;
		ReorderParms *m_parms_cache;

		pthread_mutex_t m_lock;
		pthread_cond_t m_cv;
		pthread_attr_t m_threadAttr;

		bool m_computing;
};



#endif
