#include "ReorderComponentHome.h"
#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/sparseLinearSystem/UsesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/reorderParms/ProvidesReorderParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool ReorderComponentHome::initFlag = false;

ReorderComponent* ReorderComponentHome::instantiate() {
  init();
  return new ReorderComponent();
}

void ReorderComponentHome::init() {
  cout << "ReorderComponentHome::init()\n" << flush;

  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesSparseLinearSystemSkel::registerSelf();
  ProvidesReorderParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "ReorderComponentHome: registering Reorder component\n" << flush;
    initFlag = true;
    myString compName("MyReorderComponent");
    ReorderComponent *dummyComp = 0;
    ReorderComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
