#include <iomanip.h>
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ReorderParms.h>
#include <assert.h>
#include <hpcxx_rts.h>

ReorderParms::ReorderParms(){
  reorder_method = RCM;
}

ReorderParms::ReorderParms(enum Ordering reorder_method)
{
  this->reorder_method = reorder_method;
};

ReorderParms::~ReorderParms(){
};

// Return a control parameter object to driver

ReorderParms getParameters(){
	int k;
        ReorderParms* p = new ReorderParms;
	getparms_(&k);
	if (k == 0) p->reorder_method = NONE;
	if (k == 1) p->reorder_method = QMD;
	if (k == 2) p->reorder_method = RCM;
	if (k == 3) p->reorder_method = ND;
	if (k == 4) p->reorder_method = SYMQMD;
	if ((k < 0) || (k > 4))
	{
		cout << "\nUnknown reordering method!  Specify\n" << endl;
		cout << "\n   NONE for no reordering\n" << endl;
		cout << "   RCM for reverse Cuthill-Mckee\n" << endl;
		cout << "   QMD for quotient min degree\n" << endl;
		cout << "    ND for nested dissection\n" << endl;
		cout << "SYMQMD for nested dissection\n" << endl;
		cout << "Using no reordering method.\n\n" << endl;
		p->reorder_method = NONE;
	}
	return *p;
}

void
hpcxx_pack(HPCxx_Buffer& buffer, ReorderParms* p, int count){

	assert(p->reorder_method >= 0 && p->reorder_method <= 4);

	for(int i = 0; i < count; i++) {
		int t;
		t = p->reorder_method;
		hpcxx_pack(buffer, &t, 1);
		p++;
	}
}

void
hpcxx_unpack(HPCxx_Buffer& buffer, ReorderParms* p, int count){

	for(int i = 0; i < count; i++) {
		int t;
		hpcxx_unpack(buffer, &t, 1);
		// XXX This cast is not portable according to the ARM. -kec
		p->reorder_method = (Ordering) t;
		p++;
	}

	assert(p->reorder_method >= 0 && p->reorder_method <= 4);
}
