#include "ReorderParms_impl.h"
#include "ReorderComponent.h"

ReorderParms_impl::ReorderParms_impl(ReorderComponent *c) : m_component(c) {
}

ReorderParms_impl::~ReorderParms_impl() {
}

int
ReorderParms_impl::sendReorderParms(ReorderParms *sp) {

	pthread_mutex_lock(&m_component->m_lock);

	while (m_component->m_computing) {
		pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
	}

	if (m_component->m_sls_cache) {

		m_component->m_computing = true;
		m_component->startComputation();
		m_component->m_sls_cache = NULL;
		m_component->m_parms_cache = NULL;

	} else {

		m_component->m_parms_cache = sp; 
	}

	pthread_mutex_unlock(&m_component->m_lock);

	return 0;
}
