#include "SparseLinearSystem_impl.h"
#include "ReorderComponent.h"

SparseLinearSystem_impl::SparseLinearSystem_impl(ReorderComponent *c)
 : m_component(c) {}

SparseLinearSystem_impl::~SparseLinearSystem_impl() {}

int
SparseLinearSystem_impl::sendSparseLinearSystem(SparseLinearSystem *sls) {
const char *xfn = "SparseLinearSystem_impl::sendSparseLinearSystem";

    cout << "SparseLinearSystem:: sendSparseLinearSystem() n  " << sls->n << endl;
    cout << "SparseLinearSystem:: sendSparseLinearSystem() nnz  " << sls->nnz << endl;
    cout.flush();
    cout << "SparseLinearSystem:: sendSparseLinearSystem() colinds  " << sls->colinds << endl;
    cout.flush();
    cout << "SparseLinearSystem:: sendSparseLinearSystem() rowptrs  " << sls->rowptrs << endl;
    cout.flush();
    cout << "SparseLinearSystem:: sendSparseLinearSystem() values  " << sls->values << endl;
    cout.flush();
    cout << "SparseLinearSystem:: sendSparseLinearSystem() rhs  " << sls->rhs << endl;
    cout.flush();
    cout << "SparseLinearSystem:: sendSparseLinearSystem() bstarts" << sls->bstarts << endl << flush;

    
	cout << xfn << " called" << endl;
	cout.flush();

	pthread_mutex_lock(&m_component->m_lock);

    while (m_component->m_computing) {
        pthread_cond_wait(&m_component->m_cv, &m_component->m_lock);
    }
	assert(!m_component->m_computing);

    if (m_component->m_parms_cache) {

		m_component->m_sls_cache = sls;

        m_component->m_computing = true;

        m_component->startComputation();

        m_component->m_sls_cache = NULL;
        m_component->m_parms_cache = NULL;

    } else {

        m_component->m_sls_cache = sls;
    }

    pthread_mutex_unlock(&m_component->m_lock);

	return 0;
}
