#ifndef FORTS_H
#define FORTS_H

#ifdef REMOVE_
#define setb_ setb
#define readmt_ readmt
#define prtmt_ prtmt
#define readmt_ readmt
#define dvperm_ dvperm
#define ivperm_ ivperm
#define gennd_ gennd
#define genqmd_ genqmd
#define genrcm_ genrcm
#define invertp_ invertp
#define rowinc_ rowinc
#define dperm_ dperm
#define apmbt_ apmbt
#define getparms_ getparms
#endif

/*
// ------------------
// Fortran functions:
// ------------------
*/
#ifdef __cplusplus
extern "C" {
#endif
void prtmt_(int *nrow,
	    int *ncol,
	    double *A,
	    int *colinds,
	    int *rowptrs,
	    double *b,
	    char guesol[4],
	    char title[80],
	    char key[16],
	    char type[8],
	    int *ifmt,
	    int *job,
	    int *iounit);

  void dvperm_(int* n, double* x, int* perm);
  void ivperm_(int* n, int* ix, int* perm);
  void readmt_(int *nmax, int *nzmax, int *job, int *iounit,
               double *a, int *colinds, int *rowptrs, double *b,
               int *nrhs, char guesol[4], int *nrow, int *ncol,
               int *nnz, char title[80], char key[16], char type[8],
               int *ierr);
  void setb_(int* n, double* b);

  void gennd_( int* neqns, int* xadj, int* adjncy, 
               int* mask, 
               int* perm, 
               int* xls, 
               int* ls );
  void  genqmd_(int* neqns, 
               int* xadj, 
               int* adjncy, 
               int* perm, 
               int* invp, 
               int* deg,
               int* marker, 
               int* rchset, 
               int* nbrhd, 
               int* qsize, 
               int* qlink, 
               int* nofsub );
  void  genrcm_(int* neqns, int* xadj, int* adjncy, 
                int* perm, int* mask, int* xls );
  void invertp_(int* n, int* r, int* c);
  void rowinc_(int* num, int* q, double* adata);
  void dperm_(int* nrow, double* a, int* ja, int* ia,
              double* ao, int* jao, int* iao,
              int* perm, int* qperm, int* job);

  void apmbt_(int* nrow, int* ncol, int* job,
              double* A, int* colinds, int* rowptrs,
              double* A2, int* colinds2, int* rowptrs2,
              double* C, int* jc, int* ic,
              int* nnzc, int* iw, int* ierr);

  void getparms_( int* ordering_method );

#ifdef __cplusplus
};
#endif

#endif
