/*  
//
//  Test driver for Scale.  Algorithm is:
//  
//  k = 0;
//  while (keep_going(k))
//	GetSparseSystem;
//	GetScaleParms;
//	call Scale()
//	k = k + 1;
//      PutSparseSystem;
//	FreeStorage;
//  end while
//
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Sun Nov  7 12:04:51 EST 1999
//  --------------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <mmio.h>
#include <SparseLinearSystem.h>
#include <GetSparseSystem.h>
#include <PutSparseSystem.h>
#include <KeepOnTruckin.h>
#include <ScaleParms.h>
#include <Scale.h>

int main(int argc, char *argv[]) {

  int ErrorCode;
  int k = 0;  // Number of times through

  while (KeepOnTruckin(k)) {

      ScaleParms p = getParameters();

      SparseLinearSystem *OriginalSystem;
      SparseLinearSystem *ScaledSystem;


      // --------------------------------------------------
      // Replace the following with a provides port access.
      // Now it just calls readmt_(), a Fortran H/B reader.
      // --------------------------------------------------

      OriginalSystem = GetSparseSystem();

      // ------------------------------------------
      // Call reorder to rearrange the system.
      // Note that a new sparse system is returned,
      // along with row/column permutation vectors.
      // ------------------------------------------

      ScaledSystem = Scale(&p, OriginalSystem, 
                               &ErrorCode);

      cout << "ErrorCode from Scale is: " << ErrorCode << endl;

      // --------------------------------------------------
      // Now call PutSparseSystem to output to next module
      // --------------------------------------------------

      int errflag = PutSparseSystem(ScaledSystem);

      //FreeStorage(OriginalSystem);

      k++;

  }

  return 0;
}
