/*
//  --------------------------------------------------------------------------------
//  
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Mon Nov  1 14:47:19 EST 1999
//  --------------------------------------------------------------------------------
*/

#include <PutSolutionVector.h>


int PutSolutionVector(SparseLinearSystem* sls){
  // Fake port code.  This writes out the solution
  // vector to a file, and the key thing is to note
  // the unmunging operation needed before doing so.
  // When the solution vector is drawn out from a
  // SparseLinearSystem, should always unmunge first.
  FILE *fp;
  int k;
  
  if ((fp = fopen("solution", "w")) == NULL) {
    cout << "Could not open solution file for writing" << endl;
    cout << " ... inside of PutSolutionVector " << endl;
  }

  (sls->mungings).UnMunge(sls->x);

  for (k = 0; k < sls->n; k++)
    fprintf(fp, "%e\n", (sls->x)[k]);
  fclose(fp);

  return 0;

}
