#ifndef SPLIB_H
#define SPLIB_H

#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>
#include <SparseLinearSystem.h>
#include <SplibParms.h>

#ifdef REMOVE_
#define openunits_  openunits
#define splib_      splib
#define flushunits_ flushunits
#define closeunits_ closeunits
#endif

extern "C" {
  void splib_(double* values, int* colinds, int* rowptrs, int* n,
	      double* x, double* rhs,double* work, int* space,
	      double* tolerance, int* relative, int* maxits,
	      int* preMeth, int* solveMeth, int *scale, double* Dl,
	      double* Dr, int* iparms, double* rparms, int* recomp,
	      int* errflg, int* iunit, int* output);

  void openunits_(int* iunit);
  void flushunits_(int* iunit);
  void closeunits_(int* iunit);
  void getr_(double *utime,
             double *stime,
             long counts[15]);
};

int CheckArguments(SplibParms& parms, SparseLinearSystem& sls);
int Splib(SplibParms& parms, SparseLinearSystem* sls);

#endif
