#ifndef CCAT_SPLIB_COMPONENT_H
#define CCAT_SPLIB_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"


class Services;
class SparseLinearSystem;
class SparseLinearSystem_impl;
class SplibParms;
class SplibParms_impl;

class SplibComponent : public Component {

    friend SparseLinearSystem_impl;
    friend SplibParms_impl;

    public:

        SplibComponent();
        virtual ~SplibComponent();
        void setServices(Services *cc);

    private:
        
        void startComputation(SparseLinearSystem *sls, SplibParms *);
        void compute(SparseLinearSystem *sls, SplibParms *);
        static void *compute_wrapper(void *);

    private:

        Services *m_core;
        SparseLinearSystem_impl *m_sparseLinearSystemPort;
        SplibParms_impl *m_splibParmsPort;

        SplibParms *m_parms_cache;

        pthread_mutex_t m_lock;
        pthread_cond_t m_cv;
        pthread_attr_t m_threadAttr;

        bool m_computing;
        bool m_stopped;
};



#endif
