#include "SplibComponentHome.h"
#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/solutionVector/UsesSolutionVectorSkel.h"
#include "../../../../framework/idl/solutionVector/ProvidesSolutionVectorSkel.h"
#include "../../../../framework/idl/splibParms/ProvidesSplibParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool SplibComponentHome::initFlag = false;

SplibComponent* SplibComponentHome::instantiate() {
  init();
  return new SplibComponent();
}

void SplibComponentHome::init() {

  cout << "SplibComponentHome::init()\n" << flush;

  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesSolutionVectorSkel::registerSelf();
  ProvidesSolutionVectorSkel::registerSelf();
  ProvidesSplibParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "SplibComponentHome: registering Splib component\n" << flush;
    initFlag = true;
    myString compName("MySplibComponent");
    SplibComponent *dummyComp = 0;
    SplibComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
