#include "SplibParms_impl.h"
#include "SplibComponent.h"
#include "SplibParms.h"

const int SplibParms_impl::maxDirectoryNameLength = 128;

SplibParms_impl::SplibParms_impl(SplibComponent *c) : m_component(c) {
  int ec = -1;
  ec = pthread_attr_init(&m_threadAttr);
  assert(ec == 0);
  ec = pthread_attr_setdetachstate(&m_threadAttr, PTHREAD_CREATE_DETACHED);
  assert(ec == 0);
  m_directoryName = "splib/";
}

SplibParms_impl::~SplibParms_impl() {
}

int
SplibParms_impl::sendSplibParms(SplibParms *sp) {

    pthread_mutex_lock(&m_component->m_lock);

    assert(m_component->m_parms_cache != NULL);
    delete m_component->m_parms_cache;
    m_component->m_parms_cache = sp;

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}

int
SplibParms_impl::start() {

    pthread_mutex_lock(&m_component->m_lock);

    m_component->m_stopped = false;
    pthread_cond_broadcast(&m_component->m_cv);

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}

int
SplibParms_impl::stop() {

    pthread_mutex_lock(&m_component->m_lock);

    m_component->m_stopped = true;

    pthread_mutex_unlock(&m_component->m_lock);

    return 0;
}

//  int
//  SplibParms_impl::kill() {
    
//      exit(1);

//      return 0;
//  }

int
SplibParms_impl::kill() {
  pthread_t tid;
  cout << "SplibParmsParms_impl::kill() has been called !! " << endl;
  int afterHowManyIterations = 10;
  pthread_create(&tid, &m_threadAttr, killInANewThread, &afterHowManyIterations);
  cout << "SplibParmsParms_impl::kill() returning !! " << endl;
  return 0;
}

char*
SplibParms_impl::getOutputURL() {
  cout << "SplibParmsParms_impl::getOutputURL() has been called !! " << endl;
  char *buffer = new char[maxDirectoryNameLength];
  sprintf(buffer,"/%s",m_directoryName);
  return buffer;
}

// wait for a few seconds before dying. This looks like
// a hack. However, I believe this is just a good design
// practice. The user of a the CCAT composition engine needs
// to have some time to disconnect other components before this
// component dies. Note, that other components that have a 
// startpoint to this component will get error signals if they aren't
// disconnected before this component dies. 

void *SplibParms_impl::killInANewThread(void *howManyIterations) {
  int secondsToSleep = *(static_cast<int *>(howManyIterations));
  // cout << "SplibParmsParms_impl::killInANewThread() after " << secondsToSleep << " seconds " << endl;
  // Need to figure out why howManyIterations is recieved as 0.
  // For now the sleeping time has been fixed to 10 seconds.
  secondsToSleep = 10;
  unsigned int didntSleepFor = sleep(secondsToSleep);
  cout << "SplibParmsParms_impl::killInANewThread() done waiting , didn't sleep for " << didntSleepFor << " seconds !! " << endl;
  exit(1);
  return NULL;
}


