	subroutine sparser (n, A, c_ind , r_point,   omega,
     1                   ilu   ,ilup  ,  iwork , size_work ,
     2                   ierr  , mneed )

c**********************************************************************
c                   SPLIB Copyright (C) 1995-1999                    **
c                     Indiana University                             **
c**********************************************************************

	implicit none
c-----------------------------------------------------------------------
c	n, A, c_ind, r_point: matrix A in CSR format.
c	Omega: parameter of dropping for sparser pattern.
c	ilu, ilup: pointers to the begining of the arrary for the
c		structure of ECIMGS pattern in MSR format.
c	iwork, size_work: working space array with size of size_work.
c	ierr: error code
c		=0 no error is detected
c		=1 short of space
c	mneed: if ierr = 0, it rturns the size of working space for ECIMGS
c		pattern. if ierr = 1, it returns the number of additional
c		space needed for the success pattern generation.
c-----------------------------------------------------------------------
	integer n, c_ind(*), r_point(*), iwork(*)
	integer ilu, ilup, size_work, ierr, mneed
	real*8 A(*), omega, rmax
	integer i, j, k, lp

c
c  Compute the sparsity pattern
c	
	if (size_work .lt. r_point(n+1)-1+n) then
	    ierr = 1
	    mneed= r_point(n+1)-1+n-size_work
	    goto 1000
	endif
	ilup = 1
	ilu = n+1
	iwork(ilu) = n+2
	lp = n+2
	do i = 1, n
c	    find the maximum in the row
	    rmax = 0.0d0
	    do k = r_point(i), r_point(i+1)-1
		rmax = max(abs(A(k)), rmax)
	    enddo
c	    drop off small elements for sparser pattern
	    do k = r_point(i), r_point(i+1)-1
		j = c_ind(k)
		if (j.lt.i) then
		    if (abs(A(k))/rmax .lt. omega) then
c		        dropped
		        iwork(ilu+lp-1) = j
		    else
c		        kept
		        iwork(ilu+lp-1) = -j
		    endif
		    lp = lp + 1
		elseif (j.gt.i) then
		    if ( iwork(ilup+i-1) .eq.0) iwork(ilup+i-1) = lp
                    if (abs(A(k))/rmax .lt. omega) then
c                       dropped
                        iwork(ilu+lp-1) = j
                    else
c                       kept
                        iwork(ilu+lp-1) = -j
                    endif
                    lp = lp + 1
		else
		    iwork(ilup+i-1) = lp
		endif
	    enddo
	    iwork(ilu+i) = lp
	    if (size_work .lt. n+lp) then
    		ierr = 1
		mneed = n-i
    		goto 1000
	    endif
	enddo
	mneed = lp + ilu 
1000	continue
	return
	end
