c=======================================================================
      subroutine spbmux (m, n, x, y, a, ja, ia) 
c-----------------------------------------------------------------------
c          y = A*x
c----------------------------------------------------------------------- 
c Multiplies a matrix times a vector using the dot product form.
c A is stored in compressed sparse row storage.  This version is 
c instrumented, and it calls the C routine spdot.
c
c on entry:
c----------
c m     = row dimension of A
c n     = column dimension of A
c x     = real array of length equal to the column dimension of
c         the A matrix.
c a, ja,
c    ia = input matrix in compressed sparse row format.
c
c on return:
c-----------
c y     = real array of length m, containing the product y=Ax
c
c-----------------------------------------------------------------------
     
      implicit none

c     Arguments
c     =========
      integer m, n, ja(*), ia(*)
      real*8  x(n), y(m), a(*) 
      real*8  spdot
      external spdot

c     Local variables
c     ===============
      real*8 t
      integer i, k, start

c     Instrumentation variables for timing.
c     =====================================
      include '../include/heads.inc'
      real*8 mytime, tstart
      external mytime

c=======================================================================
c      Start Executable Statements
c=======================================================================

      tstart = mytime()

      do 100 i = 1, m

c        ------------------------------------------------
c        Compute the inner product of row i with vector x
c        ------------------------------------------------
         start = ia(i)
         k = ia(i+1) - start
         y(i) = spdot(k, x, a(start), ja(start))

 100  continue
c
      times(3) = times(3) + mytime() - tstart
      return

c=============== End of spbmux ==========================================

      end
c
