#ifndef SUPERLU_H
#define SUPERLU_H
#include <SparseLinearSystem.h>
#include <SuperLUParms.h>
#include <Mungings.h>

// --------------------------------
// Check the arguments for SuperLU.
// --------------------------------
int CheckArguments(SuperLUParms& parms, SparseLinearSystem* sls);
int SuperLU(SuperLUParms& parms, SparseLinearSystem* sls);

extern "C" {
  int dsolve_(double *mpMatrixValues, 
              int    *mpColumnIndices, 
              int    *mpRowPointers, 
              int    *mNumRows,
	      int    *mNumRows1, 
              double *mpRightHandSide, 
              double *mpSolution, 
              int    *one,
	      int    *mPanelSize, 
              int    *mRelaxation, 
              double *mThreshold, 
              double *mDropTolerance,
              int    *md_r, 
              int    *md_c, 
              int    *mpEliminationTree, 
              int    *piv_r, 
              int    *piv_c, 
              void   *next, 
              int    *remain,
	      double *mRpg, 
              double *mRecipCondition, 
              double *mForwardError, 
              double *mBackwardError,
	      float  *mMemmory, 
              float  *Mem_forLU,
              int    *Mem_expansions,
              int    *mLowerNnz, 
              int    *mUpperNnz, 
              int    *mFacJob, 
              int    *keep, 
              int    *ierr);
}

  
#endif
