#include "SuperLUComponentHome.h"
#include "../../../../framework/idl/sparseLinearSystem/ProvidesSparseLinearSystemSkel.h"
#include "../../../../framework/idl/solutionVector/UsesSolutionVectorSkel.h"
#include "../../../../framework/idl/solutionVector/ProvidesSolutionVectorSkel.h"
#include "../../../../framework/idl/superLUParms/ProvidesSuperLUParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool SuperLUComponentHome::initFlag = false;

SuperLUComponent* SuperLUComponentHome::instantiate() {
  init();
  return new SuperLUComponent();
}

void SuperLUComponentHome::init() {

  cout << "SuperLUComponentHome::init()\n" << flush;

  ProvidesSparseLinearSystemSkel::registerSelf();
  UsesSolutionVectorSkel::registerSelf();
  ProvidesSolutionVectorSkel::registerSelf();
  ProvidesSuperLUParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "SuperLUComponentHome: registering SuperLU component\n" << flush;
    initFlag = true;
    myString compName("MySuperLUComponent");
    SuperLUComponent *dummyComp = 0;
    SuperLUComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
