#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <SuperLUParms.h>
#include "../../../../framework/util/hpcxx_byte.h"
#include "../../../../framework/util/HPCxx_String.h"


SuperLUParms::SuperLUParms(){
    FacJob        = 3;
    panelSize     = 8;
    relaxation    = 4;
    Markovitz  = 0.01;
    threshold  = 0.0;
}

SuperLUParms::SuperLUParms(int FacJob,
		       int panelSize,
             	       int relaxation,
             	       double Markovitz,
             	       double threshold) {
  this->FacJob     = FacJob;
  this->panelSize  = panelSize;
  this->relaxation = relaxation;
  this->Markovitz  = Markovitz;
  this->threshold  = threshold;
};

SuperLUParms::~SuperLUParms(){
};

// Return a control parameter object to driver
// This version just reads in a file.

SuperLUParms getParameters(){
        int k ;
        SuperLUParms* p = new SuperLUParms;
	getparms_(&(p->FacJob),
		  &(p->panelSize),
		  &(p->relaxation),
		  &(p->Markovitz),
		  &(p->threshold));
	return *p;
}

void hpcxx_pack(HPCxx_Buffer& b, SuperLUParms *p, int count) {
  for(int i=0; i<count; i++) {
    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_pack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.superLUParms.SuperLUParms");
    hpcxx_pack(b, &FQN, 1);

    hpcxx_pack(b, &(p->FacJob), 1);
    hpcxx_pack(b, &(p->panelSize), 1);
    hpcxx_pack(b, &(p->relaxation), 1);
    hpcxx_pack(b, &(p->Markovitz), 1);
    hpcxx_pack(b, &(p->threshold), 1);
  }
}

void hpcxx_unpack(HPCxx_Buffer& b, SuperLUParms *p, int count) {
  for(int i=0; i<count; i++) {
    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_unpack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.superLUParms.SuperLUParms");
    hpcxx_unpack(b, &FQN, 1);   

    hpcxx_unpack(b, &(p->FacJob), 1);
    hpcxx_unpack(b, &(p->panelSize), 1);
    hpcxx_unpack(b, &(p->relaxation), 1);
    hpcxx_unpack(b, &(p->Markovitz), 1);
    hpcxx_unpack(b, &(p->threshold), 1);
  }
}







