#ifndef SPLIBPARMS_H
#define SPLIBPARMS_H

// Control parameters for SuperLU

#include <iomanip.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>
#include <hpcxx_rts.h>

#ifdef REMOVE_
#define getparms_ getparms
#endif

// ------------------
// Fortran functions:
// ------------------
extern "C" {
  void getparms_(int  *FacJob, 
  		 int *panelSize,
                 int * relaxation,
                 double* Markovitz,
                 double* threshold);
};

class SuperLUParms {
 public:
     int FacJob;
     int panelSize;
     int relaxation;
     double Markovitz;
     double threshold;

 public:
  SuperLUParms();
  SuperLUParms(int FacJob,
	int panelSize,
        int relaxation,
        double Markovitz,
        double threshold);
  ~SuperLUParms();
  friend void hpcxx_pack(HPCxx_Buffer& b, SuperLUParms *slup, int count);
  friend void hpcxx_unpack(HPCxx_Buffer& b, SuperLUParms *slup, int count);
};

SuperLUParms getParameters();

#endif
