#include "TimeGenComponentHome.h"
#include "../../../../framework/idl/runItAgain/ProvidesRunItAgainSkel.h"
#include "../../../../framework/idl/timeGen/UsesTimeGenSkel.h"
#include "../../../../framework/idl/timeGenParms/ProvidesTimeGenParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool TimeGenComponentHome::initFlag = false;

TimeGenComponent* SuperLUComponentHome::instantiate() {
  init();
  return new TimeGenComponent();
}

void TimeGenComponentHome::init() {

  cout << "TimeGenComponentHome::init()\n" << flush;

  ProvidesRunItAgainSkel::registerSelf();
  UsesTimeGenSkel::registerSelf();
  ProvidesTimeGenParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "TimeGenComponentHome: registering SuperLU component\n" << flush;
    initFlag = true;
    myString compName("MyTimeGenComponent");
    TimeGenComponent *dummyComp = 0;
    TimeGenComponentHome *dummyHome = 0;
    registerComponentType(compName, *dummyComp, *dummyHome);
    delete dummyComp;
    delete dummyHome;
  }
}
