//-*-c++-*-
#ifndef CCAT_TIME_GEN_COMPONENT_H
#define CCAT_TIME_GEN_COMPONENT_H



#include <pthread.h>
#include "../../../../framework/ccacore/Component.h"

class Services;
class RunItAgain_impl;
class TimeGenParms;
class TimeGenParms_impl;

class TimeGenComponent : public Component {
  
  // TimeGen has two input ports
  // One of type runItAgain and one parms port
  friend RunItAgain_impl;
  friend TimeGenParms_impl;

public:

  TimeGenComponent();
  virtual ~TimeGenComponent();
  void setServices(Services *cc);

private:
        
  void startComputation(TimeGenParms *);
  void compute(TimeGenParms *);
  void execute(bool start);
  static void *compute_wrapper(void *);

private:

  Services *m_core;
  RunItAgain_impl *m_runItAgainPort;
  TimeGenParms_impl *m_timeGenParmsPort;

  double m_currentTime;
  double m_timeIncr;
  int m_m;
  int m_n;

  pthread_mutex_t m_lock;
  pthread_cond_t m_cv;
  //  pthread_attr_t m_threadAttr;

  bool m_computing;
  bool m_stopped;
};

#endif
