#include "TimeGenComponentHome.h"
#include "../../../../framework/idl/runItAgain/UsesRunItAgainSkel.h"
#include "../../../../framework/idl/runItAgain/ProvidesRunItAgainSkel.h"
#include "../../../../framework/idl/timeStep/UsesTimeStepSkel.h"
#include "../../../../framework/idl/timeStep/ProvidesTimeStepSkel.h"
#include "../../../../framework/idl/timeStepParms/UsesTimeStepParmsSkel.h"
#include "../../../../framework/idl/timeStepParms/ProvidesTimeStepParmsSkel.h"
#include "../../../../framework/creation/ComponentFactory.h"

bool TimeGenComponentHome::initFlag = false;

TimeGenComponent* TimeGenComponentHome::instantiate() {
  init();
  return new TimeGenComponent();
}

void TimeGenComponentHome::init() {

  cout << "TimeGenComponentHome::init()\n" << flush;

  UsesRunItAgainSkel::registerSelf();
  ProvidesRunItAgainSkel::registerSelf();
  UsesTimeStepSkel::registerSelf();
  ProvidesTimeStepSkel::registerSelf();
  UsesTimeStepParmsSkel::registerSelf();
  ProvidesTimeStepParmsSkel::registerSelf();
  
  // registering the component itself
  if (!initFlag) {
    cout << "TimeGenComponentHome: registering TimeGen component\n" << flush;
    initFlag = true;
    myString compName("MyTimeGenComponent");
    TimeGenComponent *dummyComp = 0;
    TimeGenComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
