#include "TimeGenParms.h"
#include "../../../../framework/util/hpcxx_byte.h"
#include "../../../../framework/util/HPCxx_String.h"

TimeGenParms::TimeGenParms(){
  initialTime = 0;
  timeIncr =  0.1;
  m = 10;
  n = 10;
}

TimeGenParms::TimeGenParms(double initialTime_,
			   double timeIncr_,
			   int m_,
			   int n_) {
  initialTime = initialTime_;
  timeIncr = timeIncr_;
  m = m_;
  n = n_;
}

TimeGenParms::~TimeGenParms(){
}


void hpcxx_pack(HPCxx_Buffer& b, TimeGenParms *p, int count) {
  for(int i=0; i<count; i++) {

    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_pack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.timeGenParms.TimeGenParms");
    hpcxx_pack(b, &FQN, 1);

    hpcxx_pack(b, &(p->initialTime), 1);
    hpcxx_pack(b, &(p->timeIncr), 1);
    hpcxx_pack(b, &(p->m), 1);
    hpcxx_pack(b, &(p->n), 1);
  }
}

void hpcxx_unpack(HPCxx_Buffer& b, TimeGenParms *p, int count) {
  for(int i=0; i<count; i++) {
    //NexusRMI packs byte 20 to indicate that it is an object
    hpcxx_byte k20(20);
    hpcxx_unpack(b, &k20,1);
    //NexusRMI packs the fully qualified class name of the object
    HPCxx_String FQN("idl.timeGenParms.TimeGenParms");
    hpcxx_unpack(b, &FQN, 1);   


    hpcxx_unpack(b, &(p->initialTime), 1);
    hpcxx_unpack(b, &(p->timeIncr), 1);
    hpcxx_unpack(b, &(p->m), 1);
    hpcxx_unpack(b, &(p->n), 1);
  }
}








