/*  
//
//  Test driver that mimics what all the LSA components in 
//  CCAT will do.  Where k is the count of number of systems
//  processed, that is:
//  
//  k = 0;
//  while (keep_going(k))
//	GetSparseSystem;
//	GetParameters;
//	solve/filter/whatever (do the work);
//	k = k + 1;
//	PutSparseSystem;
//	FreeStorage;
//  end while
//
//
//  Randall Bramley
//  Department of Computer Science
//  Indiana University, Bloomington
//  bramley@cs.indiana.edu                             
//  Wed Oct 27 14:30:56 EST 1999
//  --------------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <assert.h>
#include <mmio.h>
#include <SparseLinearSystem.h>
#include <GetSparseSystem.h>
#include <PutSparseSystem.h>
#include <FreeStorage.h>
#include <KeepOnTruckin.h>
#include <Parameters.h>

int main(int argc, char *argv[]) {

  int k = 0;  // Number of times through

  while (KeepOnTruckin(k)) {

  Parameters p = getParameters();

  SparseLinearSystem *sls;

  // --------------------------------------------------
  // Replace the following with a provides port access.
  // Now it just calls readmt_(), a Fortran H/B reader.
  // --------------------------------------------------

  sls = GetSparseSystem();

  // -------------------------------------------------------
  // Now call PutSparseSystem to write out the matrix again.
  // -------------------------------------------------------

  int errflag = PutSparseSystem(sls);

  FreeStorage(sls);

  k++;

  }

  return 0;
}
