SHELL = /bin/sh
#
#  Machine dependent flags for compilation.  This gets included into
#  the other makefiles.  
#  
#  The makefiles test for the presence of the Unix utility ranlib
#  in /usr/bin/ranlib.  If ranlib exists but it is not
#  present in that customary place, the makefiles should be edited to
#  show the correct location.
#  
#  The makefiles test for the presence of the machines native BLAS routines
#  in /usr/lib/libblas.a; if they are not present the Fortran version of
#  the BLAS routines in subdirectory splib/blas will be compiled instead.
#  If the BLAS libraries are present but in a different location, edit the
#  makefiles for that location.  This will not cause an error, but using
#  native BLAS libraries generally gives much faster code.
#
#**********************************************************************
#                   CCAT Copyright (C) 1999                    		 **
#                     Indiana University                             **
#**********************************************************************
#
#

#########################################################################
#    Definitions for Linux compilation									#
#########################################################################

# FC=g77
# CC=g++
# CFLAGS= -O
# FFLAGS= -O
# MAKE= make
# RANLIB = /usr/bin/ranlib
# LINKER = g++
# FLIBS = g2c
# BLAS = -lblas   # Install RPMs for blas, LAPACK if you can.

#########################################################################
#    Definitions for SGI Irix 6.5 compilation:					#
#########################################################################

FC=f77
CC=CC
CFLAGS= -O -64 -mips4
FFLAGS= -O -64 -mips4
LINKFLAGS= -O -64 -mips4
LIBS = -lftn -lm -lblas
MAKE= pmake -J 4
RANLIB = echo
LINKER = f77
BLAS = -lblas   
INC = -I. -I../Common

#########################################################################
#    Definitions for RS/6000 compilation:								#
#########################################################################

# FC=xlf
# CC=xlC
# CFLAGS= -O # for use on RS/6000
# FFLAGS= -O # for use on RS/6000
# MAKE= make
# RANLIB = ranlib
# LINKER = xlf
# REMOVE_ = true
# BLAS = -lblas   

#########################################################################
#    Definitions for SGI R4000 based compilation:						#
#########################################################################

# FC=f77
# CC=cc
# CFLAGS= -O -mips2 
# FFLAGS= -32 -O -mips2 -static 
# RANLIB = echo
# MAKE= pmake -J 2
# LINKER = f77
# BLAS = -lblas   

#########################################################################
#    Definitions for Sun System V compilations:	                       	#
#########################################################################

# FC=f77
# CC=gcc
# CFLAGS= -O
# FFLAGS= -O -f
# MAKE= make
# RANLIB = ranlib
# LINKER = f77
# BLAS = -lsunperf

#########################################################################
#    Definitions for Dec ULTRIX 4.4 RISC compilations:	                #
# Note: you will probably need to link  in with your driver the		    #
# libraries  -lF77 -lI77 -lU77											#
#########################################################################

# FC=f77
# CC=gcc
# CFLAGS= -O
# FFLAGS= -O -align dcommons
# MAKE= make
# RANLIB = ranlib
# LINKER = f77
# BLAS = -lblas
# REMOVE_ = true


#########################################################################
#    Definitions for OSF1 V2.1 250 alpha compilations:	                #
#########################################################################

# FC=f77
# CC=gcc
# CFLAGS= -O
# FFLAGS= -O -align dcommons
# MAKE= make
# RANLIB = ranlib
# LINKER = f77
# BLAS = -lblas

#########################################################################
#    End Variant Definitions compilation								#
#########################################################################

