#include <iostream>
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include "../../framework/creation/CreationService.h"
#include "../../framework/connection/ConnectionService.h"
#include "../../framework/ccacore/ComponentID.h"
#include "../../framework/ccacore/DefaultPortInfo.h"
#include "../../framework/ccacore/RegisterType.h"
#include "../../framework/util/macros.h"
#include "../system/event-channel/EventChannelComponentHome.h"

#include "../application/lsa/Splib/SplibComponentHome.h"

#include "../application/lsa/TimeGen/TimeGenParms.h"

//#include "../application/lsa/BasicInfo/BasicInfoComponentHome.h"
#include "../../framework/idl/timeStepParms/UsesTimeStepParmsSkel.h"
#include "../../framework/idl/timeStepParms/ProvidesTimeStepParmsSkel.h"
//#include "../../framework/idl/basicInfoParms/UsesBasicInfoParmsSkel.h"
//#include "../../framework/idl/basicInfoParms/ProvidesBasicInfoParmsSkel.h"



void TestLSA3(int s, char *hosts[]) {
const char *xfn = "TestLSA3";

    printf("%s: called, sleeping for %d, first host=%s\n", xfn, s, hosts[0]);

    EventChannelComponentHome::init();

    // Create core for this component.
    CCATServicesSkel *core = new CCATServicesSkel();
    ComponentID* myCompID = core->getComponentID();

    CreationService *creationService
     = (CreationService *)(core->getPort("CreationService"));
    assert(creationService != NULL);
    cout << xfn << " got Creation Serv. port" << endl;
  
    ConnectionService *connectionService
     = (ConnectionService *)(core->getPort("ConnectionService"));
    assert(connectionService != NULL);
    cout << xfn << " got Connection Serv. port" << endl;

    char
        execPath1[1024],
        execPath2[1024],
        execPath3[1024],
        execPath4[1024],
        execPath5[1024],
        execPath6[1024],
        execPath7[1024],
        execPath8[1024],
        execPath9[1024],
        execPath10[1024];
    char
        url1[1024],
        url2[1024],
        url3[1024],
        url4[1024],
        url5[1024],
        url6[1024],
        url7[1024],
        url8[1024],
        url9[1024],
        url10[1024];

    const char *logname = getenv("LOGNAME");
    assert(logname != NULL);

    if (strcmp(logname, "mgovinda") == 0) {
        logname = "madhu";
    }

    /*
     * Register types
     */

    UsesTimeStepParmsSkel::registerSelf();
    ProvidesTimeStepParmsSkel::registerSelf();
    /*
    UsesBasicInfoParmsSkel::registerSelf();
    ProvidesBasicInfoParmsSkel::registerSelf();
    */
    /*
     * Setup strings.
     */

    sprintf(execPath1, "/tmp/%s/timeGen", logname);
    sprintf(url1, "gram:/%s/MyTimeGen", hosts[0]);
    EnvObj e1;
    e1.put("executable", execPath1);

    sprintf(execPath2, "/tmp/%s/discretizer", logname);
    sprintf(url2, "gram:/%s/MyDiscretizerComponent", hosts[1]);
    EnvObj e2;
    e2.put("executable", execPath2);

    sprintf(execPath3, "/tmp/%s/basicInfo", logname);
    sprintf(url3, "gram:/%s/MyBasicInfoComponent", hosts[2]);
    EnvObj e3;
    e3.put("executable", execPath3);

    sprintf(execPath4, "/tmp/%s/splib", logname);
    sprintf(url4, "gram:/%s/MySplibComponent", hosts[3]);
    EnvObj e4;
    e4.put("executable", execPath4);

    sprintf(execPath5, "/tmp/%s/assemble", logname);
    sprintf(url5, "gram:/%s/MyAssembler", hosts[4]);
    EnvObj e5;
    e5.put("executable", execPath5);

    /*
     * Instantiate them.
     */

    printf("%s instantiating %s at %s\n", xfn, execPath1, url1);
    ComponentID *comp1 = creationService->createInstance(url1, &e1);
    assert(comp1 != NULL);

    printf("%s instantiating %s at %s\n", xfn, execPath2, url2);
    ComponentID *comp2 = creationService->createInstance(url2, &e2);
    assert(comp2 != NULL);

    printf("%s instantiating %s at %s\n", xfn, execPath3, url3);
    ComponentID *comp3 = creationService->createInstance(url3, &e3);
    assert(comp3 != NULL);

    printf("%s instantiating %s at %s\n", xfn, execPath4, url4);
    ComponentID *comp4 = creationService->createInstance(url4, &e4);
    assert(comp4 != NULL);

    printf("%s instantiating %s at %s\n", xfn, execPath5, url5);
    ComponentID *comp5 = creationService->createInstance(url5, &e5);
    assert(comp5 != NULL);

    /*
     * Connect.
     */

    cout << xfn << " connecting 1 to 2" << endl;
    connectionService->connect(comp1, "outputTimeStep", comp2, "inputTimeStep");

    cout << xfn << " connecting 2 to 3" << endl;
    connectionService->connect(comp2, "outputSLS", comp3, "inputSLS");

    cout << xfn << " connecting 2 to 5" << endl;
    connectionService->connect(comp2, "outputGeometry", comp5, "inputGeometry");

    cout << xfn << " connecting 3 to 4" << endl;
    connectionService->connect(comp3, "outputSLS", comp4, "inputSLS");

    cout << xfn << " connecting 4 to 5" << endl;
    connectionService->connect(comp4, "outputSV", comp5, "inputSV");

    cout << xfn << " connecting 5 to 1" << endl;
    connectionService->connect(comp5, "outputRunItAgain", comp1, "inputRunItAgain");

    /*
     * Register ports
     */

    core->registerUsesPort(new DefaultPortInfo(
     "outputTimeGenParms", "TimeStepParms_idl"));

    /*
     * Connect to parameter ports.
     */

    connectionService->connect(myCompID, "outputTimeGenParms",
     comp1, "inputTimeGenParms");

    cout << "SLEEPING ********************************" << endl;
    sleep(s);

    /*
     * Send parameters.
     */

    DDECL(UsesTimeStepParms, up,
     core->getPort("outputTimeGenParms"));

    TimeGenParms parms;

printf("sending timegen parms\n");
    up->sendTimeStepParms(&parms);
printf("return from sending time gen parms\n");

    core->releasePort("outputTimeGenParms");

#if 0

    while (1) {
    {

        DDECL(UsesGetSystemFromFileParms, up,
         core->getPort("outputGetSystemFromFileParms"));
        GetSystemFromFileParms parms("xiaoge");
printf("sending xioage\n");
        up->sendGetSystemFromFileParms(&parms);
printf("return xioage\n");
        core->releasePort("outputGetSystemFromFileParms");
    }


    {
        core->registerUsesPort(new DefaultPortInfo(
         "outputGetSystemFromFileParms", "GetSystemFromFileParms_idl"));

        DDECL(UsesGetSystemFromFileParms, up,
         core->getPort("outputGetSystemFromFileParms"));
        GetSystemFromFileParms parms("m.2500");
printf("sending m.2500\n");
        up->sendGetSystemFromFileParms(&parms);
printf("return m.2500\n");
        core->releasePort("outputGetSystemFromFileParms");
    }
    }
#endif


    HPCxx_Sync<int> justWait;
    int waitForKill = justWait;

    cout  <<"Compose:: End of test " << endl << endl;
    cout.flush();

    delete creationService;
    delete connectionService;

    hpcxx_exit();
}

//   core->registerUsesPort(new DefaultPortInfo("outputSplibParms", "SplibParms_idl"));
  
//   UsesSplibParms *output = dynamic_cast<UsesSplibParms *>(core->getPort("outputSplibParms"));
//   SplibParms splibParms;
//   int returnValue = output->sendSplibParms(&splibParms);
