#include <iostream>
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include "../../framework/creation/CreationService.h"
#include "../../framework/connection/ConnectionService.h"
#include "../../framework/ccacore/ComponentID.h"
#include "../../framework/ccacore/DefaultPortInfo.h"
#include "../../framework/ccacore/RegisterType.h"
#include "../../framework/util/macros.h"
#include "../system/event-channel/EventChannelComponentHome.h"

#include "../application/lsa/TimeGen/TimeGenParms.h"
#include "../../framework/idl/timeStepParms/UsesTimeStepParmsSkel.h"
#include "../../framework/idl/timeStepParms/ProvidesTimeStepParmsSkel.h"

void TestLSA6(int s, char *hosts[]) {
const char *xfn = "TestLSA6";

    printf("%s: called, sleeping for %d, first host=%s\n", xfn, s, hosts[0]);

    EventChannelComponentHome::init();

    // Create core for this component.
    CCATServicesSkel *core = new CCATServicesSkel();
    ComponentID* myCompID = core->getComponentID();

    // testing toMyString and create
    cout << "got my compID, trying toMyString\n" << flush;
    char *str = myCompID->toMyString();
    cout << "got string, trying create\n" << flush;
    ComponentID* dupCID = myCompID->create (str);
    cout << "create successful\n" << flush;

    CreationService *creationService
     = (CreationService *)(core->getPort("CreationService"));
    assert(creationService != NULL);
    cout << xfn << " got Creation Serv. port" << endl;
  
    ConnectionService *connectionService
     = (ConnectionService *)(core->getPort("ConnectionService"));
    assert(connectionService != NULL);
    cout << xfn << " got Connection Serv. port" << endl;

    char
        execPath1[1024],
        execPath2[1024],
        execPath3[1024],
        execPath4[1024],
        execPath5[1024],
        execPath6[1024],
        execPath7[1024],
        execPath8[1024],
        execPath9[1024],
        execPath10[1024];
    char
        url1[1024],
        url2[1024],
        url3[1024],
        url4[1024],
        url5[1024],
        url6[1024],
        url7[1024],
        url8[1024],
        url9[1024],
        url10[1024];

    const char *logname = "sdiwan";

    /*
     * Register types
     */

     UsesTimeStepParmsSkel::registerSelf();
     ProvidesTimeStepParmsSkel::registerSelf();

    /*
     * Setup strings.
     */

    sprintf(execPath1, "/tmp/%s/timeGen", logname);
    sprintf(url1, "gram:/baldy.extreme.indiana.edu/MyTimeGenComponent");
    EnvObj e1;
    e1.put("executable", execPath1);

    /*
     * Instantiate them.
     */

    printf("%s instantiating %s at %s\n", xfn, execPath1, url1);
    ComponentID *comp1 = creationService->createInstance(url1, &e1);
    assert(comp1 != NULL);
    
    /*
     * Register ports
     */
    
    core->registerUsesPort(new DefaultPortInfo(
					       "outputTimeGenParms", "TimeStepParms_idl"));
    
    
    connectionService->connect(dupCID, "outputTimeGenParms",
			       comp1, "inputTimeGenParms");
    
    /*
     * Send parameters.
     */
    
    DDECL(UsesTimeStepParms, up,
	  core->getPort("outputTimeGenParms"));
    
    TimeGenParms parms;
    
    printf("sending timegen parms\n");
    up->sendTimeStepParms(&parms);
    printf("return from sending time gen parms\n");
    
    
    cout << "calling stop \n" << flush;
    int res = up->stop();
    
    cout << " stop successful\n" << flush;
    
    
    core->releasePort("outputTimeGenParms");
    
    
    HPCxx_Sync<int> justWait;
    int waitForKill = justWait;

    cout  <<"Compose:: End of test " << endl << endl;
    cout.flush();

    delete creationService;
    delete connectionService;

    hpcxx_exit();
}
