#include "EventChannelComponentHome.h"
#include "../../../framework/idl/eventPort/UsesEventPortSkel.h"
#include "../../../framework/idl/eventPort/ProvidesEventPortSkel.h"
#include "../../../framework/idl/eventChannel/UsesFilteringEventChannelSkel.h"
#include "../../../framework/idl/eventChannel/ProvidesFilteringEventChannelSkel.h"
#include "../../../framework/creation/ComponentFactory.h"

bool EventChannelComponentHome::initFlag = false;

EventChannelComponent* EventChannelComponentHome::instantiate() {
  init();
  return new EventChannelComponent();
}

void EventChannelComponentHome::init() {
  // register ports
  UsesEventPortSkel::registerSelf();
  ProvidesEventPortSkel::registerSelf();

  UsesFilteringEventChannelSkel::registerSelf();
  ProvidesFilteringEventChannelSkel::registerSelf();
  
  // register the component itself
  if (!initFlag) {
    initFlag = true;

    myString compName("MyEventChannelComponent");
    EventChannelComponent *dummyComp = 0;
    EventChannelComponentHome *dummyHome = 0;
    registerComponentType(compName, dummyComp, dummyHome);
  }
}
