#include "EventPort_impl.h"
#include <iostream>
#include <assert.h>
#include "../../../framework/idl/eventPort/Event.h"
#include "EventQueue.h"
#include "EventQueueManager.h"






/*----------------------------------------------------------------------------\
|                                                                             |
|                                                                             |
|  EventPort_impl                                                             |
|                                                                             |
|                                                                             |
\----------------------------------------------------------------------------*/


/*------------------------------------------------------------------------------
 *
 *  Types-Constants
 */

/*------------------------------------------------------------------------------
 *
 *  Constructors-Initters-Assignment-Conversions-Destructors
 */

EventPort_impl::EventPort_impl(EventQueueManager *lsm)
 : m_eventQueueManager(lsm) {
}

EventPort_impl::~EventPort_impl() {
}

/*------------------------------------------------------------------------------
 *
 *  Access Operators-Methods
 */

/*------------------------------------------------------------------------------
 *
 *  Operators
 */

/*------------------------------------------------------------------------------
 *
 *  Methods
 */

int
EventPort_impl::notify(Event *cev) {
  std::cerr << "EventPort_impl::notify() received an event ! " << *cev << endl;
  std::cout.flush();

	Ptr<EventWrapper> ev = new EventWrapper(cev);
	std::string et(ev->type());

    assert(et.size() > 0 && et[0] != '.');
    
    std::string::size_type lp = 0, p;
    for (; (p = et.find('.', lp)) != std::string::npos; lp = p + 1) {

        std::string st = et.substr(0, p);
        //std::cerr << st << std::endl;

		// Don't need a lock here.  It's true the event queue might
		// might be removed from the manager because of no more
		// listeners, and then a new queue for that type created, but
		// so what?  -kec
		Ptr<EventQueue> eq = m_eventQueueManager->lookup(st);
		if (eq != NULL) {
			eq->send(ev);
		}
    }

    assert(lp < et.size());
    //std::cerr << et << std::endl;

	Ptr<EventQueue> ls = m_eventQueueManager->lookup(et);
	if (ls != NULL) {
		ls->send(ev);
	}

	return 0;
}

/*------------------------------------------------------------------------------
 *
 *  Static Methods and Helper Functions
 */

/*------------------------------------------------------------------------------
 *
 *  Static Data
 */
