#ifndef CCAT_LISTENING_SET_MANAGER_H
#define CCAT_LISTENING_SET_MANAGER_H



#include <string>
#include <map>
#include "Ptr.h"
#include "EventQueue.h"



// Linux 2.2 doesn't have rw locks.
#ifdef __linux__
	typedef pthread_mutex_t pthread_rwlock_t;
#endif



/*----------------------------------------------------------------------------\
|                                                                             |
|                                                                             |
|  EventQueueManager                                                          |
|                                                                             |
|                                                                             |
\----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|  Forwards                                                                   |
-----------------------------------------------------------------------------*/

class Services;

/*-----------------------------------------------------------------------------
|  Inline Helper Functions                                                    |
-----------------------------------------------------------------------------*/

class EventQueueManager {

    /*--------------------------------------------------------------------------
     *  Access Specifiers
     */

    /*--------------------------------------------------------------------------
     *  Forwards
     */

    /*--------------------------------------------------------------------------
     *  Friends
     */

    /*--------------------------------------------------------------------------
     *  Types-Constants
     */

	private:

		struct Key;
		struct LMVal;
		struct Cmp;

		friend Cmp;

		typedef std::map<std::string, Ptr<EventQueue> > TypeMap;
		typedef std::map<std::string, Ptr<Listener> > ListenerMap;

		/*
		struct Key {
			Key(const ComponentID &id_, const std::string &pn)
			 : id(id_), port_name(pn) {}
			const ComponentID id;
			const std::string port_name;
		};
		struct Cmp {
			bool operator()(const Key &k1, const Key &k2) const;
		};
		*/

    /*--------------------------------------------------------------------------
     *  Constructors-Initters-Assignment-Conversions-Destructors
     */

	public:

		EventQueueManager();
		~EventQueueManager();
    
    /*--------------------------------------------------------------------------
     *  Access Operators-Methods
     */

    /*--------------------------------------------------------------------------
     *  Operators
     */

    /*--------------------------------------------------------------------------
     *  Methods
     */

	public:
		
		Ptr<EventQueue> lookup(const std::string &type);
		std::string addListener(const std::string &comp_id,
		 const std::string &port, const std::string &type, bool *new_type);
		bool removeListener(const std::string &id, const std::string &port,
		 std::string *port_name);

    /*--------------------------------------------------------------------------
     *  Data
     */

	private:

		TypeMap m_typeMap;
		ListenerMap m_listenerMap;
		pthread_rwlock_t m_lock;

	public:

		Services *m_core;

    /*--------------------------------------------------------------------------
     *  Static Methods
     */

    /*--------------------------------------------------------------------------
     *  Static Data
     */
};




#endif
