#ifndef CCAT_FILTERING_EVENT_CHANNEL_H
#define CCAT_FILTERING_EVENT_CHANNEL_H



#include <pthread.h>
#include "../../../framework/idl/eventChannel/ProvidesFilteringEventChannel.h"



/*----------------------------------------------------------------------------\
|                                                                             |
|                                                                             |
|  FilteringEventChannel_impl                                                 |
|                                                                             |
|                                                                             |
\----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|  Forwards                                                                   |
-----------------------------------------------------------------------------*/

class ComponentID;
class EventQueueManager;
class Services;
class ConnectionService;

/*-----------------------------------------------------------------------------
|  Inline Helper Functions                                                    |
-----------------------------------------------------------------------------*/

class FilteringEventChannel_impl : public ProvidesFilteringEventChannel {


    /*--------------------------------------------------------------------------
     *  Access Specifiers
     */

    /*--------------------------------------------------------------------------
     *  Forwards
     */

    /*--------------------------------------------------------------------------
     *  Friends
     */

    /*--------------------------------------------------------------------------
     *  Types-Constants
     */

    /*--------------------------------------------------------------------------
     *  Constructors-Initters-Assignment-Conversions-Destructors
     */

	public:

		FilteringEventChannel_impl(EventQueueManager *eqm);
		~FilteringEventChannel_impl();
    
    /*--------------------------------------------------------------------------
     *  Access Operators-Methods
     */

    /*--------------------------------------------------------------------------
     *  Operators
     */

    /*--------------------------------------------------------------------------
     *  Methods
     */

	public:

		virtual int registerListener(ComponentID *listener,
		 char *listener_provides_port, char *type)
		 throw (AlreadyRegisteredException);

		virtual int registerPublisher(ComponentID *publisher,
		 char *publisher_uses_port)
		 throw (AlreadyRegisteredException);

		virtual int unregister(ComponentID *component, char *port)
		 throw (NotRegisteredException);

    /*--------------------------------------------------------------------------
     *  Data
     */

	private:

		EventQueueManager * const m_eventQueueManager;
		pthread_mutex_t m_registrationLock;

	public:
		
		Services *m_core;
		ConnectionService *m_connectionService;

    /*--------------------------------------------------------------------------
     *  Static Methods
     */

    /*--------------------------------------------------------------------------
     *  Static Data
     */
};



#endif
