#ifndef CCAT_LISTENER_H
#define CCAT_LISTENER_H



#include <string>
#include <set>
#include "Ptr.h"
#include "PtrObject.h"
#include "../../../framework/ccacore/ComponentID.h"






/*----------------------------------------------------------------------------\
|                                                                             |
|                                                                             |
|  Listener                                                                   |
|                                                                             |
|                                                                             |
\----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|  Forwards                                                                   |
-----------------------------------------------------------------------------*/

class EventQueue;

/*-----------------------------------------------------------------------------
|  Inline Helper Functions                                                    |
-----------------------------------------------------------------------------*/

class Listener : public PtrObject {

    /*--------------------------------------------------------------------------
     *  Access Specifiers
     */

    /*--------------------------------------------------------------------------
     *  Forwards
     */

    /*--------------------------------------------------------------------------
     *  Types-Constants
     */

	public:

		struct Cmp {
			bool operator()(Ptr<Listener> o1, Ptr<Listener> o2) {
				return o1->m_key < o2->m_key;
			}
		};

    /*--------------------------------------------------------------------------
     *  Friends
     */

		friend struct Cmp;

    /*--------------------------------------------------------------------------
     *  Constructors-Initters-Assignment-Conversions-Destructors
     */

	public:

		Listener(const std::string &id, const std::string &port, const std::string &type);
    
    /*--------------------------------------------------------------------------
     *  Access Operators-Methods
     */

	public:

		const std::string &id() const { return m_id; }

    /*--------------------------------------------------------------------------
     *  Operators
     */

    /*--------------------------------------------------------------------------
     *  Methods
     */

    /*--------------------------------------------------------------------------
     *  Data
     */

	private:

		std::string m_id;
		std::string m_port;
		std::string m_type;
		std::string m_key;

	public:
		
		std::set<Ptr<Listener>, Listener::Cmp>::iterator queueSetPos;
		Ptr<EventQueue> queue;

    /*--------------------------------------------------------------------------
     *  Static Methods
     */

    /*--------------------------------------------------------------------------
     *  Static Data
     */
};


#endif
