#include <pthread.h>
#include "PtrObject.h"



template <class T>
Ptr<T>::Ptr(T *o) {

	ref(o);
}

template <class T>
Ptr<T>::Ptr(const Ptr<T> &p) {

	ref(p.m_obj);
}

template <class T>
Ptr<T>::~Ptr() {

	unref();
}

template <class T>
Ptr<T> &
Ptr<T>::operator=(const Ptr<T> &p) {

	if (m_obj == p.m_obj) {
		return *this;
	}

	unref();
	ref(p.m_obj);

	return *this;
}

template <class T>
void
Ptr<T>::ref(T *o) {

	if (o == NULL) {
		m_obj = NULL;
	} else {
		// This is just to make sure that T is derived from PtrObject.
		PtrObject *b = o;
		pthread_mutex_lock(&b->m_lock);
		b->m_nRefs++;
		pthread_mutex_unlock(&b->m_lock);
		m_obj = o;
	}
}

template <class T>
void
Ptr<T>::unref() {

	if (m_obj != NULL) {

		// This is just to make sure that T is derived from SPO.
		PtrObject *b = m_obj;

		pthread_mutex_lock(&b->m_lock);

		if (--b->m_nRefs == 0) {
			pthread_mutex_unlock(&b->m_lock);
			delete m_obj;
		} else {
			pthread_mutex_unlock(&b->m_lock);
		}

		m_obj = NULL;
	}
}
