#ifndef CCAT_PTR_H
#define CCAT_PTR_H



/*----------------------------------------------------------------------------\
|                                                                             |
|                                                                             |
|  Ptr                                                                        |
|                                                                             |
|                                                                             |
\----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|  Forwards                                                                   |
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
|  Inline Helper Functions                                                    |
-----------------------------------------------------------------------------*/

template <class T>
class Ptr {

    /*--------------------------------------------------------------------------
     *  Access Specifiers
     */

    /*--------------------------------------------------------------------------
     *  Forwards
     */

    /*--------------------------------------------------------------------------
     *  Friends
     */

    /*--------------------------------------------------------------------------
     *  Types-Constants
     */

    /*--------------------------------------------------------------------------
     *  Constructors-Initters-Assignment-Conversions-Destructors
     */

	public:

		inline Ptr() : m_obj(NULL) {}
		Ptr(T *obj);
		Ptr(const Ptr<T> &);
		Ptr<T> &operator=(const Ptr<T> &);
		~Ptr();

	private:

		void ctor();
    
    /*--------------------------------------------------------------------------
     *  Access Operators-Methods
     */

    /*--------------------------------------------------------------------------
     *  Operators
     */

	public:

		T *operator->() const { return m_obj; }
		bool operator==(long nul) { return m_obj == nul; }
		bool operator==(T *p) { return m_obj == p; }
		bool operator!=(T *p) { return m_obj != p; }

    /*--------------------------------------------------------------------------
     *  Methods
     */

	private:

		void ref(T *);
		void unref();

    /*--------------------------------------------------------------------------
     *  Data
     */

	private:

		T *m_obj;

    /*--------------------------------------------------------------------------
     *  Static Methods
     */

    /*--------------------------------------------------------------------------
     *  Static Data
     */
};


#include "Ptr.cc"

#endif
