#include "PtrObject.h"
#include <pthread.h>
#include <assert.h>



PtrObject::PtrObject() : m_nRefs(0) {

    pthread_mutexattr_t attr;

    pthread_mutexattr_init(&attr);

	#if defined(DEBUG) && !defined(__linux__)
		int ec = -1;
		ec = pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_ERRORCHECK);
		assert(ec == 0);
	#endif

    pthread_mutex_init(&m_lock, &attr);

    pthread_mutexattr_destroy(&attr);

}

PtrObject::~PtrObject() {

	int ec = -1;

	assert(m_nRefs == 0);

    ec = pthread_mutex_destroy(&m_lock);
    assert(ec == 0);
}
