
// this class provides the interface
// needed for class that implements ComponentID.
// In our implementation it is a proxy
// for the services object with a restricted
// view to the composition engine. 
// The pseudo components being part of the
// framework can view the private interaface 
// (private methods) of the ComponentID. 
// They get that view as they have been
// delcared "friends" of ComponentID
// --Madhu

#include <stdlib.h>
#include "CCATServicesProxy.h"
#include "../util/MyHPCxx_GlobalPtr.h"
#include "../util/HPCxx_String.h"
#include "PortInfo.h"
#include "PortInfoArray.h"




CCATServicesProxy::CCATServicesProxy() { 
  cout << "Error: CCATServicesProxy::CCATServicesProxy default costructor called\n" 
	  << flush;
  // This should not be called.
  // It seems as if some other class requires a
  // default constructor. Am not sure of this. Will verify.
  // FIXME FIXME
}

// typically this is the constructor that will
// be called. Whenever a component developer 
// does a getComponent() on the CCATServicesSkeleton
// this constructor is called by CCATSevicesSkeleton
CCATServicesProxy::CCATServicesProxy(CCATServicesSkel *p){ 
  skp = new MyHPCxx_GlobalPtr<CCATServicesSkel>(p);
  //skp = p->skp;
  char fqn[MAX_CLASSNAME_LEN];
  fqn[0] = '\0';
  strcat (fqn, FRAMEWORK_PORT_PACKAGE);
  strcat (fqn, "CCAServices");
  skp->setFullyQualifiedFileName (fqn);
  // commenting out removed. why was it commented out???
  // becuase, I thouht that the method was buggy  !!
  ref = toMyString();
  hpcxx_register(&CCATServicesProxy::ccatEquals, CCAT_EQUALS_ID);
}


CCATServicesProxy::CCATServicesProxy(HPCxx_ContextID* contextID){ 
  skp = new MyHPCxx_GlobalPtr<CCATServicesSkel>(NULL, contextID);
  char fqn[MAX_CLASSNAME_LEN];
  fqn[0] = '\0';
  strcat (fqn, FRAMEWORK_PORT_PACKAGE);
  strcat (fqn, "CCAServices");
  skp->setFullyQualifiedFileName (fqn);
  ref = toMyString();
}

CCATServicesProxy::CCATServicesProxy(CCATServicesProxy &p){
  //skp = new MyHPCxx_GlobalPtr<CCATServicesSkel>(*(p.skp));
  skp = p.skp;
  //skp->setFullyQualifiedFileName (p.skp->getFullyQualifiedFileName());
  //ref = new char [strlen(p.ref)+1];
  //strcpy (ref, p.ref);
}

// called from  UsesFilteringChannelSkel.C
// and ProvidesFilteringEventChannelSkel.C
CCATServicesProxy::CCATServicesProxy(CCATServicesProxy *p) {
  //skp = new MyHPCxx_GlobalPtr<CCATServicesSkel>(*(p->skp));
  //skp->setFullyQualifiedFileName (p->skp->getFullyQualifiedFileName());
  //ref = new char [strlen(p->ref)+1];
  //strcpy (ref, p->ref);
  skp = p->skp;
}

CCATServicesProxy::~CCATServicesProxy() {
  //delete skp;
  //delete [] ref;
}

// FIXME FIXME
// as of now I am not sure
// if this method is even
// needed. 
int CCATServicesProxy::kill(){
//   int dummy;
//   cout << "doing proxy kill " << endl;
//   hpcxx_minvoke(skp,dummy, SERVICES_KILL_ID);
  return 0;
}

char *CCATServicesProxy::getName(){
  cout << "CCATServicesProxy getName called " << endl;
  cout.flush();
  HPCxx_String returnValue;
  hpcxx_minvoke(skp, returnValue, CCAT_GET_NAME_ID );
//   cout << "CCATServicesProxy getName call returned " << returnValue << endl;
//   cout.flush();
  return (char *)returnValue;
}

int CCATServicesProxy::setName(char *nameValue){
  cout << "CCATServicesProxy setName called with " << nameValue << endl;
  cout.flush();
  HPCxx_String tempNameValue(nameValue);
  int dummy;
  hpcxx_minvoke(skp, dummy, CCAT_SET_NAME_ID, tempNameValue);
//   cout << "CCATServicesProxy setName call returned " << endl;
//   cout.flush();
  return dummy;
}

// get the stringified reference maintained by the component.
char* CCATServicesProxy::getRef() {
  return ref;
}

// whenever the user invokes this method
// on the ComponentID, this method is called.
// The list is actually stored in the skeleton.
// So, we need to minvoke to the skeleton and
// fetch it. 
PortInfo ** CCATServicesProxy::getUsesPorts(int &length){
  PortInfoArray inar;
  hpcxx_minvoke(skp, inar, CCAT_GET_USES_PORTS_ID );
  length = inar.getLength();
  return inar.getArray();
}

// whenever the user invokes this method
// on the ComponentID, this method is called.
// The list is actually stored in the skeleton.
// So, we need to minvoke to the skeleton and
// fetch it. 
PortInfo ** CCATServicesProxy::getProvidesPorts(int &length){
  PortInfoArray inar;
  hpcxx_minvoke(skp, inar, CCAT_GET_PROVIDES_PORTS_ID);
  length = inar.getLength();
  return inar.getArray();
}

// This method was modified to account for the changes required on the Java
// side. The Java side changes were required to fix problems with the XML
// interface's inability to handle strings containing arbitrary unicode
// characters.
char* CCATServicesProxy::toMyString() const {
  int i;

  // This code is Nexus specific!!! It marshals the component ID into a
  // character buffer using Nexus startpoint marshalling routines.
  if (!skp) {
    cerr << "Error: cannot stringify an uninitialized ComponentID\n" 
	    << flush;
    return NULL;
  }
  HPCxx_ContextID *contextID = skp->getContextID();
  // Here the assumption is that the contxt id IS a nexus startpoint
  int len = nexus_sizeof_startpoint(contextID, 1) + 1; 
  unsigned char *buf = new unsigned char [len];
  
  // first put in the format that we are using to marshal th startpoint
  unsigned char format = NEXUS_DC_FORMAT_LOCAL;
  buf[0] = format;
  // now put in the startpoint
  unsigned char *temp =  buf+1;
  globus_nexus_startpoint_t sp;
  globus_nexus_startpoint_copy(&sp, contextID);
  nexus_user_put_startpoint_transfer(&temp, &sp, 1); 

  // Here, we now need to convert the byte array containing the SP into a byte
  // array that the Java side requires. E.g., if the byte array contains 12 and
  // 23, then the new byte array should contain '1' '2' ':' '2' '3'.

  // This array will contain the final version. It's 5 times as big as the input 
  // byte array, as each signed char can be converted to not more than 5
  // chars (we need to account for the ':' that separates the characters).
  char *outarray = new char [5*len]; 
  int index = 0;

  cout << "original byte array: ";
  for (i = 0; i < len; i++) {
    cout << buf[i] << " ";
  }
  cout << endl;
  
  for (i = 0; i < len; i++) {
    // convert each character into a string of ascii characters and put it in
    // the output array, followed by a ':'.
    char mystr[5];

    charToString (buf[i], mystr);
    strcat (outarray, mystr);
    index += strlen (mystr);

    if (i < (len-1))
      strcat(outarray, ":");
  }

  cout << "final byte array: " << outarray << endl;

  return outarray;
}

int CCATServicesProxy::operator==(const ComponentID& cid) {
  // if any of the ComponentID's are uninitialized, the result is an immediate
  // false
  if (!skp || !((CCATServicesProxy&)cid).skp) {
    return 0;  
  }
  return (*skp == *(((CCATServicesProxy&)cid).skp));
}

int CCATServicesProxy::equals(ComponentID* cid) {
  // 0: false 
  // 1: true
  cout << "CCAT ServicesProxy::equals called " << endl;
  int areTheyEqual = 0;
  hpcxx_minvoke(skp, areTheyEqual, CCAT_EQUALS_ID, *(dynamic_cast<CCATServicesProxy *>(cid)));
  cout << "CCAT ServicesProxy::equals returned  " << areTheyEqual << endl;
  return areTheyEqual;
}

int CCATServicesProxy::ccatEquals(CCATServicesProxy cid) {
  // 0: false 
  // 1: true
  cout << "CCAT ServicesProxy::ccatEquals called  " << endl;
  if (!skp || !cid.skp) {
    return 0;  
  }
  return (*skp == *(cid.skp));
}


ComponentID* CCATServicesProxy::create(char* stringifiedReference) {
  // first convert the stringifiedreference to an unsigned char buffer from
  // which we can unmarshal a startpoint
  int i, index = 0;
  int len = strlen (stringifiedReference);
  unsigned char* buf = new unsigned char[len];

  cout << "original stringified reference: ";
  for (i = 0; i < len; i++) {
    cout << stringifiedReference[i] << " ";
  }
  cout << endl;
  
  i = 0;
  while (i < len) {
    char mystr[10];
    int j = 0;
    while ((i != len) && (stringifiedReference[i] != ':')) {
      mystr[j++] = stringifiedReference[i];
      i++;
    }
    mystr[j] = '\0';
    if (i != len) 
      i++;

    char num = atoi (mystr);
    buf[index++] = (unsigned char)num;
  }

  cout << "final stringified reference: ";
  for (i = 0; i < index; i++) {
    cout << buf[i] << " ";
  }
  cout << endl;
  
  
  // This code is Nexus specific!!! It marshals the component ID into a
  // character buffer using Nexus startpoint marshalling routines.
  HPCxx_ContextID* contextID = new HPCxx_ContextID;
  unsigned char format = buf[0];
  unsigned char* tmpBuf = buf+1;
  nexus_user_get_startpoint(&tmpBuf, contextID, 1, (int)format);  
  CCATServicesProxy *compID = new CCATServicesProxy(contextID);
  delete buf;

  return compID;
}

HPCxx_ContextID* CCATServicesProxy::getContextID() {
  // This uses Nexus code. FIXME
  HPCxx_ContextID* myCid = new HPCxx_ContextID;
  HPCxx_ContextID* cid = skp->getContextID();
  globus_nexus_startpoint_copy (myCid, cid);
  
  return myCid;
}

// This method is called by the ConnectionServices
// The implementation of this method is in the skeleton.
// The user provides a pointer to a providesPort and
// and a string name of the uses port. Note that
// while making the remote call "minvoke" we need
// to pass by value and not by pointer.

int CCATServicesProxy::ccatConnect(const char *usesPortName, Port* providesPort) throw (ConnectionException) {
  cout << "CCATServicesProxy:: ccatConnect " << usesPortName << " with a ProvidesPort " << endl;
  cout.flush();
  int result;
  HPCxx_String tempUsesPortName((char *)usesPortName);
  hpcxx_minvoke(skp, result, CCAT_CONNECT_ID, tempUsesPortName, *providesPort);
  cout << "CCATServicesProxy:: ccatConnect " << usesPortName << " with a ProvidesPort done" << endl;
  cout.flush();
  return result;
}

// This method is called by the ConnectionServices
// The implementation of this method is in the skeleton.
// The user provides a pointer to a providesPort and
// and a string name of the uses port. Note that
// while making the remote call "minvoke" we need
// to pass by value and not by pointer.
int CCATServicesProxy::ccatDisconnect(const char *usesPortName, Port* providesPort, double timeout) throw (DisconnectionException) {
  cout << "CCATServicesProxy:: ccatDisConnect " << usesPortName << " with a ProvidesPort " << endl;
  cout.flush();
  int result;
  HPCxx_String tempUsesPortName((char *)usesPortName);
  hpcxx_minvoke(skp, result, CCAT_DISCONNECT_ID, tempUsesPortName, *providesPort);
  cout << "CCATServicesProxy:: ccatDisConnect " << usesPortName << " with a ProvidesPort done " << endl;
  cout.flush();
  return result;
}

// Invoke the corresponding method on the skeleton.  The skeleton has the list
// of providesPorts mapped to the names. What will be returned to the caller of
// this method is a proxy to the provides port. This proxy will have a
// globalPointer<PortSkel> in it, pointing to the actual implementation.
Port* CCATServicesProxy::ccatGetProvidesPort(const char *providesPortName) {
  cout << "CCATServicesProxy:: ccatGetProvidesPort " << providesPortName << endl << endl;
  cout.flush();
  Port *p = new Port();
  HPCxx_String tempProvidesPortName((char *)providesPortName);
  hpcxx_minvoke(skp, *p, CCAT_GET_PROVIDES_PORT_ID, tempProvidesPortName);
  cout << "CCATServicesProxy:: ccatGetProvidesPort " << providesPortName 
	  << " returned" << endl << endl;
  return p;
}


// This method will export another component's port (with name "portname") as my
// own port (with name "newPortname"). Currently, it can export only "provides"
// ports. FIXME (what does it mean to export a uses port anyway???)

int CCATServicesProxy::ccatExportAs(ComponentID *idSub, const char *portName, 
							 const char *newPortName) 
  throw (ExportAsException) {
  // get the provides port "portName" from idSub
  Port* provPort = (dynamic_cast<CCATServicesProxy *>(idSub))->ccatGetProvidesPort (portName);

  // get the port's type name
  // if the type is read from the global
  // pointer then more work needs to be done
  // to parse it and extrace the typeName from it.
  // idea has been shelved for now.
  // char* tname = (char *)(provPort->skp->getFullyQualifiedFileName());

  char *tname = (dynamic_cast<CCATServicesProxy *>(idSub))->ccatGetPortTypeForPortName(portName);
  if (tname[0] == '\0') {
    cout << "Error, the remote provides port's type name cannot be found\n"
	 << "Cannot export the port: " << portName << endl << flush;
    return -1;
  }
  
  // create a DefaultPortInfo object for the port type and new port name
  DefaultPortInfo info(newPortName, tname);

  // invoke a request on the remote CCAServices object to add this port with
  // this info as an exported port.
  int returnValue;
  hpcxx_minvoke(skp, returnValue, CCAT_EXPORT_AS_ID, *provPort, info);  

  return returnValue;
}

// Need to find out the portType for the portName that is provided
// in ccatExportAs()

char* CCATServicesProxy::ccatGetPortTypeForPortName(const char *portName) {
  HPCxx_String portTypeName;
  HPCxx_String portNameObject(const_cast<char *>(portName));
  hpcxx_minvoke(skp, portTypeName, CCAT_GET_PORT_TYPE_FOR_PORT_NAME_ID, portNameObject);
  return (char *)portTypeName;
}

// Provide the given "port" as a provides port for the uses port named
// "usesPortName".
int CCATServicesProxy::ccatProvideTo(const char *usesPortName, Port *port) 
  throw (ProvideToException) {
  
  int retVal;
  HPCxx_String pname (usesPortName);
  hpcxx_minvoke(skp, retVal, CCAT_PROVIDE_TO_ID, pname, *port);    
  return retVal;
}


// temporary method
// FIXME FIXME
// int CCATServicesProxy::run() {
//   int dummy;
//   hpcxx_minvoke(skp, dummy, CCAT_RUN_ID);
//   return dummy;
// }



// Needed we interoperate with java
char *CCATServicesProxy::getIfaceName (char *fqn) {
  char *temp = strrchr (fqn, '.');
  return temp + 1; 
  // FIXME should be the following statement instead, I think.
  // to make it portable code
  // temp + sizeof(char)
}

void CCATServicesProxy::charToString (unsigned char c, char* mystr) const {
  signed char mychar;
  if ((c & 0x80) != 0) {
    // it's a negative number, so the character value needs to be treated as 
    // a two's complement value. So, retrieve the actual negative number.
    mychar = 0xFF - c + 1;
    mychar = - mychar;
  }
  else
    mychar = c;
    
  int i = 0;
  if (mychar < 0) {
    mystr[i++] = '-';      
    mychar = abs(mychar);
  }
  
  mystr[i++] = '0' + mychar / 100;
  mychar %= 100;
  mystr[i++] = '0' + mychar / 10;
  mychar %= 10;
  mystr[i++] = '0' + mychar;
  mystr[i] = '\0';
}


void hpcxx_pack(HPCxx_Buffer& b, CCATServicesProxy* p, int count){
  cout << "CCATServicesProxy:: packing up a proxy\n" <<  flush;
  for(int i = 0; i < count; i++){
    hpcxx_pack(b, p->skp, 1);
  }
}
void hpcxx_unpack(HPCxx_Buffer& b, CCATServicesProxy* p, int count){
   cout << "CCATServicesProxy:: unpacking a proxy\n" <<  flush;
   cout.flush();
  for(int i = 0; i < count; i++){
    p->skp = new MyHPCxx_GlobalPtr<CCATServicesSkel> ();
    hpcxx_unpack(b, p->skp, 1);
  }
  cout << "CCATServicesProxy:: done with unpack\n" << flush;
}


