
// DefaultPortInfo.C: since PortInfo is an 
// abstract class, an implementation class 
// has been specified in the cca specs.
// This is very likely to change.
// --Madhu

#include "DefaultPortInfo.h"
#include "../util/HPCxx_String.h"
DefaultPortInfo::DefaultPortInfo(const myString portName_, const myString portType_){
  portName = portName_;
  portType = portType_;
}

DefaultPortInfo::DefaultPortInfo(const DefaultPortInfo& defaultPortInfo_) {
  portName = defaultPortInfo_.getName();
  portType = defaultPortInfo_.getType();
}

const myString DefaultPortInfo::getType() const {
  return portType;
}

const myString DefaultPortInfo::getName() const {
  return portName;
}

void DefaultPortInfo::setType(const myString type) {
  portType = type; 
}

void DefaultPortInfo::setName(const myString name) {
  portName = name;
}

DefaultPortInfo::~DefaultPortInfo() {
  // The user supplies pointer to 
  // the data members of this class
  // at the time of creation. So the 
  // user is expected to manage that memory.
  // do NOT delete anything in this destructor
 
}

void hpcxx_pack(HPCxx_Buffer& b, DefaultPortInfo* p, int count){
  for(int i = 0; i < count; i++){
    HPCxx_String hpName((char *) p[i].getName().c_str());
    hpcxx_pack(b, &hpName, 1);
    HPCxx_String hpType((char *) p[i].getType().c_str());
    hpcxx_pack(b, &hpType, 1);
  }
}
void hpcxx_unpack(HPCxx_Buffer& b, DefaultPortInfo* p, int count){
  for(int i = 0; i < count; i++){
    HPCxx_String hpName;
    hpcxx_unpack(b, &hpName, 1);
    HPCxx_String hpType;
    hpcxx_unpack(b, &hpType, 1);
    myString name((char *) hpName);
    myString type((char *) hpType);
    cout << "unpacked "  << hpName << " and " << hpType << endl;
    p->setName(name);
    p->setType(type);
  }
}

