// -*-c++-*-

// This class defines all the constants
// defined in the frameworkCore directory.
// Note that they are all defined as const.
// In C++, one should alway prefer "const"
// to #define. Or, look at it this way,
// always prefer the compiler to the 
// preprocessor. 
// --Madhu

#ifndef _FRAMEWORK_REGISTRATION_ID_H__
#define _FRAMEWORK_REGISTRATION_ID_H__

const int MAX_CLASSNAME_LEN = 100;
extern const char *FRAMEWORK_PORT_PACKAGE;


// Regisration IDs of classes
const int CCAT_SERVICES_SKEL_ID = 2000;

// Remote method invoked on user component
const int RETURN_COMPONENT_ID = 4000;

// Registration IDs of remote methods
const int GET_PROVIDES_PORTS_ID = 1910;
const int GET_USES_PORTS_ID = 1920;
const int SERVICES_KILL_ID = 1930;

//Registration IDs for remote methods
//that are CCAT framework specific
//Note that ccatGetProvidesPort
//and ccatGetProvidesPorts are two 
//different methods
// Bad methodNames ? 
// Will Fix later. FIXME FIXME 
const int CCAT_CONNECT_ID = 225;
const int CCAT_DISCONNECT_ID = 226;
const int CCAT_EXPORT_AS_ID = 227;
const int CCAT_GET_PORT_TYPE_FOR_PORT_NAME_ID = 228;
const int CCAT_GET_PROVIDES_PORT_ID = 229;
const int CCAT_PROVIDE_TO_ID = 230;
const int CCAT_EQUALS_ID = 231;
const int CCAT_GET_NAME_ID = 232;
const int CCAT_GET_PROVIDES_PORTS_ID = 233;
const int CCAT_GET_REF_ID = 234;
const int CCAT_GET_USES_PORTS_ID = 235;
const int CCAT_SET_NAME_ID = 236;
// const int CCAT_TO_MY_STRING = 237;
// get rid of this run method
 const int CCAT_RUN_ID = 237;

#endif // _FRAMEWORK_REGISTRATION_ID_H__
