// -*-c++-*-
#ifndef FRAMEWORKSERVICESSINGLETONFACTORY_H
#define FRAMEWORKSERVICESSINGLETONFACTORY_H

#include "../creation/CreationServiceImpl.h"
#include "../connection/ConnectionServiceImpl.h"
#include "CCATServicesProxy.h"
#include "Port.h"
#include "../idl/eventPort/UsesEventPortSkel.h"

class FrameworkServicesSingletonFactory {
private:
  static bool connectionsDone;
  static CreationServiceImpl* creation;
  static ConnectionServiceImpl* connection;

public:
  static CreationServiceImpl* getCreationService() {
    if (!creation)
	 creation = new CreationServiceImpl();
    return creation;
  }

  static ConnectionServiceImpl* getConnectionService() {
    if (!connection) 
	 connection = new ConnectionServiceImpl();
    return connection;
  }
  
  static void makeEventPortConnections (CCATServicesProxy* eventCompID) {
    if (!connectionsDone) {
	 connectionsDone = true;
	 
	 // create a uses port that is connected to the event channel's publish
	 // provides port and stick that into all the pseudo components. The pseudo
	 // components need to use this Uses port to publish their events to the
	 // standard event channel. So, in essence, all the pseudo components share
	 // the same "wire" for publishing their events.
	 UsesEventPortSkel *eventUser = new UsesEventPortSkel();
	 Port* eventListener = eventCompID->ccatGetProvidesPort ("notify");
	 eventUser->addProvidesPort(*eventListener);
	 
	 // get the pseudo components, and add the event uses port
	 CreationServiceImpl* cr = getCreationService();
	 ConnectionServiceImpl* co = getConnectionService();
	 cr->addEventUser(eventUser);
	 co->addEventUser(eventUser);
    }
  }
};

#endif // FRAMEWORKSERVICESSINGLETONFACTORY_H
