
// Port.C: Very important class. All proxies
// to ports are wrapped as port object and
// sent to other processes.
// --Madhu

#include <HPCxx_GlobalPtr.h>
#include <HPCxx_GlobalPtr.cc>
#include <HPCxx_GlobalRefImpl.h>
#include <HPCxx_GlobalRefImpl.cc>
#include "Port.h"
#include "../util/MyHPCxx_GlobalPtr.h"

Port::Port() {
  skp = NULL;
}

// called when a PortObjet
// needs to be made from 
// a PortProxy. Hence the 
// port object would contain
// a valid global pointer 
// in that case.
Port::Port(Port &portRef_){
  skp = portRef_.skp;
}


// called by makeGPSkel(...) when it 
// gets a local PortSkel pointer and
// it wants to make a Proxy out of it 
// and store it in a list to send to 
// other processes
Port::Port(PortSkel *portSkelPtr) {
  this->skp = new MyHPCxx_GlobalPtr<PortSkel>(portSkelPtr);
}


Port::~Port() {}

void hpcxx_pack(HPCxx_Buffer& b, Port* p, int count){
  for(int i = 0; i < count; i++){
    cout << "Port::hpcxx_pack(): Packing the global pointer " << endl;
    hpcxx_pack(b, p->skp, 1);
    cout << "Port::hpcxx_pack(): Packing the global pointer done " << endl;
  }
}
void hpcxx_unpack(HPCxx_Buffer& b, Port* p, int count){
  for(int i = 0; i < count; i++){
    cout << "Port::hpcxx_unpack(): Unpacking the global pointer " << endl;
    cout.flush();
    p->skp = new MyHPCxx_GlobalPtr<PortSkel> ();
    hpcxx_unpack(b, p->skp, 1);
    cout << "Port::hpcxx_unpack(): Unpacking the global pointer done " << endl;
    cout.flush();
  }
}
