// -*-c++-*-

// this class acts as a base class
// for the templated class PortFactoryProv.
// The idea is to avoid declaring a 
// vector<someTemplatedClass> 
// so we declare a vector<ProtFactoryProvBase>
// and make PortFactoryProv inherit from it.
// This vector is needed to maintain a collection
// of provides ports.
// --Madhu


#ifndef _PORT_FACTORY_PROV_BASE_H_
#define _PORT_FACTORY_PROV_BASE_H_

#include "STL.h"
#include "PortSkel.h"
#include "Port.h"


class PortFactoryProvBase{
public:
  myString typeName;
  PortFactoryProvBase(myString typeName_){
    typeName = typeName_;
  }
  virtual Port* makeGPofProvSkel(myString typeName_, Port *p) = 0;
  virtual PortSkel* getPortSkelProv(myString _typeName, Port* p) =0;
  myString getTypeName() {
    return typeName;
  }
};

#endif // _PORT_FACTORY_PROV_BASE_H_


