// -*-c++-*-

// this class acts as a base class
// for the templated class PortFactoryUses.
// The idea is to avoid declaring a 
// vector<someTemplatedClass> 
// so we declare a vector<ProtFactoryUsesBase>
// and make PortFactoryUses inherit from it.
// This vector is needed to maintain a collection
// of uses ports.
// --Madhu


#ifndef _PORT_FACTORY_USES_BASE_H_
#define _PORT_FACTORY_USES_BASE_H_

#include "STL.h"
#include "PortSkelUses.h"
#include "Port.h"

class PortFactoryUsesBase{
public:
  myString typeName;
  PortFactoryUsesBase(myString typeName_){
    typeName = typeName_;
  }
  virtual PortSkelUses* getPortSkelUses(myString _typeName) =0;

  myString getType() {
    return typeName;
  }
};

#endif // _PORT_FACTORY_USES_BASE_H_


