// -*-c++-*-

// PortSkelProvRecord.h: 
// stores the implementation pointer
// name and type of the provides
// port. Framework maintains once 
// such record per provides port.
// --Madhu 

#ifndef _PORT_SKEL_PROV_RECORD_H__
#define _PORT_SKEL_PROV_RECORD_H__

#include "PortSkel.h"
#include "PortInfo.h"

// portSkel is a local pointer
// This pointer will be returned
// only if the calling process is also
// local. i.e. this will never be used
// by a ComponentID. A ComponentID is 
// supposed to be a proxy that can move
// around in different address spaces. 

class PortSkelProvRecord {
  PortInfo *theInfo;
  PortSkel *skelPort;
public:
  PortSkelProvRecord(PortSkel *_skelPort, PortInfo *_theInfo){
    theInfo = _theInfo;
    skelPort = _skelPort;
  }
  PortSkelProvRecord(){
    theInfo = new DefaultPortInfo("","");
    skelPort = NULL;
  }

  PortSkelProvRecord(const PortSkelProvRecord &r){
    theInfo = r.theInfo;
    skelPort = r.skelPort;
  }

  PortInfo* getInfo() const { return theInfo; }
  PortSkel* getSkelPort() const { return skelPort; }
};

#endif // _PORT_SKEL_PROV_RECORD_H_




