
// PortSkelUses.C: all uses ports need 
// to have addProvidesPort() and removeProvidesPort()
// This class acts as a base class for uses ports.
// --Madhu
#include "PortSkelUses.h"

PortSkelUses::PortSkelUses(Port *p, bool voidsFlag_) : UsesPort(),
  refCount (0), lockMutex(), voidsFlag (voidsFlag_) {

  sync = new HPCxx_Sync<int>();
  cout << "PortSkelUses:: constructor has been called " << endl;
  initialized = true;
  cout.flush();
}

PortSkelUses::PortSkelUses(bool voidsFlag_) : UsesPort(), refCount (0),
    lockMutex(), voidsFlag (voidsFlag_) {

  sync = new HPCxx_Sync<int>();
  initialized = true;
}


void PortSkelUses::addProvidesPort(Port p) {
  if(!initialized) {
    cout << "PortSkelUses:: Error !! PortSkelUses was never initialized " << endl << endl;
  }
  // this port that is recieved
  // has to be proxy. It has a 
  // global pointer in it.
  Port *g = new Port(p);
  cout << "PortSkelUses:: addProvidesPort:: adding to the providerList " << endl;
  cout.flush();
  providerList.push_back(g);
  int x = 1;
  sync->write(x); // wakeup anybody waiting for a connection.
  cout << "PortSkelUses:: addProvidesPort done " << endl;
  cout.flush();
}

void PortSkelUses::removeProvidesPort(Port p) {
  for(vector<Port*>::iterator iter=providerList.begin();
      iter != providerList.end();iter++)
    // FIXME FIXME 
    // write an == operator for Port that compares
    // startpoint in GlobalPointers.
    if((*iter)->skp == p.skp){
      providerList.erase(iter);
    }
  if (providerList.size() == 0) {
    // there are no more connections, so need to block any new getPort calls.
    // There are race conditions all over the place. Need to be more careful
    // than this!!! What if a waitForConnection call comes while we are doing
    // the next? FIXME
    delete sync;
    sync = new HPCxx_Sync<int>();
  }
}

void PortSkelUses::unlockAndWaitForConnection() {
  unlock();
  // wait for somebody to write to the sync variable.
  int i = *sync;
  lock();
}

void hpcxx_pack(HPCxx_Buffer& b, PortSkelUses* p, int count){
}

void hpcxx_unpack(HPCxx_Buffer& b, PortSkelUses* p, int count){
}
