// -*-c++-*-

// PortSkelUses: Umbrella class for
// local uses port objects. 
// --Madhu

#ifndef _PORT_SKEL_USES_H__
#define _PORT_SKEL_USES_H__

// These methods will be  called by a derived 
// class instance. All SkelPorts of the user
// should derive from this class. The methods
// will be called from the CCATServicesSkel::ccatConnect
// and CCATServicesSkel::ccatDisconnect

#include "Port.h"
//#include "PortSkel.h"
#include "UsesPort.h"

class PortSkelUses : public UsesPort  {
protected:
  vector<Port * > providerList;
  bool initialized;
  int flag;
public:
  PortSkelUses(Port *, bool voidsFlag_ = false);
  PortSkelUses(bool voidsFlag_ = false);
  void addProvidesPort(Port p);
  // Do NOT make this method virtual
  void removeProvidesPort(Port p);

  // block until there is a connection established with this port. When you
  // are awaken, you already have a lock.
  void unlockAndWaitForConnection();

  // return true if this port has all void methods. Need to be overridden by
  // subclass if any method is non-void.
  bool hasAllVoidMethods () { return voidsFlag; }

  int getRefCount () { return refCount; }
  void incrRefCount () { refCount++; }
  void decrRefCount () { refCount--; }

  void lock() { lockMutex.lock(); }
  void unlock() { lockMutex.unlock(); }

friend void hpcxx_pack(HPCxx_Buffer& b, PortSkelUses* p, int count);
friend void hpcxx_unpack(HPCxx_Buffer& b, PortSkelUses* p, int count);

private:
  // to synchronize on waiting.
  HPCxx_Sync<int>* sync;
  // reference count for getport and releasePort.
  int refCount;
  HPCxx_Mutex lockMutex;
  bool voidsFlag;
};
#endif // _PORT_SKEL_USES_H__
