// -*-c++-*-

// portSkel is a local pointer
// This pointer will be returned
// only if the calling process is also
// local. i.e. this will never be used
// by a ComponentID. A ComponentID is 
// supposed to be a proxy that can move
// around in different address spaces. 
// --Madhu

#ifndef _PORT_SKEL_USES_RECORD_H__
#define _PORT_SKEL_USES_RECORD_H__

#include "PortSkelUses.h"
#include "PortInfo.h"


class PortSkelUsesRecord {
  PortInfo *theInfo;
  PortSkelUses *portSkelUses;
public:
  PortSkelUsesRecord(PortSkelUses *_portSkelUses, PortInfo *_theInfo){
    theInfo = _theInfo;
    portSkelUses = _portSkelUses;
  }

  PortSkelUsesRecord(){
    theInfo = new DefaultPortInfo("","");
    portSkelUses = NULL;
  }

  PortSkelUsesRecord(const PortSkelUsesRecord &r){
    theInfo = r.theInfo;
    portSkelUses = r.portSkelUses;
  }

  PortInfo* getInfo() const { return theInfo; }
  PortSkelUses* getPortSkelUses() const { return portSkelUses; }
};

#endif // _PORT_SKEL_USES_RECORD_H_
