// -*-c++-*-

// these templated functions allow the framework main() 
// or some server instantiating a user component
// to provide a mapping between typeNames (in string format)
// and actual objects that implement them
// --Madhu

#ifndef _REGISTER_TYPE_H__
#define _REGISTER_TYPE_H__

#include "CCATServicesSkel.h"
#include "STL.h"
#include "PortFactoryUses.h"
#include "PortFactoryProv.h"
#include <stdio.h>


// this method needs to be invoked 
// before the user component can do
// a registerUsesPort(string)
template< class Tskel >
void registerUsesPortType(myString idlType, Tskel theSkel){
  std::cout << "RegisterType:: registering uses port Type --> " << idlType << " " << endl << endl;
  std::cout.flush();
  printf("\n\n");
  CCATServicesSkel::usesFactoryList.push_back(new PortFactoryUses<Tskel >(idlType));
}

// this method needs to be invoked 
// before the user component can do
// a addProvidesPort(Port*, string)

template< class Tskel >
void registerProvidesPortType(myString idlType, Tskel theSkel){
  CCATServicesSkel::providesFactoryList.push_back(new PortFactoryProv< Tskel >(idlType));
}

#endif // _REGISTER_TYPE_H__


