// -*-c++-*-

// ConnectionService: part of our ccat specs
// --Madhu

#ifndef _CONNECTION_SERVICE_H__
#define _CONNECTION_SERVICE_H__

#include "../exceptions/ConnectionException.h"
#include "../exceptions/DisconnectionException.h"
#include "../exceptions/ExportAsException.h"
#include "../exceptions/ProvideToException.h"
#include "../ccacore/ComponentID.h"
#include "../ccacore/Port.h"

class ConnectionService : public Port {
private:
  // Connection Service has no state !
public:
    virtual void connect(ComponentID *idUses, const char *usesPortName, 
					ComponentID *idProv, const char *provPortName) 
	 throw (ConnectionException) = 0;
  
  virtual void disconnect(ComponentID *idUser, const char *usesPortName, 
					 ComponentID *idProv, const char *provPortName, double timeout) 
    throw (DisconnectionException) = 0;
  
  virtual void exportAs(ComponentID *idMe, ComponentID *idSub, const char *portName, 
				    const char *newPortname) throw (ExportAsException) = 0;
  
  virtual void provideTo(ComponentID *idSub, const char *usesPortName, Port *port) 
    throw (ProvideToException) = 0;
};


#endif // _CONNECTION_SERVICE_H__

