// ConnectionServiceImpl.C:
// --Madhu

#include  "ConnectionServiceImpl.h"
#include "../ccacore/ProvidesPort.h"
#include "../ccacore/UsesPort.h"

// Connection Service has no state
ConnectionServiceImpl:: ConnectionServiceImpl() {}

void ConnectionServiceImpl::connect(ComponentID *idUses, const char *usesPortName, ComponentID *idProv, const char *provPortName) throw (ConnectionException) {
  cout << "ConnectionServiceImpl: connect " << usesPortName << "with " << provPortName << endl << endl;
  cout << "ConnectionServiceImpl:: testing CompID name " << idUses->getName() << endl;
  cout.flush();
  cout << "ConnectionServiceImpl: connect :: ccatGetProvidesPort " << provPortName << "called " << endl << endl;
  Port* providesPort = (Port *)(idProv->ccatGetProvidesPort(provPortName));
  cout << "ConnectionServiceImpl: connect :: ccatGetProvidesPort " << provPortName << "returned" << endl << endl;
  cout << "ConnectionServiceImpl: connect :: ccatConnect " << "called " << endl << endl;
  int result = idUses->ccatConnect(usesPortName, providesPort);
  cout << "ConnectionServiceImpl: connect :: ccatConnect " << "returned" << endl << endl;
  cout.flush();
}

void ConnectionServiceImpl::disconnect(ComponentID *idUses, const char *usesPortName, 
							    ComponentID *idProv, const char *provPortName, 
							    double timeout) throw (DisconnectionException) {
  cout << "CCATServicesImpl: disconnect " << usesPortName << "with " << provPortName << endl;
  cout.flush();
  Port* providesPort = (Port *)(idProv->ccatGetProvidesPort(provPortName));
  int result = idUses->ccatDisconnect(usesPortName, providesPort, timeout);
}

void ConnectionServiceImpl::exportAs(ComponentID *idMe, ComponentID *idSub, 
							  const char *portName, const char *newPortname) 
  throw (ExportAsException) {

  cout << "CCATServicesImpl: exportAs Port:" << portName << " as Port:" 
	  << newPortname << endl << flush;
  idMe->ccatExportAs (idSub, portName, newPortname);
}

void ConnectionServiceImpl::provideTo(ComponentID *idSub, const char *usesPortName, 
							   Port *port) throw (ProvideToException) {
  cout << "CCATServicesImpl: provideTo Port:" << usesPortName << endl << flush;
  idSub->ccatProvideTo (usesPortName, port);
}
  
void ConnectionServiceImpl::addEventUser(UsesEventPortSkel* eventUser_) {
  eventUser = eventUser_;
}








