// -*-c++-*-

// ConnectionServiceImpl:
// --Madhu
#ifndef _CONNECTION_SERVICE_IMPL_H__
#define _CONNECTION_SERVICE_IMPL_H__

#include "ConnectionService.h"
#include "../idl/eventPort/UsesEventPortSkel.h"

class ConnectionServiceImpl : public ConnectionService {
public:
  ConnectionServiceImpl();

  virtual void connect(ComponentID *idUses, const char *usesPortName, 
				   ComponentID *idProv, const char *provPortName) 
				   throw (ConnectionException);

  virtual void disconnect(ComponentID *idUser, const char *usesPortName,  
					 ComponentID *idProv, const char *provPortName, double timeout) 
    throw (DisconnectionException);

  virtual void exportAs(ComponentID *idMe, ComponentID *idSub, const char *portName, 
				    const char *newPortname) throw (ExportAsException);

  virtual void provideTo(ComponentID *idSub, const char *usesPortName, Port *port) 
    throw (ProvideToException);

private:
  UsesEventPortSkel *eventUser;
  void addEventUser(UsesEventPortSkel* eventUser_);

  friend class FrameworkServicesSingletonFactory;
};

#endif // _CONNECTION_SERVICE_IMPL_H__
