// -*-c++-*-
// CreationServiceImpl: creationService is an 
// abstract class and has been defined as part
// of the ccat specs. So we need another 
// class that has a private api to be used 
// to imlement the creation service functionality
// --Madhu

#ifndef _CREATION_SERVICE_IMPL_H__
#define _CREATION_SERVICE_IMPL_H__

#include "CreationService.h"
#include "../idl/eventPort/UsesEventPortSkel.h"

class CreationServiceImpl : public CreationService {
public:
  CreationServiceImpl();
  //  virtual ComponentID* createInstance(char* execHost, char *execPath) throw (InstantiateException);
  virtual ComponentID* createInstance(char* url, EnvObj* env) 
    throw (InstantiateException);  
  virtual void deleteInstance(ComponentID* id) throw (InstantiateException);

private:
  UsesEventPortSkel *eventUser;

  // create a component using Globus GRAM.
  ComponentID* createGramInstance(const char *execHost, const char *execPath);

  //   ComponentID* createSSHInstance(char *execHost, char *execPath);
  //   ComponentID* createRSHInstance(char *execHost, char *execPath);
  //   ComponentID* createExecInstance(char *execHost, char *execPath);

  // This requires that the object file containing the componen to be
  // instantiated is already linked with the creator. This does not do any of
  // dynamic loading. It's assumed that a stub compiler generated class is
  // available that will take a full name for the component and gives back a
  // ComponentID.
  ComponentID* createInProcessInstance(myString &componentName);

  void parseUrl (myString& url, myString& mechanism, 
		 myString& targetHost, myString& compoName);

  void addEventUser(UsesEventPortSkel *eventUser_);

  friend class FrameworkServicesSingletonFactory;
};

#endif // _CREATION_SERVICE_IMPL_H__
