// -*-c++-*-
#ifndef _PORTS_REGISTRATION_ID_H
#define _PORTS_REGISTRATION_ID_H


////////////////////// Start of ID Declarations /////////////////////

// The real remote methods start with the starting ID. There is one extra ID
// required, in order to register the class itself, that one is always
// first-method-id - 1. Also, for NexusRMI, the ID is added with 200. So, be
// careful there. Also, there are some blank spots as the Java side requires a
// setProxy method that has some ID on the Java side.

// eventChannel: starting with 250
// This is currently unused but there for future expansion

// filteringEventChannel: starting with 275
enum {
    PROVIDES_FILTERING_EVENT_CHANNEL_SKEL_ID = 274,
    REGISTER_LISTENER_ID,
    REGISTER_PUBLISHER_ID,
    FILTERING_EVENT_CHANNEL_SET_PROXY_ID,
    UNREGISTER_ID
};

// sparseLinearSystem: starting with 300
enum {
    PROVIDES_SPARSE_LINEAR_SYSTEM_SKEL_ID = 299,
    SPARSE_LINEAR_SYSTEM_SET_PROXY_ID,
    SEND_SPARSE_LINEAR_SYSTEM_ID
};

// control: starting with 325
// Not sure if this will be required as all the control functionality is going
// into the Parms ports for specific components.

// getSystemFromFile: starting with 350
enum {
    PROVIDES_GET_SYSTEM_FROM_FILE_PARMS_SKEL_ID = 349,
    GET_SYSTEM_FROM_FILE_PARMS_KILL_ID,
    SEND_GET_SYSTEM_FROM_FILE_PARMS_ID,
    GET_SYSTEM_FROM_FILE_PARMS_SET_PROXY_ID,
    GET_SYSTEM_FROM_FILE_PARMS_START_ID,
    GET_SYSTEM_FROM_FILE_PARMS_STOP_ID
};

// basicInfoParms: starting with 375
enum {
    PROVIDES_BASIC_INFO_PARMS_SKEL_ID = 374,
    BASIC_INFO_PARMS_GETOUTPUTURL_ID,
    BASIC_INFO_PARMS_KILL_ID,
    SEND_BASIC_INFO_PARMS_ID,
    BASIC_INFO_PARMS_SET_PROXY_ID,
    BASIC_INFO_PARMS_START_ID,
    BASIC_INFO_PARMS_STOP_ID
};

// string: starting with 400
enum {
    STRING_IDL_SKEL_ID = 399,
    STRING_SET_PROXY_ID,
    SET_STRING_ID
};

// splib: starting with 425
enum {
    PROVIDES_SPLIB_PARMS_SKEL_ID = 424,
    SPLIB_PARMS_GETOUTPUTURL_ID,
    SPLIB_PARMS_KILL_ID,
    SEND_SPLIB_PARMS_ID,
    SPLIB_PARMS_SET_PROXY_ID,
    SPLIB_PARMS_START_ID,
    SPLIB_PARMS_STOP_ID
};


// solutionVector: starting with 450
enum {
    PROVIDES_SOLUTION_VECTOR_SKEL_ID = 449,
    PROVIDES_SOLUTION_VECTOR_PARMS_KILL_ID,
    SEND_SOLUTION_VECTOR_ID,
    PROVIDES_SOLUTION_VECTOR_PARMS_SET_PROXY_ID,
    PROVIDES_SOLUTION_VECTOR_PARMS_START_ID,
    PROVIDES_SOLUTION_VECTOR_PARMS_STOP_ID
};

// putSolutionToFileParms: starting with 475
enum {
    PROVIDES_PUT_SOLUTION_TO_FILE_PARMS_SKEL_ID = 474,
    PUT_SOLUTION_TO_FILE_PARMS_KILL_ID,
    SEND_PUT_SOLUTION_TO_FILE_PARMS_ID,
    PUT_SOLUTION_TO_FILE_PARMS_SET_PROXY_ID,
    PUT_SOLUTION_TO_FILE_PARMS_START_ID,
    PUT_SOLUTION_TO_FILE_PARMS_STOP_ID
};

// reorderParms: starting with 500
enum {
    PROVIDES_REORDER_PARMS_SKEL_ID = 499,
    REORDER_PARMS_KILL_ID,
    SEND_REORDER_PARMS_ID,
    REORDER_PARMS_SET_PROXY_ID,
    REORDER_PARMS_START_ID,
    REORDER_PARMS_STOP_ID
};

// scaleParms: starting with 525
enum {
    PROVIDES_SCALE_PARMS_SKEL_ID = 524,
    SCALE_PARMS_KILL_ID,
    SEND_SCALE_PARMS_ID,
    SCALE_PARMS_SET_PROXY_ID,
    SCALE_PARMS_START_ID,
    SCALE_PARMS_STOP_ID
};


// superluParms: starting with 550
enum {
    PROVIDES_SUPER_LU_PARMS_SKEL_ID = 549,
    SUPER_LU_PARMS_GETOUTPUTURL_ID,
    SUPER_LU_PARMS_KILL_ID,
    SEND_SUPER_LU_PARMS_ID,
    SUPER_LU_PARMS_SET_PROXY_ID,
    SUPER_LU_PARMS_START_ID,
    SUPER_LU_PARMS_STOP_ID
};

// geometry: starting with 575
enum {
    PROVIDES_GEOMETRY_SKEL_ID = 574,
    SEND_GEOMETRY_ID
};

// timeStep: starting with 600
enum {
    PROVIDES_TIME_STEP_SKEL_ID = 599,
    SEND_TIME_STEP_ID
};

// runItAgain: starting with 625
enum {
    PROVIDES_RUN_IT_AGAIN_SKEL_ID = 624,
    SEND_RUN_IT_AGAIN_ID
};

// eventPort: starting with 650
enum {
    PROVIDES_EVENT_PORT_SKEL_ID = 649,
    NOTIFY_ID,
    EVENT_PORT_SET_PROXY_ID
};

// timeStepParms: starting with 675
enum {
    PROVIDES_TIME_STEP_PARMS_SKEL_ID = 674,
    TIME_STEP_PARMS_GETOUTPUTURL_ID,
    TIME_STEP_PARMS_KILL_ID,
    SEND_TIME_STEP_PARMS_ID,
    TIME_STEP_PARMS_SET_PROXY_ID,
    TIME_STEP_PARMS_START_ID,
    TIME_STEP_PARMS_STOP_ID
};



/*
    const int PROVIDES_TIME_STEP_PARMS_SKEL_ID = 674;
    const int TIME_STEP_PARMS_KILL_ID = 675 ;
    const int SEND_TIME_STEP_PARMS_ID = 676; 
    const int TIME_STEP_PARMS_SET_PROXY_ID = 677;
    const int TIME_STEP_PARMS_START_ID = 678;
    const int TIME_STEP_PARMS_STOP_ID = 679;
*/

// AssembleParms: starting with 700
enum {
    PROVIDES_ASSEMBLE_PARMS_SKEL_ID = 699,
    ASSEMBLE_PARMS_GETOUTPUTURL_ID,
    ASSEMBLE_PARMS_KILL_ID,
    SEND_ASSEMBLE_PARMS_ID,
    ASSEMBLE_PARMS_SET_PROXY_ID,
    ASSEMBLE_PARMS_START_ID,
    ASSEMBLE_PARMS_STOP_ID
};

// DiscretizerParms: starting with 725
enum {
    PROVIDES_DISCRETIZER_PARMS_SKEL_ID = 724,
    DISCRETIZER_PARMS_GETOUTPUTURL_ID,
    DISCRETIZER_PARMS_KILL_ID,
    SEND_DISCRETIZER_PARMS_ID,
    DISCRETIZER_PARMS_SET_PROXY_ID,
    DISCRETIZER_PARMS_START_ID,
    DISCRETIZER_PARMS_STOP_ID
};


////////////////////// End of ID Declarations /////////////////////

static const char *PORT_PACKAGE = "ccat.frameworkCore.idl";

#endif // _PORTS_REGISTRATION_ID.H_

void registerStringPorts();
