#include "UsesAssembleParmsSkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool UsesAssembleParmsSkel::registerFlag = false;

int
UsesAssembleParmsSkel::sendAssembleParms() {
const char *xfn = "UsesAssembleParmsSkel::sendAssembleParms";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SEND_ASSEMBLE_PARMS_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesAssembleParmsSkel::start() {
const char *xfn = "UsesAssembleParmsSkel::start";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             ASSEMBLE_PARMS_START_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesAssembleParmsSkel::stop() {
const char *xfn = "UsesAssembleParmsSkel::stop";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             ASSEMBLE_PARMS_STOP_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesAssembleParmsSkel::kill() {
const char *xfn = "UsesAssembleParmsSkel::kill";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             ASSEMBLE_PARMS_KILL_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

char*
UsesAssembleParmsSkel::getOutputURL() {
const char *xfn = "UsesAssembleParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             ASSEMBLE_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}

void UsesAssembleParmsSkel::registerSelf () {
    if (!registerFlag) {
        registerFlag = true;
        registerUsesPortType("AssembleParms_idl", *(new UsesAssembleParmsSkel()));
    }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesAssembleParmsSkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesAssembleParmsSkel* p, int count){}


