#include "ProvidesBasicInfoParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesBasicInfoParms.h"



bool ProvidesBasicInfoParmsSkel::registerFlag = false;



ProvidesBasicInfoParmsSkel::ProvidesBasicInfoParmsSkel(Port *executingPort) 
  : PortSkel(executingPort) {}

int
ProvidesBasicInfoParmsSkel::sendBasicInfoParms(BasicInfoParms bip) {
  const char *xfn = "ProvidesBasicInfoParmsSkel::sendBasicInfoParms";

  cout << xfn << " called." << endl;

  ProvidesBasicInfoParms *port
    = dynamic_cast<ProvidesBasicInfoParms *>(portPointer); 

  int result = port->sendBasicInfoParms(new BasicInfoParms(bip));

  return result;
}

void
ProvidesBasicInfoParmsSkel::registerSelf() {

  if (!registerFlag) {

    registerFlag = true;

    hpcxx_registerClass((ProvidesBasicInfoParmsSkel *) NULL);
    hpcxx_register(&ProvidesBasicInfoParmsSkel::sendBasicInfoParms,
		   SEND_BASIC_INFO_PARMS_ID);
    hpcxx_register(&ProvidesBasicInfoParmsSkel::start,
		   BASIC_INFO_PARMS_START_ID);
    hpcxx_register(&ProvidesBasicInfoParmsSkel::stop,
		   BASIC_INFO_PARMS_STOP_ID);
    hpcxx_register(&ProvidesBasicInfoParmsSkel::kill,
		   BASIC_INFO_PARMS_KILL_ID);
    hpcxx_register(&ProvidesBasicInfoParmsSkel::getOutputURL, BASIC_INFO_PARMS_GETOUTPUTURL_ID);


    registerProvidesPortType("BasicInfoParms_idl",
			     *(new ProvidesBasicInfoParmsSkel(NULL)));    
  }
}

int
ProvidesBasicInfoParmsSkel::start() {
  const char *xfn = "ProvidesBasicInfoParmsSkel::start";

  cout << xfn << " called." << endl << flush;

  ProvidesBasicInfoParms *port = dynamic_cast<ProvidesBasicInfoParms *>(portPointer); 

  return port->start();
}

int
ProvidesBasicInfoParmsSkel::stop() {
  const char *xfn = "ProvidesBasicInfoParmsSkel::stop";

  cout << xfn << " called." << endl << flush;

  ProvidesBasicInfoParms *port = dynamic_cast<ProvidesBasicInfoParms *>(portPointer); 

  return port->stop();
}

int
ProvidesBasicInfoParmsSkel::kill() {
  const char *xfn = "ProvidesBasicInfoParmsSkel::kill";

  cout << xfn << " called." << endl << flush;

  ProvidesBasicInfoParms *port = dynamic_cast<ProvidesBasicInfoParms *>(portPointer); 

  return port->kill();
}

HPCxx_String
ProvidesBasicInfoParmsSkel::getOutputURL() {
const char *xfn = "ProvidesBasicInfoParmsSkel::getOutputURL";

    cout << xfn << " called." << endl << flush;

    ProvidesBasicInfoParms *port = dynamic_cast<ProvidesBasicInfoParms *>(portPointer); 

    char *returnVal = port->getOutputURL();
    char *returnValue = new char[strlen(returnVal)+1];
    strcpy(returnValue,returnVal);
    HPCxx_String *urlValue = new HPCxx_String(returnValue);
    return *urlValue;
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesBasicInfoParmsSkel* p, int count) {
  assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesBasicInfoParmsSkel* p, int count) {
  assert(0);
}

#ifdef ORIG
//  // register all the port types and their member functions.
//  void registerBasicInfoParmsPorts(){
//    hpcxx_registerClass((ProvidesBasicInfoParmsSkel *)NULL);
//    hpcxx_register(&ProvidesBasicInfoParmsSkel::start, BASIC_INFO_PARMS_START_ID);
//    hpcxx_register(&ProvidesBasicInfoParmsSkel::stop, BASIC_INFO_PARMS_STOP_ID);
//    hpcxx_register(&ProvidesBasicInfoParmsSkel::kill, BASIC_INFO_PARMS_KILL_ID);
//    hpcxx_register(&ProvidesBasicInfoParmsSkel::registerListener, SEND_BASIC_INFO_PARMS_ID);
//  }
#endif
