// -*-c++-*-
#ifndef _PROVIDES_BASIC_INFO_PARMS_SKEL_H
#define _PROVIDES_BASIC_INFO_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../../../components/application/lsa/BasicInfo/BasicInfoParms.h"
#include "../PORTS_REGISTRATION_ID.h"



class Port;
class ProvidesBasicInfoParmsSkel;
class HPCxx_String;


// The provides port that calls the executing port
// to implement the method declared in the idl

class ProvidesBasicInfoParmsSkel : public PortSkel {

public:

  ProvidesBasicInfoParmsSkel(Port *executingPort);
  int sendBasicInfoParms(BasicInfoParms sls);
  int start();
  int stop();
  int kill();
  HPCxx_String getOutputURL();

public:

  // port registration
  static void registerSelf ();
  static int registrationID() {
    return PROVIDES_BASIC_INFO_PARMS_SKEL_ID; }

private:

  static bool registerFlag;  
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesBasicInfoParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesBasicInfoParmsSkel* p, int count);
void registerBasicInfoParmsPorts();


#endif
