#include "UsesBasicInfoParmsSkel.h"
#include <hpcxx.h>



#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/BasicInfo/BasicInfoParms.h"



bool UsesBasicInfoParmsSkel::registerFlag = false;

int UsesBasicInfoParmsSkel::sendBasicInfoParms(BasicInfoParms *sls) {

  for (vector<Port*>::iterator iter = providerList.begin();
       iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {

      cout << "UsesBasicInfoParmsSkel::call sendBasicInfoParms " << endl;

      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    SEND_BASIC_INFO_PARMS_ID, *sls);

    } else {

      cout << "UsesBasicInfoParmsSkel::registerListener::Unbound"
	" ProvidesPort Proxy !! \n" << endl;
      assert(0);
    }
  }

  return 0;
}


int
UsesBasicInfoParmsSkel::start() {
  const char *xfn = "UsesBasicInfoParmsSkel::start";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    BASIC_INFO_PARMS_START_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

int
UsesBasicInfoParmsSkel::stop() {
  const char *xfn = "UsesBasicInfoParmsSkel::stop";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    BASIC_INFO_PARMS_STOP_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

int
UsesBasicInfoParmsSkel::kill() {
  const char *xfn = "UsesBasicInfoParmsSkel::kill";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    BASIC_INFO_PARMS_KILL_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

char*
UsesBasicInfoParmsSkel::getOutputURL() {
const char *xfn = "UsesBasicInfoParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             BASIC_INFO_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}

void UsesBasicInfoParmsSkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;
    registerUsesPortType("BasicInfoParms_idl", 
			 *(new UsesBasicInfoParmsSkel()));
  }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesBasicInfoParmsSkel* p, int count) {
  assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, UsesBasicInfoParmsSkel* p, int count){
  assert(0);
}
