#include "ProvidesDiscretizerParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesDiscretizerParms.h"



bool ProvidesDiscretizerParmsSkel::registerFlag = false;

ProvidesDiscretizerParmsSkel::ProvidesDiscretizerParmsSkel(Port *executingPort)
 : PortSkel(executingPort) {}

int
ProvidesDiscretizerParmsSkel :: sendDiscretizerParms() {
const char *xfn = "ProvidesDiscretizerParmsSkel :: sendDiscretizerParms";

    cout << xfn << " called." << endl << flush;

    ProvidesDiscretizerParms *port = dynamic_cast<ProvidesDiscretizerParms *>(portPointer); 

    int result = port->sendDiscretizerParms();
    return result;
}

int
ProvidesDiscretizerParmsSkel::start() {
const char *xfn = "ProvidesDiscretizerParmsSkel::start";

    cout << xfn << " called." << endl << flush;

    ProvidesDiscretizerParms *port = dynamic_cast<ProvidesDiscretizerParms *>(portPointer); 

    return port->start();
}

int
ProvidesDiscretizerParmsSkel::stop() {
const char *xfn = "ProvidesDiscretizerParmsSkel::stop";

    cout << xfn << " called." << endl << flush;

    ProvidesDiscretizerParms *port = dynamic_cast<ProvidesDiscretizerParms *>(portPointer); 

    return port->stop();
}

int
ProvidesDiscretizerParmsSkel::kill() {
const char *xfn = "ProvidesDiscretizerParmsSkel::kill";

    cout << xfn << " called." << endl << flush;

    ProvidesDiscretizerParms *port = dynamic_cast<ProvidesDiscretizerParms *>(portPointer); 

    return port->kill();
}

HPCxx_String
ProvidesDiscretizerParmsSkel::getOutputURL() {
const char *xfn = "ProvidesDiscretizerParmsSkel::getOutputURL";

    cout << xfn << " called." << endl << flush;

    ProvidesDiscretizerParms *port = dynamic_cast<ProvidesDiscretizerParms *>(portPointer); 

    char *returnVal = port->getOutputURL();
    char *returnValue = new char[strlen(returnVal)+1];
    strcpy(returnValue,returnVal);
    HPCxx_String *urlValue = new HPCxx_String(returnValue);
    return *urlValue;
}

void ProvidesDiscretizerParmsSkel::registerSelf () {

    if (!registerFlag) {

        registerFlag = true;

        hpcxx_registerClass((ProvidesDiscretizerParmsSkel *)NULL);
        hpcxx_register(&ProvidesDiscretizerParmsSkel::sendDiscretizerParms,
         SEND_DISCRETIZER_PARMS_ID);
        hpcxx_register(&ProvidesDiscretizerParmsSkel::start, DISCRETIZER_PARMS_START_ID);
        hpcxx_register(&ProvidesDiscretizerParmsSkel::stop, DISCRETIZER_PARMS_STOP_ID);
        hpcxx_register(&ProvidesDiscretizerParmsSkel::kill, DISCRETIZER_PARMS_KILL_ID);
	hpcxx_register(&ProvidesDiscretizerParmsSkel::getOutputURL, DISCRETIZER_PARMS_GETOUTPUTURL_ID);
        registerProvidesPortType("DiscretizerParms_idl",
         *(new ProvidesDiscretizerParmsSkel(NULL)));    
    }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesDiscretizerParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesDiscretizerParmsSkel* p, int count) {
    assert(0);
}

