// -*-c++-*-
#ifndef _PROVIDES_DISCRETIZER_PARMS_SKEL_H
#define _PROVIDES_DISCRETIZER_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../PORTS_REGISTRATION_ID.h"



// The provides port that calls the executing port
// to implement the method declared in the idl



class Port;
class HPCxx_String;


class ProvidesDiscretizerParmsSkel : public PortSkel {

    public:

      ProvidesDiscretizerParmsSkel(Port *executingPort);
      int sendDiscretizerParms();
      int start();
      int stop();
      int kill();
      HPCxx_String getOutputURL();

    /*
     * Static
     */
      
    private:

      static bool registerFlag;  

    public:

        static int registrationID() { return PROVIDES_DISCRETIZER_PARMS_SKEL_ID; }
        // port registration
        static void registerSelf ();
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesDiscretizerParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesDiscretizerParmsSkel* p, int count);
void registerDiscretizerParmsPorts();



#endif // _PROVIDES_DISCRETIZER_PARMS_SKEL_H
