#include "UsesDiscretizerParmsSkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool UsesDiscretizerParmsSkel::registerFlag = false;

int
UsesDiscretizerParmsSkel::sendDiscretizerParms() {
const char *xfn = "UsesDiscretizerParmsSkel::sendDiscretizerParms";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SEND_DISCRETIZER_PARMS_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesDiscretizerParmsSkel::start() {
const char *xfn = "UsesDiscretizerParmsSkel::start";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             DISCRETIZER_PARMS_START_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesDiscretizerParmsSkel::stop() {
const char *xfn = "UsesDiscretizerParmsSkel::stop";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             DISCRETIZER_PARMS_STOP_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesDiscretizerParmsSkel::kill() {
const char *xfn = "UsesDiscretizerParmsSkel::kill";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             DISCRETIZER_PARMS_KILL_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

char*
UsesDiscretizerParmsSkel::getOutputURL() {
const char *xfn = "UsesDiscretizerParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             DISCRETIZER_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}

void UsesDiscretizerParmsSkel::registerSelf () {
    if (!registerFlag) {
        registerFlag = true;
        registerUsesPortType("DiscretizerParms_idl", *(new UsesDiscretizerParmsSkel()));
    }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesDiscretizerParmsSkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesDiscretizerParmsSkel* p, int count){}


