// -*-c++-*-

#ifndef _FILTERING_EVENT_CHANNEL_IDL_H__
#define _FILTERING_EVENT_CHANNEL_IDL_H__

#include "../../ccacore/ComponentID.h"
#include "../../ccacore/STL.h"
#include "../InterfaceType.h"
#include "../../exceptions/AlreadyRegisteredException.h"
#include "../../exceptions/NotRegisteredException.h"


// interface FilteringEventChannel : CCAPort {
//   void registerListener(ComponentID listener,
// 			string listener_provides_port, string type)
//     raises (AlreadyRegisteredException);
//   void registerPublisher(ComponentID publisher,
// 			 string publisher_uses_port)
//     raises (AlreadyRegisteredException);
//   void unregister(ComponentID component, string port)
//     raises (NotRegisteredException);
// };


class FilteringEventChannel_idl : public InterfaceType {
public:
  virtual int registerListener(ComponentID *listener, char *listenerProvidesPort, char *type) throw (AlreadyRegisteredException) = 0;
  virtual int registerPublisher(ComponentID *publisher, char *publisherUsesPort) throw (AlreadyRegisteredException) = 0;
  virtual int unregister(ComponentID *component, char *port) throw (NotRegisteredException) = 0;
};

#endif // _FILTERING_EVENT_CHANNEL_IDL_H__
