#include "ProvidesFilteringEventChannelSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool ProvidesFilteringEventChannelSkel::registerFlag = false;

ProvidesFilteringEventChannelSkel::ProvidesFilteringEventChannelSkel(Port *executingPort): PortSkel(executingPort) {}

int ProvidesFilteringEventChannelSkel ::  registerListener(CCATServicesProxy listener, HPCxx_String listenerProvidesPort, HPCxx_String type) throw (AlreadyRegisteredException) {
  cout << "ProvidesFilteringEventChannelSkel::registerListener called !! "<< listenerProvidesPort << " " << type << endl;
  cout.flush();
  char *listenerProvString = (char *)listenerProvidesPort;
  char *typeString = (char *)type;
  ProvidesFilteringEventChannel *port = dynamic_cast<ProvidesFilteringEventChannel *>(portPointer);
  ComponentID *listenerCompID = new CCATServicesProxy(listener);
  int result = port->registerListener(listenerCompID, listenerProvString, typeString);
  return result;
}

int ProvidesFilteringEventChannelSkel :: registerPublisher(CCATServicesProxy publisher, HPCxx_String publisherUsesPort) throw (AlreadyRegisteredException) {
  cout << "ProvidesFilteringEventChannelSkel::registerPublisher called !! "<< publisherUsesPort << endl;
  cout.flush();
  char *publisherUsesString = (char *)publisherUsesPort;
  ProvidesFilteringEventChannel *port = dynamic_cast<ProvidesFilteringEventChannel *>(portPointer);
  ComponentID *publisherCompID = new CCATServicesProxy(publisher);
  int result = port->registerPublisher(publisherCompID, publisherUsesString);
  return result;
}


int ProvidesFilteringEventChannelSkel :: unregister(CCATServicesProxy component, HPCxx_String portName) throw (NotRegisteredException) {
  char *myPortString = (char *)portName;
  ProvidesFilteringEventChannel *port = dynamic_cast<ProvidesFilteringEventChannel *>(portPointer);
  ComponentID *compCompID = new CCATServicesProxy(component);
  int result = port->registerPublisher(compCompID, myPortString);
  return result;
}

void ProvidesFilteringEventChannelSkel :: registerSelf () {
  if (!registerFlag) {
    registerFlag = true;

    hpcxx_registerClass((ProvidesFilteringEventChannelSkel *)NULL);
    hpcxx_register(&ProvidesFilteringEventChannelSkel::registerListener, REGISTER_LISTENER_ID);
    hpcxx_register(&ProvidesFilteringEventChannelSkel::registerPublisher, REGISTER_PUBLISHER_ID);
    hpcxx_register(&ProvidesFilteringEventChannelSkel::unregister, UNREGISTER_ID);

    registerProvidesPortType("FilteringEventChannel_idl",
					    *(new ProvidesFilteringEventChannelSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.

void hpcxx_pack(HPCxx_Buffer& b, ProvidesFilteringEventChannelSkel* p, int count){}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesFilteringEventChannelSkel* p, int count){}

#ifdef ORIG
// register all the port types and their member functions.
void registerFilteringEventChannelPorts(){
  hpcxx_registerClass((ProvidesFilteringEventChannelSkel *)NULL);
  hpcxx_register(&ProvidesFilteringEventChannelSkel::registerListener, REGISTER_LISTENER_ID);
  hpcxx_register(&ProvidesFilteringEventChannelSkel::registerPublisher, REGISTER_PUBLISHER_ID);
  hpcxx_register(&ProvidesFilteringEventChannelSkel::unregister, UNREGISTER_ID);
}
#endif
