// -*-c++-*-
#ifndef PROVIDESFILTERINGEVENTCHANNELSKEL_H
#define PROVIDESFILTERINGEVENTCHANNELSKEL_H

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../ccacore/CCATServicesProxy.h"
#include "../../exceptions/AlreadyRegisteredException.h"
#include "../../exceptions/NotRegisteredException.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "../../util/HPCxx_String.h"
#include "ProvidesFilteringEventChannel.h"
#include "UsesFilteringEventChannel.h"
#include "FilteringEventChannel_idl.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>


// The provides port that calls the executing port
// to implement the method declared in the idl


class ProvidesFilteringEventChannelSkel : public PortSkel {
public:
  ProvidesFilteringEventChannelSkel(Port *executingPort);
  static int registrationID() { return PROVIDES_FILTERING_EVENT_CHANNEL_SKEL_ID; }
  int registerListener(CCATServicesProxy listener, HPCxx_String listenerProvidesPort, HPCxx_String type) throw (AlreadyRegisteredException);
  int registerPublisher(CCATServicesProxy publisher, HPCxx_String publisherUsesPort) throw (AlreadyRegisteredException);
  int unregister(CCATServicesProxy component, HPCxx_String portName) throw (NotRegisteredException);

  // port registration
  static void registerSelf ();

private:
  static bool registerFlag;  
};

// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesFilteringEventChannelSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesFilteringEventChannelSkel* p, int count);
void registerFilteringEventChannelPorts();

#endif // PROVIDESFILTERINGEVENTCHANNELSKEL_H



