// -*-c++-*-

#ifndef USES_FILTERING_EVENT_CHANNEL_SKEL_H__
#define USES_FILTERING_EVENT_CHANNEL_SKEL_H__

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../exceptions/AlreadyRegisteredException.h"
#include "../../exceptions/NotRegisteredException.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "ProvidesFilteringEventChannel.h"
#include "UsesFilteringEventChannel.h"
#include "FilteringEventChannel_idl.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>


class UsesFilteringEventChannelSkel: public UsesFilteringEventChannel {
public:
  UsesFilteringEventChannelSkel(): UsesFilteringEventChannel() {}
  UsesFilteringEventChannelSkel(Port *): UsesFilteringEventChannel() {}
  
  // these are local method invocations
  int registerListener(ComponentID *listener, char *listenerProvidesPort, char *type) throw (AlreadyRegisteredException);
  int registerPublisher(ComponentID *publisher, char *publisherUsesPort) throw (AlreadyRegisteredException);
  int unregister(ComponentID *component, char *portName) throw (NotRegisteredException);
  friend void hpcxx_pack(HPCxx_Buffer& b, UsesFilteringEventChannelSkel* p, int count);
  friend void hpcxx_unpack(HPCxx_Buffer& b, UsesFilteringEventChannelSkel* p, int count);

  // port registration
  static void registerSelf ();

private:
  static bool registerFlag;  
};

#endif // USES_FILTERING_EVENT_CHANNEL_SKEL_H__





