#include "ProvidesEventPortSkel.h"

#ifdef ORIG

#include <hpcxx_register.cc>
#include <HPCxx_GlobalRefImpl.cc>

#else

#include <hpcxx.h>

#endif
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool ProvidesEventPortSkel::registerFlag = false;

ProvidesEventPortSkel::ProvidesEventPortSkel(Port *executingPort): PortSkel(executingPort) {}

int ProvidesEventPortSkel ::  notify(Event event) {
  ProvidesEventPort *port = dynamic_cast<ProvidesEventPort *>(portPointer);
  Event *ev = new Event(event);
  int result = port->notify(ev);
  return result;
}

void ProvidesEventPortSkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;

    hpcxx_registerClass((ProvidesEventPortSkel *)NULL);
    hpcxx_register(&ProvidesEventPortSkel::notify, NOTIFY_ID);
    
    registerProvidesPortType("EventPort_idl", *(new ProvidesEventPortSkel(NULL)));
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesEventPortSkel* p, int count){}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesEventPortSkel* p, int count){}

#ifdef ORIG
// register all the port types and their member functions.
void registerEventPortPorts(){
  hpcxx_registerClass((ProvidesEventPortSkel *)NULL);
  hpcxx_register(&ProvidesEventPortSkel::notify, NOTIFY_ID);
}
#endif
