// -*-c++-*-
#ifndef PROVIDES_EVENT_PORT_SKEL_H__
#define PROVIDES_EVENT_PORT_SKEL_H__

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../exceptions/AlreadyRegisteredException.h"
#include "../../exceptions/NotRegisteredException.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "ProvidesEventPort.h"
#include "UsesEventPort.h"
#include "EventPort_idl.h"
#include "Event.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>


// The provides port that calls the executing port
// to implement the method declared in the idl

class ProvidesEventPortSkel: public PortSkel {
public:
  ProvidesEventPortSkel(Port *executingPort);
  static int registrationID() { return PROVIDES_EVENT_PORT_SKEL_ID; }
  int notify(Event event);

  // port registration
  static void registerSelf ();

private:
  static bool registerFlag;  
};

// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesEventPortSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesEventPortSkel* p, int count);
void registerEventPortPorts();

#endif // _PROVIDES_FILTERING_EVENT_CHANNEL_H__



