#include "ProvidesGeometrySkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool ProvidesGeometrySkel::registerFlag = false;

ProvidesGeometrySkel::ProvidesGeometrySkel(Port *executingPort): PortSkel(executingPort) {}

int ProvidesGeometrySkel :: sendGeometry(Geometry geo) {
  cout << "ProvidesGeometrySkel::sendGeometry called !!  " << endl;
  cout.flush();
  ProvidesGeometry *port = dynamic_cast<ProvidesGeometry *>(portPointer); 
  int result = port->sendGeometry(new Geometry(geo));
  return result;
}


void ProvidesGeometrySkel :: registerSelf () {
  if (!registerFlag) {
    registerFlag = true;

    hpcxx_registerClass((ProvidesGeometrySkel *)NULL);
    hpcxx_register(&ProvidesGeometrySkel::sendGeometry, SEND_GEOMETRY_ID);
    registerProvidesPortType("Geometry_idl",
					    *(new ProvidesGeometrySkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesGeometrySkel* p, int count){}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesGeometrySkel* p, int count){}
