// -*-c++-*-
#ifndef _PROVIDES_GEOMETRY_SKEL_H
#define _PROVIDES_GEOMETRY_SKEL_H

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../ccacore/CCATServicesProxy.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "../../util/HPCxx_String.h"
#include "ProvidesGeometry.h"
#include "UsesGeometry.h"
#include "Geometry_idl.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>


// The provides port that calls the executing port
// to implement the method declared in the idl


class ProvidesGeometrySkel : public PortSkel {
public:
  ProvidesGeometrySkel(Port *executingPort);
  static int registrationID() { return PROVIDES_GEOMETRY_SKEL_ID; }
  int sendGeometry(Geometry geo);
  // port registration
  static void registerSelf ();
  
private:
  static bool registerFlag;  
};

// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesGeometrySkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesGeometrySkel* p, int count);
void registerGeometryPorts();

#endif // _PROVIDES_GEOMETRY_SKEL_H



