#include "UsesGeometrySkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/Common/Geometry.h"

bool UsesGeometrySkel::registerFlag = false;

int UsesGeometrySkel :: sendGeometry(Geometry *geo) {

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end();  
      iter++) {
    Port *pidl = *iter;
    int dummy;
    if ((*pidl).skp) {
      cout << "UsesGeometrySkel::call sendGeometry "  << endl;
      cout.flush();
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy, SEND_GEOMETRY_ID, *geo);
    } else {
      cout << "UsesGeometrySkel::registerListener::Unbound ProvidesPort Proxy !! \n";
    }
  }
  return 0;
}

void UsesGeometrySkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;
    registerUsesPortType("Geometry_idl", 
					*(new UsesGeometrySkel()));
  }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesGeometrySkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesGeometrySkel* p, int count){}


