#include "ProvidesReorderParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesReorderParms.h"



bool ProvidesReorderParmsSkel::registerFlag = false;



ProvidesReorderParmsSkel::ProvidesReorderParmsSkel(Port *executingPort) 
 : PortSkel(executingPort) {}

int
ProvidesReorderParmsSkel::sendReorderParms(ReorderParms bip) {

    cout << "ProvidesReorderParmsSkel::sendReorderParms called !!" << endl;

    ProvidesReorderParms *port
     = dynamic_cast<ProvidesReorderParms *>(portPointer); 

    int result = port->sendReorderParms(&bip);

    return result;
}

void
ProvidesReorderParmsSkel::registerSelf() {

  if (!registerFlag) {

    registerFlag = true;

    hpcxx_registerClass((ProvidesReorderParmsSkel *) NULL);
    hpcxx_register(&ProvidesReorderParmsSkel::sendReorderParms,
     SEND_REORDER_PARMS_ID);
    registerProvidesPortType("ReorderParms_idl",
     *(new ProvidesReorderParmsSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesReorderParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesReorderParmsSkel* p, int count) {
    assert(0);
}

#ifdef ORIG
// register all the port types and their member functions.
void registerReorderParmsPorts(){
  hpcxx_registerClass((ProvidesReorderParmsSkel *)NULL);
  hpcxx_register(&ProvidesReorderParmsSkel::registerListener, SEND_REORDER_PARMS_ID);
}
#endif
