// -*-c++-*-
#ifndef _PROVIDES_REORDER_PARMS_SKEL_H
#define _PROVIDES_REORDER_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../../../components/application/lsa/Reorder/ReorderParms.h"
#include "../PORTS_REGISTRATION_ID.h"



class Port;



// The provides port that calls the executing port
// to implement the method declared in the idl

class ProvidesReorderParmsSkel : public PortSkel {

    public:

        ProvidesReorderParmsSkel(Port *executingPort);
        int sendReorderParms(ReorderParms sls);

    public:

        // port registration
        static void registerSelf ();
        static int registrationID() { return PROVIDES_REORDER_PARMS_SKEL_ID; }

    private:

        static bool registerFlag;  
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesReorderParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesReorderParmsSkel* p, int count);
void registerReorderParmsPorts();


#endif
