#include "ProvidesScaleParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesScaleParms.h"



bool ProvidesScaleParmsSkel::registerFlag = false;



ProvidesScaleParmsSkel::ProvidesScaleParmsSkel(Port *executingPort) 
 : PortSkel(executingPort) {}

int
ProvidesScaleParmsSkel::sendScaleParms(ScaleParms bip) {

    cout << "ProvidesScaleParmsSkel::sendScaleParms called !!" << endl;

    ProvidesScaleParms *port
     = dynamic_cast<ProvidesScaleParms *>(portPointer); 

    int result = port->sendScaleParms(&bip);

    return result;
}

void
ProvidesScaleParmsSkel::registerSelf() {

  if (!registerFlag) {

    registerFlag = true;

    hpcxx_registerClass((ProvidesScaleParmsSkel *) NULL);
    hpcxx_register(&ProvidesScaleParmsSkel::sendScaleParms,
     SEND_SCALE_PARMS_ID);
    registerProvidesPortType("ScaleParms_idl",
     *(new ProvidesScaleParmsSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesScaleParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesScaleParmsSkel* p, int count) {
    assert(0);
}

#ifdef ORIG
// register all the port types and their member functions.
void registerScaleParmsPorts(){
  hpcxx_registerClass((ProvidesScaleParmsSkel *)NULL);
  hpcxx_register(&ProvidesScaleParmsSkel::registerListener, SEND_SCALE_PARMS_ID);
}
#endif
