// -*-c++-*-
#ifndef _PROVIDES_SCALE_PARMS_SKEL_H
#define _PROVIDES_SCALE_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../../../components/application/lsa/Scale/ScaleParms.h"
#include "../PORTS_REGISTRATION_ID.h"



class Port;
class ProvidesScaleParmsSkel;



// The provides port that calls the executing port
// to implement the method declared in the idl

class ProvidesScaleParmsSkel : public PortSkel {

    public:

        ProvidesScaleParmsSkel(Port *executingPort);
        int sendScaleParms(ScaleParms sls);

    public:

        // port registration
        static void registerSelf ();
        static int registrationID() { return PROVIDES_SCALE_PARMS_SKEL_ID; }

    private:

        static bool registerFlag;  
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesScaleParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesScaleParmsSkel* p, int count);
void registerScaleParmsPorts();


#endif
