#include "ProvidesSolutionVectorSkel.h"
#include <hpcxx.h>
#include "../../util/macros.h"
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"



bool
ProvidesSolutionVectorSkel::registerFlag = false;

ProvidesSolutionVectorSkel::ProvidesSolutionVectorSkel(Port *executingPort)
 : PortSkel(executingPort) {}

int
ProvidesSolutionVectorSkel::sendSolutionVector(SolutionVector sv) {
const char *xfn = "ProvidesSolutionVectorSkel::sendSolutionVector";

 printf("%s: called, length=%d.\n", xfn, sv.lengthOfDoubleArray);
 
 DDECL(ProvidesSolutionVector, port, portPointer);
 
 printf("%s: called, length=%d.\n", xfn, sv.lengthOfDoubleArray);
 
 // As opposed to the skeleton level method, the next method is a void one
 port->sendSolutionVector(new SolutionVector(sv));

 // Do we need to release this port? FIXME
 
 return 0;
}


void
ProvidesSolutionVectorSkel::registerSelf() {

    if (!registerFlag) {

        registerFlag = true;

        hpcxx_registerClass((ProvidesSolutionVectorSkel *) NULL);
        hpcxx_register(&ProvidesSolutionVectorSkel::sendSolutionVector,
         SEND_SOLUTION_VECTOR_ID);
        registerProvidesPortType("SolutionVector_idl",
         *(new ProvidesSolutionVectorSkel(NULL)));    
    }
}

// these methods will not be called
// we never move skels around.
void
hpcxx_pack(HPCxx_Buffer& b, ProvidesSolutionVectorSkel* p, int count) {
    assert(0);
}
void
hpcxx_unpack(HPCxx_Buffer& b, ProvidesSolutionVectorSkel* p, int count) {
    assert(0);
}

#ifdef ORIG
// register all the port types and their member functions.
void registerSolutionVectorPorts(){
  hpcxx_registerClass((ProvidesSolutionVectorSkel *)NULL);
  hpcxx_register(&ProvidesSolutionVectorSkel::registerListener, SEND_SOLUTION_VECTOR_ID);
}
#endif
