// -*-c++-*-
#ifndef _PROVIDES_SOLUTION_VECTOR_SKEL_H
#define _PROVIDES_SOLUTION_VECTOR_SKEL_H

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../ccacore/CCATServicesProxy.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "../../util/HPCxx_String.h"
#include "ProvidesSolutionVector.h"
#include "UsesSolutionVector.h"
#include "SolutionVector_idl.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>


// The provides port that calls the executing port
// to implement the method declared in the idl


class ProvidesSolutionVectorSkel : public PortSkel {
public:
  ProvidesSolutionVectorSkel(Port *executingPort);
  static int registrationID() { return PROVIDES_SOLUTION_VECTOR_SKEL_ID; }
  // This method returns an int as oppsed to void in the SolutionVector_idl
  // interface
  int sendSolutionVector(SolutionVector sls);
  // port registration
  static void registerSelf ();
  
private:
  static bool registerFlag;  
};

// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesSolutionVectorSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesSolutionVectorSkel* p, int count);
void registerSolutionVectorPorts();

#endif // _PROVIDES_SPARSE_LINEAR_SYSTEM_SKEL_H



