#include "SolutionVector.h"

SolutionVector::SolutionVector() {
  this->lengthOfDoubleArray = 0;
  this->solutionDoubleArray = NULL;
}

SolutionVector::SolutionVector(const SolutionVector& source) {
  if (source.solutionDoubleArray != NULL) {
    this->solutionDoubleArray = new double[source.lengthOfDoubleArray];
    for (int i=0; i<source.lengthOfDoubleArray; i++) {
      (this->solutionDoubleArray)[i] = (source.solutionDoubleArray)[i];
    }
  } else {
    this->solutionDoubleArray = NULL;
    this->lengthOfDoubleArray = 0;
  }
}

SolutionVector& SolutionVector::operator=(const SolutionVector& source) {
  if (this ==  &source)
    return const_cast<SolutionVector &>(source);
  if (solutionDoubleArray != NULL)
    delete [] solutionDoubleArray;
  if (source.solutionDoubleArray != NULL) {
    this->solutionDoubleArray = new double[source.lengthOfDoubleArray];
    for (int i=0; i<source.lengthOfDoubleArray; i++) {
      (this->solutionDoubleArray)[i] = (source.solutionDoubleArray)[i];
    }
  } else {
    this->solutionDoubleArray = NULL;
    this->lengthOfDoubleArray = 0;
  }
  return *this;
}
double* SolutionVector::getSolutionArray() const {
  return solutionDoubleArray;
}

int SolutionVector::getLength() const {
  return lengthOfDoubleArray;
}

void SolutionVector::freeMemory() {
  if (solutionDoubleArray != NULL)
    delete [] solutionDoubleArray;
}

SolutionVector::~SolutionVector() {
  // use freeMemory() to 
  // free memory
}

void hpcxx_pack(HPCxx_Buffer& buffer, SolutionVector *s, int count) {
  for(int i=0; i<count; i++) {
    int lengthOfArray = s->getLength();
    hpcxx_pack(buffer, &lengthOfArray, 1);
    hpcxx_pack(buffer, s->getSolutionArray(), lengthOfArray);
  }
}

void hpcxx_unpack(HPCxx_Buffer& buffer, SolutionVector *s, int count) {
  for(int i=0; i<count; i++) {
    int lengthOfArray;
    hpcxx_unpack(buffer, &lengthOfArray, 1);
    s->lengthOfDoubleArray = lengthOfArray;
    hpcxx_unpack(buffer, s->solutionDoubleArray, lengthOfArray);
  }
}




