#include "UsesSolutionVectorSkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/Common/SolutionVector.h"

bool UsesSolutionVectorSkel::registerFlag = false;

void UsesSolutionVectorSkel :: sendSolutionVector(SolutionVector *sls) {

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end();  
      iter++) {
    Port *pidl = *iter;
    // Although this method returns void, the method it calls on the skeleton
    // return an int. Currently, this is a limitation of HPC++
    int dummy;
    if ((*pidl).skp) {
      cout << "UsesSolutionVectorSkel::call sendSolutionVector "  << endl;
      cout.flush();
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy, SEND_SOLUTION_VECTOR_ID, *sls);
    } else {
      cout << "UsesSolutionVectorSkel::registerListener::Unbound ProvidesPort Proxy !! \n";
    }
  }
}

void UsesSolutionVectorSkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;
    registerUsesPortType("SolutionVector_idl", 
					*(new UsesSolutionVectorSkel()));
  }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesSolutionVectorSkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesSolutionVectorSkel* p, int count){}


