#include "ProvidesSparseLinearSystemSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool ProvidesSparseLinearSystemSkel::registerFlag = false;

ProvidesSparseLinearSystemSkel::ProvidesSparseLinearSystemSkel(Port *executingPort): PortSkel(executingPort) {}

int ProvidesSparseLinearSystemSkel :: sendSparseLinearSystem(SparseLinearSystem sls) {
  cout << "ProvidesSparseLinearSystemSkel::sendSparseLinearSystem called !!  " << endl;
  cout.flush();
  ProvidesSparseLinearSystem *port = dynamic_cast<ProvidesSparseLinearSystem *>(portPointer); 
  int result = port->sendSparseLinearSystem(new SparseLinearSystem(sls));
  return result;
}


void ProvidesSparseLinearSystemSkel :: registerSelf () {
  if (!registerFlag) {
    registerFlag = true;

    hpcxx_registerClass((ProvidesSparseLinearSystemSkel *)NULL);
    hpcxx_register(&ProvidesSparseLinearSystemSkel::sendSparseLinearSystem, SEND_SPARSE_LINEAR_SYSTEM_ID);
    registerProvidesPortType("SparseLinearSystem_idl",
					    *(new ProvidesSparseLinearSystemSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.

void hpcxx_pack(HPCxx_Buffer& b, ProvidesSparseLinearSystemSkel* p, int count){}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesSparseLinearSystemSkel* p, int count){}

#ifdef ORIG
// register all the port types and their member functions.
void registerSparseLinearSystemPorts(){
  hpcxx_registerClass((ProvidesSparseLinearSystemSkel *)NULL);
  hpcxx_register(&ProvidesSparseLinearSystemSkel::sendSparseLinearSystem, SEND_SPARSE_LINEAR_SYSTEM_ID);
}
#endif
