#include "UsesSparseLinearSystemSkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/Common/SparseLinearSystem.h"

bool UsesSparseLinearSystemSkel::registerFlag = false;

int UsesSparseLinearSystemSkel :: sendSparseLinearSystem(SparseLinearSystem *sls) {

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end();  
      iter++) {
    Port *pidl = *iter;
    int dummy;
    if ((*pidl).skp) {
      cout << "UsesSparseLinearSystemSkel::call sendSparseLinearSystem "  << endl;
      cout.flush();
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy, SEND_SPARSE_LINEAR_SYSTEM_ID, *sls);
    } else {
      cout << "UsesSparseLinearSystemSkel::registerListener::Unbound ProvidesPort Proxy !! \n";
    }
  }
  return 0;
}

void UsesSparseLinearSystemSkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;
    registerUsesPortType("SparseLinearSystem_idl", 
					*(new UsesSparseLinearSystemSkel()));
  }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesSparseLinearSystemSkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesSparseLinearSystemSkel* p, int count){}


