#include "ProvidesSplibParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesSplibParms.h"
#include <string.h>

bool ProvidesSplibParmsSkel::registerFlag = false;



ProvidesSplibParmsSkel::ProvidesSplibParmsSkel(Port *executingPort)
 : PortSkel(executingPort) {}

int
ProvidesSplibParmsSkel :: sendSplibParms(SplibParms sls) {
const char *xfn = "ProvidesSplibParmsSkel :: sendSplibParms";

    cout << xfn << " called." << endl << flush;

    ProvidesSplibParms *port = dynamic_cast<ProvidesSplibParms *>(portPointer); 

    int result = port->sendSplibParms(new SplibParms(sls));
    return result;
}

int
ProvidesSplibParmsSkel::start() {
const char *xfn = "ProvidesSplibParmsSkel::start";

    cout << xfn << " called." << endl << flush;

    ProvidesSplibParms *port = dynamic_cast<ProvidesSplibParms *>(portPointer); 

    return port->start();
}

int
ProvidesSplibParmsSkel::stop() {
const char *xfn = "ProvidesSplibParmsSkel::stop";

    cout << xfn << " called." << endl << flush;

    ProvidesSplibParms *port = dynamic_cast<ProvidesSplibParms *>(portPointer); 

    return port->stop();
}

int
ProvidesSplibParmsSkel::kill() {
const char *xfn = "ProvidesSplibParmsSkel::kill";

    cout << xfn << " called." << endl << flush;

    ProvidesSplibParms *port = dynamic_cast<ProvidesSplibParms *>(portPointer); 

    return port->kill();
}

HPCxx_String
ProvidesSplibParmsSkel::getOutputURL() {
const char *xfn = "ProvidesSplibParmsSkel::getOutputURL";

    cout << xfn << " called." << endl << flush;

    ProvidesSplibParms *port = dynamic_cast<ProvidesSplibParms *>(portPointer); 

    char *returnVal = port->getOutputURL();
    char *returnValue = new char[strlen(returnVal)+1];
    strcpy(returnValue,returnVal);
    HPCxx_String *urlValue = new HPCxx_String(returnValue);
    return *urlValue;
}

void ProvidesSplibParmsSkel::registerSelf () {

    if (!registerFlag) {

        registerFlag = true;

        hpcxx_registerClass((ProvidesSplibParmsSkel *)NULL);
        hpcxx_register(&ProvidesSplibParmsSkel::sendSplibParms,
         SEND_SPLIB_PARMS_ID);
        hpcxx_register(&ProvidesSplibParmsSkel::start, SPLIB_PARMS_START_ID);
        hpcxx_register(&ProvidesSplibParmsSkel::stop, SPLIB_PARMS_STOP_ID);
        hpcxx_register(&ProvidesSplibParmsSkel::kill, SPLIB_PARMS_KILL_ID);
        hpcxx_register(&ProvidesSplibParmsSkel::getOutputURL, SPLIB_PARMS_GETOUTPUTURL_ID);
        registerProvidesPortType("SplibParms_idl",
         *(new ProvidesSplibParmsSkel(NULL)));    
    }
}



// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesSplibParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesSplibParmsSkel* p, int count) {
    assert(0);
}
