// -*-c++-*-
#ifndef _PROVIDES_SPLIB_PARMS_SKEL_H
#define _PROVIDES_SPLIB_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../../../components/application/lsa/Splib/SplibParms.h"
#include "../PORTS_REGISTRATION_ID.h"



// The provides port that calls the executing port
// to implement the method declared in the idl



class Port;
class HPCxx_String;


class ProvidesSplibParmsSkel : public PortSkel {

    public:

      ProvidesSplibParmsSkel(Port *executingPort);
      int sendSplibParms(SplibParms sls);
      int start();
      int stop();
      int kill();
      HPCxx_String getOutputURL();

    /*
     * Static
     */
      
    private:

      static bool registerFlag;  

    public:

        static int registrationID() { return PROVIDES_SPLIB_PARMS_SKEL_ID; }
        // port registration
        static void registerSelf ();
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesSplibParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesSplibParmsSkel* p, int count);
void registerSplibParmsPorts();



#endif // _PROVIDES_SPLIB_PARMS_SKEL_H
