#include "UsesSplibParmsSkel.h"
#include <hpcxx.h>

#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/Splib/SplibParms.h"

bool UsesSplibParmsSkel::registerFlag = false;

int
UsesSplibParmsSkel::sendSplibParms(SplibParms *sls) {
const char *xfn = "UsesSplibParmsSkel::sendSplibParms";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SEND_SPLIB_PARMS_ID, *sls);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesSplibParmsSkel::start() {
const char *xfn = "UsesSplibParmsSkel::start";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SPLIB_PARMS_START_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesSplibParmsSkel::stop() {
const char *xfn = "UsesSplibParmsSkel::stop";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SPLIB_PARMS_STOP_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesSplibParmsSkel::kill() {
const char *xfn = "UsesSplibParmsSkel::kill";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SPLIB_PARMS_KILL_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

char*
UsesSplibParmsSkel::getOutputURL() {
const char *xfn = "UsesSplibParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             SPLIB_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}

void UsesSplibParmsSkel::registerSelf () {
    if (!registerFlag) {
        registerFlag = true;
        registerUsesPortType("SplibParms_idl", *(new UsesSplibParmsSkel()));
    }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesSplibParmsSkel* p, int count) {}
void hpcxx_unpack(HPCxx_Buffer& b, UsesSplibParmsSkel* p, int count){}


