// -*-c++-*-
#ifndef CCAT_STRING_IDL_H
#define CCAT_STRING_IDL_H

#include "../../ccacore/Port.h"
#include "../../ccacore/UsesPort.h"
#include "../../ccacore/ProvidesPort.h"
#include "../../ccacore/PortSkelUses.h"
#include "../../ccacore/PortSkel.h"
#include "../../util/MyHPCxx_GlobalPtr.h"
#include "ProvidesString_idlPort.h"
#include "UsesString_idlPort.h"
#include "string_idl.h"
#include "../PORTS_REGISTRATION_ID.h"
#include <iostream.h>
#include <string>

// need to define these in a
// different place.
// FIXME FIXME 
extern const char *PORT_PACKAGE_STRING;

// -------------------- Provides String ----------------------

class CCATProvidesString_idlSkel: public PortSkel {
public:
  CCATProvidesString_idlSkel(Port *executingPort): PortSkel(executingPort) {}
  static int registrationID() { return STRING_IDL_SKEL_ID; }

  // hps: helloWorld providesPort String
  // portPointer: is memeber of the PortSkel class
  // this method is invoked remotely.
  int setString(HPCxx_String hps){
    char *s = (char *) hps; 
    ProvidesString_idlPort *port = (ProvidesString_idlPort *) portPointer;
    port->setString(s);
    return 0;  
  }
  // "hpcxx_register" self and also register to the port factory. hpcxx_register 
  // is required for remote calls using hpcxx remote invocation mechanism, while 
  // the port factory registration is required so that a component can
  // instantiate port objects based on port name/type-name.
  static void registerSelf ();

private:
  static bool registerFlag;
};


// -------------------- Uses String ----------------------
// for uses port the framework manufactures
// its own implementation objects.

class CCATUsesString_idlSkel: public UsesString_idlPort {
public:
  CCATUsesString_idlSkel(): UsesString_idlPort()  {
  }
  CCATUsesString_idlSkel(Port *): UsesString_idlPort(){
  }
  // this is a local method invocation
  int setString(char *s);

  // Register self to the port factory. The port factory registration is
  // required so that a component can instantiate port objects based on port
  // name/type-name. hpcxx_register is not required as remote calls are never
  // made on uses ports.
  static void registerSelf ();

private:
  static bool registerFlag;
};


// ---------------------------------------------------------------
// dummy packs... never called because we don't move skels.

void hpcxx_pack(HPCxx_Buffer& b, CCATUsesString_idlSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, CCATUsesString_idlSkel* p, int count);
void hpcxx_pack(HPCxx_Buffer& b, CCATProvidesString_idlSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, CCATProvidesString_idlSkel* p, int count);

#endif



