#include "ProvidesSuperLUParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesSuperLUParms.h"



bool ProvidesSuperLUParmsSkel::registerFlag = false;



ProvidesSuperLUParmsSkel::ProvidesSuperLUParmsSkel(Port *executingPort) 
  : PortSkel(executingPort) {}

int
ProvidesSuperLUParmsSkel::sendSuperLUParms(SuperLUParms bip) {

  cout << "ProvidesSuperLUParmsSkel::sendSuperLUParms called !!" << endl;

  ProvidesSuperLUParms *port
    = dynamic_cast<ProvidesSuperLUParms *>(portPointer); 

  int result = port->sendSuperLUParms(&bip);

  return result;
}

int
ProvidesSuperLUParmsSkel::start() {
  const char *xfn = "ProvidesSuperLUParmsSkel::start";

  cout << xfn << " called." << endl << flush;

  ProvidesSuperLUParms *port = dynamic_cast<ProvidesSuperLUParms *>(portPointer); 

  return port->start();
}

int
ProvidesSuperLUParmsSkel::stop() {
  const char *xfn = "ProvidesSuperLUParmsSkel::stop";

  cout << xfn << " called." << endl << flush;

  ProvidesSuperLUParms *port = dynamic_cast<ProvidesSuperLUParms *>(portPointer); 

  return port->stop();
}

int
ProvidesSuperLUParmsSkel::kill() {
  const char *xfn = "ProvidesSuperLUParmsSkel::kill";

  cout << xfn << " called." << endl << flush;

  ProvidesSuperLUParms *port = dynamic_cast<ProvidesSuperLUParms *>(portPointer); 

  return port->kill();
}

HPCxx_String
ProvidesSuperLUParmsSkel::getOutputURL() {
const char *xfn = "ProvidesSuperLUParmsSkel::getOutputURL";

    cout << xfn << " called." << endl << flush;

    ProvidesSuperLUParms *port = dynamic_cast<ProvidesSuperLUParms *>(portPointer); 

    char *returnVal = port->getOutputURL();
    char *returnValue = new char[strlen(returnVal)+1];
    strcpy(returnValue,returnVal);
    HPCxx_String *urlValue = new HPCxx_String(returnValue);
    return *urlValue;
}

void
ProvidesSuperLUParmsSkel::registerSelf() {

  if (!registerFlag) {

    registerFlag = true;

    hpcxx_registerClass((ProvidesSuperLUParmsSkel *) NULL);
    hpcxx_register(&ProvidesSuperLUParmsSkel::sendSuperLUParms,
		   SEND_SUPER_LU_PARMS_ID);
    hpcxx_register(&ProvidesSuperLUParmsSkel::stop,
		   SUPER_LU_PARMS_STOP_ID);
    hpcxx_register(&ProvidesSuperLUParmsSkel::start,
		   SUPER_LU_PARMS_START_ID);
    hpcxx_register(&ProvidesSuperLUParmsSkel::kill,
		   SUPER_LU_PARMS_KILL_ID);
    hpcxx_register(&ProvidesSuperLUParmsSkel::getOutputURL, SUPER_LU_PARMS_GETOUTPUTURL_ID);


    registerProvidesPortType("SuperLUParms_idl",
			     *(new ProvidesSuperLUParmsSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesSuperLUParmsSkel* p, int count) {
  assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesSuperLUParmsSkel* p, int count) {
  assert(0);
}

#ifdef ORIG
// register all the port types and their member functions.
//  void registerSuperLUParmsPorts(){
//    hpcxx_registerClass((ProvidesSuperLUParmsSkel *)NULL);
//    hpcxx_register(&ProvidesSuperLUParmsSkel::sendSuperLUParms, SEND_SUPER_LU_PARMS_ID);
//    hpcxx_register(&ProvidesSuperLUParmsSkel::start, SUPER_LU_PARMS_START_ID);
//    hpcxx_register(&ProvidesSuperLUParmsSkel::stop, SUPER_LU_PARMS_STOP_ID);
//    hpcxx_register(&ProvidesSuperLUParmsSkel::kill, SUPER_LU_PARMS_KILL_ID);
//  }
#endif
