#include "UsesSuperLUParmsSkel.h"
#include <hpcxx.h>



#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/SuperLU/SuperLUParms.h"



bool UsesSuperLUParmsSkel::registerFlag = false;

int UsesSuperLUParmsSkel::sendSuperLUParms(SuperLUParms *sls) {

  for (vector<Port*>::iterator iter = providerList.begin();
       iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {

      cout << "UsesSuperLUParmsSkel::call sendSuperLUParms " << endl;

      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    SEND_SUPER_LU_PARMS_ID, *sls);

    } else {

      cout << "UsesSuperLUParmsSkel::registerListener::Unbound"
	" ProvidesPort Proxy !! \n" << endl;
      assert(0);
    }
  }

  return 0;
}

int
UsesSuperLUParmsSkel::start() {
  const char *xfn = "UsesSuperLUParmsSkel::start";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    SUPER_LU_PARMS_START_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

int
UsesSuperLUParmsSkel::stop() {
  const char *xfn = "UsesSuperLUParmsSkel::stop";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    SUPER_LU_PARMS_STOP_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

int
UsesSuperLUParmsSkel::kill() {
  const char *xfn = "UsesSuperLUParmsSkel::kill";

  for(vector<Port*>::iterator iter = providerList.begin();
      iter != providerList.end(); iter++) {

    Port *pidl = *iter;
    int dummy;

    if ((*pidl).skp) {
      cout << xfn << " called." << endl << flush;
      hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
		    SUPER_LU_PARMS_KILL_ID);
    } else {
      cout << xfn << "unbound Provides Port Proxy." << endl << flush;
    }
  }

  return 0;
}

char*
UsesSuperLUParmsSkel::getOutputURL() {
    const char *xfn = "UsesSuperLUParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             SUPER_LU_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}


void UsesSuperLUParmsSkel::registerSelf () {
  if (!registerFlag) {
    registerFlag = true;
    registerUsesPortType("SuperLUParms_idl", 
			 *(new UsesSuperLUParmsSkel()));
  }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesSuperLUParmsSkel* p, int count) {
  assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, UsesSuperLUParmsSkel* p, int count){
  assert(0);
}
