#include "ProvidesTimeStepSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"

bool ProvidesTimeStepSkel::registerFlag = false;

ProvidesTimeStepSkel::ProvidesTimeStepSkel(Port *executingPort): PortSkel(executingPort) {}

int ProvidesTimeStepSkel :: sendTimeStep(TimeStep ts) {
  cout << "ProvidesTimeStepSkel::sendTimeStep called !!  " << endl;
  cout.flush();
  ProvidesTimeStep *port = dynamic_cast<ProvidesTimeStep *>(portPointer); 
  int result = port->sendTimeStep(new TimeStep(ts));
  return result;
}


void ProvidesTimeStepSkel :: registerSelf () {
  if (!registerFlag) {
    registerFlag = true;

    hpcxx_registerClass((ProvidesTimeStepSkel *)NULL);
    hpcxx_register(&ProvidesTimeStepSkel::sendTimeStep, SEND_TIME_STEP_ID);
    registerProvidesPortType("TimeStep_idl",
					    *(new ProvidesTimeStepSkel(NULL)));    
  }
}

// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesTimeStepSkel* p, int count){}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesTimeStepSkel* p, int count){}
