#include "ProvidesTimeStepParmsSkel.h"
#include <hpcxx.h>
#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "ProvidesTimeStepParms.h"



bool ProvidesTimeStepParmsSkel::registerFlag = false;



ProvidesTimeStepParmsSkel::ProvidesTimeStepParmsSkel(Port *executingPort) 
 : PortSkel(executingPort) {}

int
ProvidesTimeStepParmsSkel::sendTimeStepParms(TimeGenParms tsp) {

    cout << "ProvidesTimeStepParmsSkel::sendTimeStepParms called !!" << endl;

    ProvidesTimeStepParms *port
     = dynamic_cast<ProvidesTimeStepParms *>(portPointer); 

    int result = port->sendTimeStepParms(&tsp);

    return result;
}

int
ProvidesTimeStepParmsSkel::start() {
const char *xfn = "ProvidesTimeStepParmsSkel::start";

    cout << xfn << " called." << endl << flush;

    ProvidesTimeStepParms *port = dynamic_cast<ProvidesTimeStepParms *>(portPointer); 

    return port->start();
}

int
ProvidesTimeStepParmsSkel::stop() {
const char *xfn = "ProvidesTimeStepParmsSkel::stop";

    cout << xfn << " called." << endl << flush;

    ProvidesTimeStepParms *port = dynamic_cast<ProvidesTimeStepParms *>(portPointer); 

    return port->stop();
}

int
ProvidesTimeStepParmsSkel::kill() {
const char *xfn = "ProvidesTimeStepParmsSkel::kill";

    cout << xfn << " called." << endl << flush;

    ProvidesTimeStepParms *port = dynamic_cast<ProvidesTimeStepParms *>(portPointer); 

    return port->kill();
}

HPCxx_String
ProvidesTimeStepParmsSkel::getOutputURL() {
const char *xfn = "ProvidesTimeStepParmsSkel::getOutputURL";

    cout << xfn << " called." << endl << flush;

    ProvidesTimeStepParms *port = dynamic_cast<ProvidesTimeStepParms *>(portPointer); 

    char *returnVal = port->getOutputURL();
    char *returnValue = new char[strlen(returnVal)+1];
    strcpy(returnValue,returnVal);
    HPCxx_String *urlValue = new HPCxx_String(returnValue);
    return *urlValue;
}

void ProvidesTimeStepParmsSkel::registerSelf () {

    if (!registerFlag) {

        registerFlag = true;

	   int t;
        t = hpcxx_registerClass((ProvidesTimeStepParmsSkel *)NULL);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t1: " << t << endl;
        t = hpcxx_register(&ProvidesTimeStepParmsSkel::sendTimeStepParms,
					  SEND_TIME_STEP_PARMS_ID);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t2: " << t << endl;
        t = hpcxx_register(&ProvidesTimeStepParmsSkel::start, TIME_STEP_PARMS_START_ID);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t3: " << t << endl;
        t = hpcxx_register(&ProvidesTimeStepParmsSkel::stop, TIME_STEP_PARMS_STOP_ID);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t4: " << t << endl;
        t = hpcxx_register(&ProvidesTimeStepParmsSkel::kill, TIME_STEP_PARMS_KILL_ID);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t5: " << t << endl;
        t = hpcxx_register(&ProvidesTimeStepParmsSkel::getOutputURL, TIME_STEP_PARMS_GETOUTPUTURL_ID);
	   cout << "ProvidesTimeStepParmsSkel::registerSelf: t6: " << t << endl;
        registerProvidesPortType("TimeStepParms_idl",
							  *(new ProvidesTimeStepParmsSkel(NULL)));    
    }
}


// these methods will not be called
// we never move skels around.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesTimeStepParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesTimeStepParmsSkel* p, int count) {
    assert(0);
}

