// -*-c++-*-
#ifndef _PROVIDES_TIME_STEP_PARMS_SKEL_H
#define _PROVIDES_TIME_STEP_PARMS_SKEL_H



#include "../../ccacore/PortSkel.h"
#include "../../../components/application/lsa/TimeGen/TimeGenParms.h"
#include "../PORTS_REGISTRATION_ID.h"



class Port;
class HPCxx_String;

// The provides port that calls the executing port
// to implement the method declared in the idl

class ProvidesTimeStepParmsSkel : public PortSkel {

    public:

        ProvidesTimeStepParmsSkel(Port *executingPort);
        int sendTimeStepParms(TimeGenParms tsp);
        int start();
        int stop();
        int kill();
        HPCxx_String getOutputURL();
  
    public:

        // port registration
        static void registerSelf ();
        static int registrationID() { return PROVIDES_TIME_STEP_PARMS_SKEL_ID; }

    private:

        static bool registerFlag;  
};



// These packs are never called because we don't move skels.
void hpcxx_pack(HPCxx_Buffer& b, ProvidesTimeStepParmsSkel* p, int count);
void hpcxx_unpack(HPCxx_Buffer& b, ProvidesTimeStepParmsSkel* p, int count);


#endif
