#include "UsesTimeStepParmsSkel.h"
#include <hpcxx.h>



#include "../PORTS_REGISTRATION_ID.h"
#include "../../ccacore/RegisterType.h"
#include "../../../components/application/lsa/TimeGen/TimeGenParms.h"



bool UsesTimeStepParmsSkel::registerFlag = false;

int UsesTimeStepParmsSkel::sendTimeStepParms(TimeGenParms *tsp) {

    for (vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {

            cout << "UsesTimeStepParmsSkel::call sendTimeStepParms " << endl;

            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             SEND_TIME_STEP_PARMS_ID, *tsp);

        } else {

            cout << "UsesTimeStepParmsSkel::registerListener::Unbound"
             " ProvidesPort Proxy !! \n" << endl;
            assert(0);
        }
    }

    return 0;
}

int
UsesTimeStepParmsSkel::start() {
const char *xfn = "UsesTimeStepParmsSkel::start";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             TIME_STEP_PARMS_START_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesTimeStepParmsSkel::stop() {
const char *xfn = "UsesTimeStepParmsSkel::stop";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             TIME_STEP_PARMS_STOP_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

int
UsesTimeStepParmsSkel::kill() {
const char *xfn = "UsesTimeStepParmsSkel::kill";

    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        int dummy;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, dummy,
             TIME_STEP_PARMS_KILL_ID);
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
        }
    }

    return 0;
}

char*
UsesTimeStepParmsSkel::getOutputURL() {
const char *xfn = "UsesTimeStepParmsSkel::getOutputURL";

    char *returnValue = NULL;
    for(vector<Port*>::iterator iter = providerList.begin();
     iter != providerList.end(); iter++) {

        Port *pidl = *iter;
        HPCxx_String urlValue;

        if ((*pidl).skp) {
            cout << xfn << " called." << endl << flush;
            hpcxx_minvoke((HPCxx_GlobalPtr<PortSkel> *)(*pidl).skp, urlValue,
             TIME_STEP_PARMS_GETOUTPUTURL_ID);
	    returnValue = new char[urlValue.length()];
	    returnValue = (char*)urlValue;
        } else {
            cout << xfn << "unbound Provides Port Proxy." << endl << flush;
	    returnValue = "error while getting URL";
        }
    }

    return returnValue;
}

void UsesTimeStepParmsSkel::registerSelf () {
    if (!registerFlag) {
        registerFlag = true;
        registerUsesPortType("TimeStepParms_idl", 
         *(new UsesTimeStepParmsSkel()));
    }
}

// these methods will never be called
// as we never move skels around
void hpcxx_pack(HPCxx_Buffer& b, UsesTimeStepParmsSkel* p, int count) {
    assert(0);
}
void hpcxx_unpack(HPCxx_Buffer& b, UsesTimeStepParmsSkel* p, int count){
    assert(0);
}
