#include "EnvObj.h"
#include <string.h>

extern "C" char *strdup(const char *);

EnvObj::EnvObj() {
  mytable = new std::map <const char*, char*, ltstr>;
}

EnvObj::~EnvObj() {
  // Iterate over the elements and delete all the names and values stored in the
  // map. 
  std::map<const char*, char*, ltstr>::iterator iter;  
  for (iter = mytable->begin(); iter != mytable->end(); iter++) {
    free ((void *)iter->first);
    free ((void *)iter->second);
  } 
  delete mytable;
}

void EnvObj::put (const char* name, char* val) {
  // As per our semantics, copy the name and value before storing in the map. 
  (*mytable)[strdup(name)] = strdup(val);
}

char *EnvObj::get (const char * name) {
  return (*mytable) [name];
}

void EnvObj::getAllNames (char ** names, int &len) {
  std::map<const char*, char*, ltstr>::iterator iter;
  int i = 0;

  // Iterate over the map elements and in the end, set the len to be the size of
  // the map.
  for (iter = mytable->begin(); (iter != mytable->end()) && (i < len); iter++, i++) {
    names[i] = (char *)iter->first;
  }
  len = i;
}
