// -*-c++-*-
#ifndef __ENV_OBJ_H
#define __ENV_OBJ_H

#include <map>
#include <string.h>
#include <iostream.h>

// The environment object to be sent to the creation service and the registry
// service. It maintains a set of name - value pairs that can be queried by the
// name.
// Author: Shridhar Diwan

class EnvObj {
public:
  EnvObj();
  virtual ~EnvObj();
  // Adds the given name - value pair to the environment object
  virtual void put (const char* name, char* val);

  // Returns the value associated with a given name
  virtual char *get (const char * name);

  //  Gets all the names stored in the environment object
  virtual void getAllNames (char ** names, int &len);

private:
  // The "Compare" object required by the STL map template
  struct ltstr {
    bool operator()(const char* s1, const char* s2) const {
      return strcmp(s1, s2) < 0;
    }
  };

  // The internal STL map
  std::map <const char*, char*, ltstr> *mytable;
};

#endif //__ENV_OBJ_H
