#ifndef __HPCXX_STRING_H_
#define __HPCXX_STRING_H_

#include <HPCxx_Buffer.h>
#include <iostream.h>
#include <strstream.h>

class HPCxx_String {
private:
  char *val;
  int len, room;

  void makeRoom(int len);

public:
  HPCxx_String();
  HPCxx_String(const char *v);
  HPCxx_String(const HPCxx_String &source);
  HPCxx_String& operator=(const HPCxx_String &source);
  HPCxx_String& operator= (const char *buf);
  int operator==(const HPCxx_String& s) const;
  static int registrationID()  { return 352; }
  operator char *() { return val; }
  int length () const { return len; }
  ~HPCxx_String();
    
  friend void hpcxx_pack(HPCxx_Buffer&, HPCxx_String*, int);
  friend void hpcxx_unpack(HPCxx_Buffer&, HPCxx_String*, int);
  friend ostream& operator<< (ostream &, const HPCxx_String &);

};

ostream &operator<< (ostream &, const HPCxx_String &);

#endif // __HPCXX_STRING_H_


