#include "Info.h"
#include <string.h>

extern "C" char *strdup(const char *);

Info::Info()
{
  sTable = new stringTable;
  iTable = new infoTable;
}

Info::Info(const Info &info)
{
  sTable = new stringTable;
  iTable = new infoTable;

  for (SI = info.sTable->begin(); SI != info.sTable->end(); SI++) {
      putValue(SI->first, SI->second);
  } 
  for (II = info.iTable->begin(); II != info.iTable->end(); II++) {
      putInfo(II->first, *II->second);
  }
}
  

Info::~Info() {
  // Iterate over the elements and delete all the names and values stored in the
  // map. 
 
  for (SI = sTable->begin(); SI != sTable->end(); SI++) {
    free ((void *)SI->first);
    free ((void *)SI->second);
  } 
  delete sTable;
  for (II = iTable->begin(); II != iTable->end(); II++) {
    free ((void *)II->first);
    delete(II->second);
  } 
  delete iTable;
}

void Info::putValue (const char* name, char* val) {
  // As per our semantics, copy the name and value before storing in the map. 
  sTable->insert(SV(strdup(name), strdup(val)));
;
}

void Info::putInfo (const char* name, Info val) {
  // As per our semantics, copy the name and value before storing in the map. 
  iTable->insert(IV(strdup(name), new Info(val)));
}

char **Info::getValue (const char * name) {
  char **retval;
  int count=0, count2=0;
  
  std::pair<stringIt,stringIt> SIpair = sTable->equal_range((char *)name);

  //first get how many there are
  for (SI=SIpair.first; SI!=SIpair.second; SI++, ++count);

  //make some storage for the pointers
  retval=new char*[count];
  for (SI=SIpair.first; SI!=SIpair.second; SI++) {
    retval[count2++]=SI->second;
  }
  
  return retval;
}

Info *Info::getInfo(const char *name)
{
  Info *retval;
  int count=0, count2=0;
  
  std::pair<infoIt,infoIt> IIpair = iTable->equal_range((char *)name);

  //first get how many there are
  for (II=IIpair.first; II!=IIpair.second; II++, ++count);

  //make some storage for the pointers
  retval=new Info[count];
  for (II=IIpair.first; II!=IIpair.second; II++) {
    retval[count2++]=*II->second;
  }
  
  return retval;
}

