// -*-c++-*-

#ifndef _INFO_H__
#define _INFO_H__
#include <map>
#include <string.h>
#include <iostream.h>

struct ltstr {
  bool operator()(const char* s1, const char* s2) const 
    {
      return strcmp(s1, s2) < 0;
    }
};

class Info;
  

#define SV(a, b) std::multimap<const char *, char *, ltstr>::value_type((a), (b))
#define IV(a, b) std::multimap<const char *, Info *, ltstr>::value_type((a), (b))

typedef std::multimap<const char *, char *, ltstr> stringTable;
typedef std::multimap<const char *, char *, ltstr>::iterator stringIt;

typedef std::multimap<const char *, Info *, ltstr> infoTable;
typedef std::multimap<const char *, Info *, ltstr>::iterator infoIt;

// The Info object used to represent XML docs in the form of name/value pairs
// and name/list pairs.
// Author: Benjamin Temko


class Info {
public:
  Info();
  Info(const Info &info);

  virtual ~Info();
    
  // Adds the given name - value pair to the environment object
  virtual void putValue(const char* name, char* val);
    
  // Adds the given name - value pair to the environment object
  virtual void putInfo(const char* name, Info val);
    
  // Returns the value associated with a given name
  virtual char **getValue (const char * name);

  // Returns the Info Object associated with a given name
  virtual Info *getInfo (const char * name);
    


private:

  // The internal STL multimap for the name/string pairs, and iterator
  infoTable *iTable;
  infoIt II;
  
  // The internal STL multimap for the name/Info pairs, and iterator
  stringTable *sTable;
  stringIt SI;

};
#endif // _INFO_H__
