#include "MyArray.h"
#include <hpcxx_rts.h>
#include "hpcxx_byte.h"
#include <string.h>

MyArray::MyArray(){len = 0; val = NULL;}

MyArray::MyArray(const MyArray &source)  {
  len = source.len;
  val = new float[len];
  for(int i = 0; i < len; i++) val[i] = source.val[i];
}

MyArray& MyArray::operator=(const MyArray &source)  {
  len = source.len;
  if(val) delete[] val;
  val = new float[len];
  for(int i = 0; i < len; i++) val[i] = source.val[i];
  return *this;
}

MyArray::~MyArray() {
  if (val) delete[] val;
}

void hpcxx_pack(HPCxx_Buffer& b, MyArray* s, int i)  {

  for (int j = 0; j < i; j++) {
    hpcxx_byte *two = new hpcxx_byte();
    two->byte = 15;
    hpcxx_pack(b, two, 1);
    hpcxx_pack(b, &(s[j].len), 1);

    if (s[j].len > 0) {
      hpcxx_pack(b, s[j].val, s[j].len);
    }

  }
}

void hpcxx_unpack(HPCxx_Buffer& b, MyArray* s, int i)
{
  for (int j = 0; j < i; j++) {
    int l;
    hpcxx_byte *two = new hpcxx_byte();
    hpcxx_unpack(b, two, 1);
    if (two->byte != 15) {
     cout << "Error !! in hpcxx_unpack() ... " <<endl;
     cout << "The first byte of MyArray is: " << (int)(two->byte) << endl;
     cout << "exiting ... : " << endl << endl;
     exit(-1);
    }
    hpcxx_unpack(b, &l, 1);
    s[j].len = l;
    if(s[j].val) delete[] s[j].val;
    s[j].val = new float[l];
    if (l > 0) {
         hpcxx_unpack(b, s[j].val, l);
    }
  }
}

