#ifndef MyGlobalPointerPack_cc
#define MyGlobalPointerPack_cc

#include "MyHPCxx_GlobalPtr.h"
 
template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count) {
  HPCxx_String serClass("nexusrmi.Nexusize");

   cout << "MyGlobalPointerPack() packing " << endl;
  fflush(NULL);
  int sz = 
    count * (globus_nexus_sizeof_startpoint((*(r[0])).contextID_, 1) + 1000);

  if(globus_nexus_check_buffer_size(buffer.impl_.buffer_, sz, sz, 0, 0) < 0)
    cout << "global pointer pack failed\n" << flush;

  for (int i = 0; i < count; i++) {
    hpcxx_byte byte_5(5);
    hpcxx_byte byte_2(2);
    hpcxx_byte byte_0(0);
    
//     cout << "MyHPCxx_GlobalPtr.C:: destroyIt is: " << (r[i]).getDestroy() << endl;
//     cout.flush();

//     cout << "MyHPCxx_GlobalPtr.C:: getIsItNULL is: " << (r[i]).getIsItNULL() << endl;
//     cout.flush();

    if ((r[i]).getIsItNULL()) {
	 cout << "MyHPCxxGlobalPointerPack: packing a null pointer " << endl;
	 hpcxx_pack(buffer,&byte_0,1); 
	 break;
    }
    // nexusrmi packs byte 5 to indicate remote stub
    hpcxx_pack(buffer,&byte_5,1); 
    
    //pack the fullyQualifiedFileName
    HPCxx_String FQN((r[i]).getFullyQualifiedFileName());
    cout << "MyHPCxx_GlobalPtr.cc:: FQN being sent back is " << FQN  << endl << flush;
    hpcxx_pack(buffer, &FQN, 1);
    
     cout <<" Packing the startpoint\n" << flush;
    // pack the startpoint   
    hpcxx_pack(buffer, &byte_2, 1);

    HPCxx_ContextID sp;
    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
    globus_nexus_startpoint_copy(&sp,  gr.contextID_);
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , &sp, 1);
    
    hpcxx_pack(buffer,&serClass,1);
    // 3. The code base
    hpcxx_pack(buffer,&byte_0,1);
     cout << "MyHPCxxGlobalPointerPack: packing RemoteReference\n" << flush;
  }
}

template <class T>
void hpcxx_unpack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count) {

  cout << "MyHPCxx_GlobalPtr.cc We are unpacking a global pointer!" << endl; 
  cout.flush();
  for (int i = 0; i < count; i++) {

    hpcxx_byte *k = new hpcxx_byte();
    hpcxx_unpack(buffer,k,1); 

    // FIXME take care of the case when the first byte is a null
    // indicating that it is a null global pointer
    // FIXME FIXME FIXME ... 

    if (k->byte != 5 && k->byte != 6 ) {
      cerr << "MyHPCxx_GlobalPtr.cc:: Error unpacking MyHPCxx_GlobaPtr! byte is "  << k->byte << endl;
      cout << "MyHPCxx_GlobalPtr.cc:: Error unpacking MyHPCxx_GlobaPtr! byte is "  << k->byte << endl;
      cout.flush();
      //assert(0);
    }
  
    cout << "MyHPCxx_GlobalPtr.cc : unpack the FQN of the object " << endl; 
    cout.flush();
    HPCxx_String FQN;
    hpcxx_unpack(buffer, &FQN, 1);     
    cout << "unpack got a global ptr to " << FQN << endl;
    cout.flush();
    r->setFullyQualifiedFileName(FQN);
    //unpack the startpoint
  
    hpcxx_unpack(buffer, k, 1);
    if (k->byte != 2) {
      cerr << "MyHPCxx_GlobalPtr.cc Error unpacking HPCxx_GlobaPtr!(2)" << endl;
      cout << "MyHPCxx_GlobalPtr.cc Error unpacking HPCxx_GlobaPtr!(2)" << endl;
      cout.flush();
    }
  
    HPCxx_GlobalRefImpl<T> &gr = *(r[i]);
    gr.contextID_ = new nexus_startpoint_t;
    nexus_get_startpoint(buffer.impl_.buffer_,gr.contextID_, 1);
    //    nexus_get_int(buffer.impl_.buffer_, &(gr.offset_), 1 );
    gr.offset_ = 0;
    gr.localPtr_ = NULL;
    gr.GlobalEndpoint = NULL;
    
    HPCxx_String serClass("nexusrmi.Nexusize    ");
    hpcxx_unpack(buffer, &serClass, 1);
    
    hpcxx_unpack(buffer, k, 1);
    if (k->byte != 0) {
      cerr << "MyHPCxx_GlobalPtr.cc:: Error unpacking MyHPCxx_GlobaPtr!(3)" << endl;
      cout << "MyHPCxx_GlobalPtr.cc:: Error unpacking MyHPCxx_GlobaPtr!(3)" << endl;
      cout.flush();
    }

     cout << "MyHPCxx_GlobalPtr.cc::unpack() UnPacked Startpoint\n" << flush;
  }
}

#endif // MyGlobalPointerPack_cc

