// -*-c++-*-
#ifndef __MY_HPCXX_GLOBAL_POINTER_H_
#define __MY_HPCXX_GLOBAL_POINTER_H_

#include "hpcxx_byte.h"
#include "HPCxx_String.h"
#include <hpcxx_rts.h>
#include <HPCxx_GlobalPtr.h>

template <class T>
class MyHPCxx_GlobalPtr : public HPCxx_GlobalPtr<T> {
public:
  MyHPCxx_GlobalPtr(): HPCxx_GlobalPtr<T>() , isItNULL(false), FQN("NOTSET"), destroyIt(false) {}

  MyHPCxx_GlobalPtr(T *ptr) :  HPCxx_GlobalPtr<T>(ptr),  isItNULL(false), FQN("NOTSET"), destroyIt(false) {}

  MyHPCxx_GlobalPtr(T *ptr, HPCxx_ContextID *sp) 
    : isItNULL(false) , HPCxx_GlobalPtr<T>(ptr, sp), FQN("NOTSET"), destroyIt(false) {}

  MyHPCxx_GlobalPtr(const HPCxx_GlobalPtr<T> &gp) 
    : isItNULL(gp.getIsItNULL()) ,  HPCxx_GlobalPtr<T>(gp), FQN("NOTSET") {
  }
  
  MyHPCxx_GlobalPtr<T>& operator=(MyHPCxx_GlobalPtr<T>& gp) {
    setItAsNULL(gp.getIsItNULL());
    destroyIt = gp.getDestroy();
    gp.setDestroy(false);
    setFullyQualifiedFileName(gp.getFullyQualifiedFileName());
    globalRef_ = gp.globalRef_;
    return(*this);
  }

  void setFullyQualifiedFileName(HPCxx_String name) { FQN = name; }
  void setItAsNULL(bool whatToDo) { 
    this->isItNULL = whatToDo ;
  }
  bool getIsItNULL() {
    return isItNULL;
  }
  void setDestroy(bool whatToDo) {
    destroyIt = whatToDo;
  }
  bool getDestroy() {
    return destroyIt;
  }


  HPCxx_String getFullyQualifiedFileName() { return FQN; }
  static int registrationID() { return 0; }
private:
  HPCxx_String FQN;
  bool isItNULL;
  bool destroyIt;
};

template <class T>
void hpcxx_pack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count);
template <class T>
void hpcxx_unpack(HPCxx_Buffer &buffer, MyHPCxx_GlobalPtr<T> *r, int count);

#include "MyHPCxx_GlobalPtr.cc"

#endif // __MY_GLOBAL_POINTER_PACK_H_
