sub determine_location {
	if ($hostname =~ /^gromit/) {
		$location = "iu-extreme";
	} elsif ($hostname =~ /extreme\.indiana\.edu$/) {
		$location = "iu-extreme";
	} elsif ($hostname =~ /\.cs\.indiana\.edu$/) {
		$location = "iu-cs";
		%path_map = ('/.automount', '/nfs');
	} elsif ($hostname =~ /^steel[0-9]\.ucs\.indiana\.edu/) {
		$location = "steel-ucs";
	} else {
		print STDERR "Unknown location.\n";
	}
}

sub determine_platform {
	if ($w1 =~ /^IRIX/) {
		$os = 'irix';
		$rel = $w3;
		$arch = 'mips';
	} elsif ($w1 eq 'SunOS') {
		$os = 'solaris';
		$rel = $w3 - 3;
		$arch = 'sparc';
	} elsif ($w1 eq 'Linux') {
		$os = 'linux';
#		$w3 =~ /(.*)(-[0-9]+)??$/;
		$w3 =~ /^([0-9]+\.[0-9]+)\.[0-9]+(-[0-9]+)?$/;
		$rel = $1;
		if ($w5 eq "SMP") {
			$arch = $w12;
		} else {
			$arch = $w11;
		}
		if ($arch =~ /i[56]86/) {
			$arch = 'x86';
		}
	} else {
		print STDERR "Unknown OS.\n";
		exit 1;
	}
}
