package eventGenerator;

import ccacore.*;
import idl.eventPort.*;
import ccacore.Services;
import ccacore.Component;
import ccacore.DefaultPortInfo;
import idl.control.ProvidesControlImpl;


public class EventGeneratorComponent implements Component  {
  private Services eventGeneratorCore;
  private EventGeneratorControlInterface controlExec;

  public EventGeneratorComponent(){
  }

  public void setServices(Services cc){
    eventGeneratorCore = cc;
    try {
      eventGeneratorCore.registerUsesPort(new DefaultPortInfo("publish", "EventPort_idl"));
      EventListenerPort eventListenerPort = new EventListenerPort();
      eventGeneratorCore.addProvidesPort(eventListenerPort, new DefaultPortInfo("listen", "EventPort_idl"));

      controlExec = new EventGeneratorControl();
      eventGeneratorCore.addProvidesPort((ProvidesControlImpl)controlExec, new DefaultPortInfo("control", "Control_idl"));
    } catch(Exception e) {
      e.printStackTrace();
      System.out.println("EventGeneratorComponent: unable to register: "+e);
    }
  }

  public int startExecuting() {
    controlExec.letMeKnowWhenToStartExecuting();
    try {
    System.out.println("\n EventGenerator Component:: execute  ");
    UsesEventPort output;
    output = (UsesEventPort)eventGeneratorCore.getPort("publish");
    CCATEvent ccatEvent = new CCATEvent();
	for (int i = 0; i<9; i++) {
	  ccatEvent.setSequenceNum(i);
	  int reply = output.notify(ccatEvent);
	}
    eventGeneratorCore.releasePort("publish");
    System.out.println("\n EventGenerator Component:: execute done ");
    } catch (Exception e) {
      e.printStackTrace();
    }
    return 0;
  }

  public void waitForKill() {
    (new Thread() {
      public void run() {
	final int returnValue = startExecuting();
      }
    }).start();
    controlExec.letMeKnowWhenToKillMyself();
  }
  
}
