
package eventGenerator;

import idl.control.ProvidesControlImpl;

public class EventGeneratorControl extends ProvidesControlImpl implements EventGeneratorControlInterface {

  private boolean killCalled = false;
  private boolean executeCalled = false; 

  public EventGeneratorControl() throws nexusrmi.RemoteException {
    super();
  }

  public int kill() {
    // just return to printerServer runit()
    // and runFinalizers 
    unblockKillCalled(true);
    return 0;
  }
  
  public int startExecuting() {
    unblockExecuteCalled(true);
    return 0;
  }
  
  private synchronized void unblockKillCalled(boolean whatToDo) {
    killCalled = whatToDo;
    try {
      notifyAll();
    } catch (Exception e) {
      e.printStackTrace();
    }

  }
  
  private synchronized void unblockExecuteCalled(boolean whatToDo) {
    executeCalled = whatToDo;
    try {
      notifyAll();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public void letMeKnowWhenToKillMyself() {
    synchronized(this) {
      while(!killCalled) {
	try {
	  wait();
	} catch (Exception e) {
	  e.printStackTrace();
	}
      }
      killCalled = false;
    }
  }

  public void letMeKnowWhenToStartExecuting() {
    synchronized(this) {
      while(!executeCalled) {
	try {
	  wait();
	} catch (Exception e) {
	  e.printStackTrace();
	}
      }
      executeCalled = false;
    }
  }
}
