package eventGenerator;

import ccacore.*;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import registry.*;
import util.EnvObj;
import util.NexusConnectionClient;

public class EventGeneratorServer {

  private static int creationServicePORT = -1024;
  private static String creationServiceHost = null;
  private static String localHost = "DEFAULT";
  public static final String RELEASE = "$Revision: 1.3 $ by $Author: mgovinda $ on $Date: 1999/11/02 08:29:45 $ (GMT)";

  public static void main(String args[]) {
    System.out.println(RELEASE);
    parseCommandLineArgs(args);
    EventGeneratorServer EventGeneratorServer = new EventGeneratorServer();
    EventGeneratorServer.initialize();
    System.runFinalizersOnExit(true);
    System.runFinalization();
  }

  public EventGeneratorServer() {
  }
  
  
  private static void parseCommandLineArgs(String argv[]) {
    System.out.println("\nEventGeneratorServer:: " + argv.length + " CommandLineArgs found ");
    creationServiceHost = argv[0];
    creationServicePORT = Integer.parseInt(argv[1]);
    String blank = " ";
    System.out.println("\nEventGeneratorServer:: " + creationServiceHost + blank + creationServicePORT);
  }
  
  
  public void initialize() {
    Services eventGeneratorCore = null;
    EventGeneratorComponent eventGenerator = new EventGeneratorComponent();
    try {
      eventGeneratorCore = new ServicesImpl();
      eventGenerator.setServices(eventGeneratorCore);
    } catch (Exception e) {
      System.out.println("EventGeneratorServer.java:: unable to set  core "+ e);
    }
    
    try {
      ComponentID eventGeneratorCompID = eventGeneratorCore.getComponentID();
	  ((ComponentIDregistry)eventGeneratorCompID).setName("EVENT_GENERATOR_COMPONENT_ID");
      if (eventGeneratorCore == null) {
	throw new NullPointerException("EventGeneratorServer:: eventGeneratorCore is null !!\n");
      }
      NexusConnectionClient nexusConnectionClient = new NexusConnectionClient();
      nexusConnectionClient.sendMyComponentID(creationServiceHost, creationServicePORT, eventGeneratorCompID);

      // Just waits for  the kill signal.
      // Meanwhile if it gets any requests on
      // the provides port, it works on it.
      // This is part of the execution logic
      // in the execute method of this component.
      // This is just a way to keep this component
      // alive and when the compostion engine does
      // not need this anymore, this should die a
      // graceful death.
      eventGenerator.waitForKill();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }  
}

