package printer;

import ccacore.Services;
import ccacore.Component;
import ccacore.DefaultPortInfo;
import idl.string.ProvidesString;
import idl.control.ProvidesControlImpl;

public class PrinterComponent implements Component {
  private Services printerCore = null;
  private ProvidesString printMe = null;
  private PrinterControlInterface controlExec = null;

  public PrinterComponent() {
  }

  public void setServices(Services cc){
    printerCore = cc;
    try {
      // The provides port for string is
      // implemented by the class PrintMe
      printMe = (ProvidesString)(new PrintMe());
      printerCore.addProvidesPort(printMe, new DefaultPortInfo("stringInPortName", "String_idl"));

      // The provides port for control port
      // is implemented by the class PrinterControl
      controlExec = new PrinterControl();
      printerCore.addProvidesPort((ProvidesControlImpl)controlExec, new DefaultPortInfo("control", "Control_idl"));
    } catch(Exception e) {
      e.printStackTrace();
      System.out.println("PrinterComponent: unable to register"+e);
    }
  }

  // once execute is unblocked
  // it returns to the printerServer
  // runit() method and exits
  // gracefully.
  public void WaitForKill() {
   controlExec.letMeKnowWhenToKillMyself();
  }
}
