
package printer;

import idl.control.ProvidesControlImpl;

public class PrinterControl extends ProvidesControlImpl implements PrinterControlInterface {

  private boolean killCalled = false;

  public PrinterControl() throws nexusrmi.RemoteException {
    super();
  }
  
  public int kill() {
    // just return to printerServer runit()
    // and runFinalizers 
    unblockKillCalled(true);
    return 0;
  }
  
  public int startExecuting() {
    System.out.println("\nPrinterControl::startExecuting():: Why was I called ?? ");
    System.out.println("\nPrinterControl::startExecuting():: Printer just provides !! ");
    return 0;
  }
  
  public synchronized void unblockKillCalled(boolean whatToDo) {
    killCalled = whatToDo;
    try {
      notifyAll();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public void letMeKnowWhenToKillMyself() {
    synchronized(this) {
      while(!killCalled) {
	try {
	  wait();
	} catch (Exception e) {
	  e.printStackTrace();
	}
      }
      killCalled = false;
    }
  }
}
