package printer;

import ccacore.*;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import registry.*;
import util.EnvObj;
import util.NexusConnectionClient;

public class PrinterServer {

  private static int creationServicePORT = -1024;
  private static String creationServiceHost = null;
  private static String localHost = "DEFAULT";
  public static final String RELEASE = "$Revision: 1.9 $ by $Author: mgovinda $ on $Date: 1999/11/02 08:29:46 $ (GMT)";

  public static void main(String args[]) {
    
    System.out.println(RELEASE);
    parseCommandLineArgs(args);
    PrinterServer printerServer = new PrinterServer();
    printerServer.initialize();
    System.runFinalizersOnExit(true);
    System.runFinalization();
  }

    public PrinterServer() {
    }
  
  private static void parseCommandLineArgs(String argv[]) {
//     System.out.println("\nPrinterServer:: " + argv.length + " CommandLineArgs found ");
    creationServiceHost = argv[0];
    creationServicePORT = Integer.parseInt(argv[1]);
    String blank = " ";
    System.out.println("\nPrinterServer::" + creationServiceHost + blank + creationServicePORT);
  }
  
  public void initialize() {
    Services printerCore = null;
    PrinterComponent printer = new PrinterComponent();
    try {
      printerCore = new ServicesImpl();
      printer.setServices(printerCore);
    } catch (Exception e) {
      System.out.println("PrinterServer.java:: unable to set  core "+ e);
    }
    
    try {
      ComponentID printerCompID = printerCore.getComponentID();
      if (printerCore == null) {
	throw new NullPointerException("PrinterServer:: printerCore is null !!\n");
      }
      ((ComponentIDregistry)printerCompID).setName("PRINTER_GENERATOR_COMPONENT_ID");
      NexusConnectionClient nexusConnectionClient = new NexusConnectionClient();
      nexusConnectionClient.sendMyComponentID(creationServiceHost, creationServicePORT, printerCompID);

      // Just waits for  the kill signal.
      // Meanwhile if it gets any requests on
      // the provides port, it works on it.
      // This is part of the execution logic
      // in the execute method of this component.
      // This is just a way to keep this component
      // alive and when the compostion engine does
      // not need this anymore, this should die a
      // graceful death.
      printer.WaitForKill();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }  
}

