package stringGenerator;

import ccacore.Services;
import ccacore.Component;
import ccacore.DefaultPortInfo;
import idl.string.UsesString;
import idl.control.ProvidesControlImpl;


public class StringGeneratorComponent implements Component  {
  private Services stringGeneratorCore;
  private StringGeneratorControlInterface controlExec;

  public StringGeneratorComponent() {
  }
  
  public void setServices(Services cc){
    stringGeneratorCore = cc;
    try {
      stringGeneratorCore.registerUsesPort(new DefaultPortInfo("stringOutPortName", "String_idl")); 
      
      // This class (the component itself)
      // implements the Control ProvidesPort
      controlExec = new StringGeneratorControl();
      stringGeneratorCore.addProvidesPort((ProvidesControlImpl)controlExec, new DefaultPortInfo("control", "Control_idl"));
    } catch(Exception e) {
      e.printStackTrace();
      System.out.println("StringGeneratorComponent: unable to register: "+e);
    }
  }

  public int startExecuting() {
    controlExec.letMeKnowWhenToStartExecuting();
    try {
      System.out.println("\n StringGenerator Component:: execute  ");
      UsesString output;
      output = (UsesString)stringGeneratorCore.getPort("stringOutPortName");
      int reply = output.setString("[StringGenerator] CCAT is better than CAT ");
      reply = output.setString("[StrinGenerator] If you didn't receive the previous message ignore it, hmm ... is that possible ? ");
      stringGeneratorCore.releasePort("stringOutPortName");
      System.out.println("\n StringGenerator Component:: execute done ");
    } catch (Exception e) {
      e.printStackTrace();
    }
    return 0;
  }
  
  
  public void WaitForKill() {
    (new Thread() {
      public void run() {
	final int returnValue = startExecuting();
      }
    }).start();
    controlExec.letMeKnowWhenToKillMyself();
  }
  
}

