package stringGenerator;

import ccacore.*;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import registry.*;
import util.EnvObj;
import util.NexusConnectionClient;

public class StringGeneratorServer {

  private static int creationServicePORT = -1024;
  private static String creationServiceHost = null;
  private static String localHost = "DEFAULT";
  public static final String RELEASE = "$Revision: 1.7 $ by $Author: mgovinda $ on $Date: 1999/11/02 08:29:47 $ (GMT)";

  public static void main(String args[]) {
    System.out.println(RELEASE);
    parseCommandLineArgs(args);
    StringGeneratorServer stringGeneratorServer = new StringGeneratorServer();
    stringGeneratorServer.initialize();
    System.runFinalizersOnExit(true);
    System.runFinalization();
  }

  public StringGeneratorServer() {
  }
  
  
  private static void parseCommandLineArgs(String argv[]) {
    System.out.println("\nStringGeneratorServer:: " + argv.length + " CommandLineArgs found ");
    creationServiceHost = argv[0];
    creationServicePORT = Integer.parseInt(argv[1]);
    String blank = " ";
    System.out.println("\nStringGeneratorServer:: " + creationServiceHost + blank + creationServicePORT);
  }
  
  
  public void initialize() {
    Services stringGeneratorCore = null;
    StringGeneratorComponent stringGenerator = new StringGeneratorComponent();
    try {
      stringGeneratorCore = new ServicesImpl();
      stringGenerator.setServices(stringGeneratorCore);
    } catch (Exception e) {
      System.out.println("StringGeneratorServer.java:: unable to set  core "+ e);
    }
    
    try {
      ComponentID stringGeneratorCompID = stringGeneratorCore.getComponentID();
      ((ComponentIDregistry)stringGeneratorCompID).setName("STRING_GENERATOR_COMPONENT_ID");
      if (stringGeneratorCore == null) {
	throw new NullPointerException("StringGeneratorServer:: stringGeneratorCore is null !!\n");
      }
      NexusConnectionClient nexusConnectionClient = new NexusConnectionClient();
      nexusConnectionClient.sendMyComponentID(creationServiceHost, creationServicePORT, stringGeneratorCompID);

      // Just waits for  the kill signal.
      // Meanwhile if it gets any requests on
      // the provides port, it works on it.
      // This is part of the execution logic
      // in the execute method of this component.
      // This is just a way to keep this component
      // alive and when the compostion engine does
      // not need this anymore, this should die a
      // graceful death.
      stringGenerator.WaitForKill();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }  
}

