import com.objectspace.jgl.*;
import java.util.Enumeration;
import ccacore.*;

class EventQueueManager {

	EventQueueManager() {
		typeMap = new OrderedMap();
		listenerMap = new OrderedMap();
	}

	synchronized EventQueue lookup(String type) {

		return (EventQueue) typeMap.get(type);
	}

	synchronized boolean addListener(String id, String port, String type,
	 StringBuffer my_port) {

		boolean rc = false;

		my_port.setLength(0);
		my_port.append(type + "_uses");

		EventQueue eq = (EventQueue) typeMap.get(type);

		if (eq == null) {

			eq = new EventQueue(type, core);
			Object ec = typeMap.put(type, eq);
			if (ec != null) {
				System.err.println("Error");
				System.exit(1);
			}

			eq.start();

			rc = true;

			System.err.println("Inserted new event channel for type "
			 + type);
		}

		Listener l = new Listener(id, port, type);
		l.queue = eq;
		eq.addListener(l);

		listenerMap.put(id + ":" + port, l);

		return rc;
	}

	synchronized boolean removeListener(String id, String port,
	 StringBuffer my_port) {

		boolean rc = false;

		my_port.setLength(0);
		my_port.append(id + ":" + port);

		Listener l = (Listener) listenerMap.get(id + ":" + port);
		if (l != null) {
			
			listenerMap.remove(id + ":" + port);

			l.queue.removeListener(l);

			rc = true;

			/* XXX Currently, never remove, because we can't
				   remove a uses port.
			if (l.queue.nListeners() == 0) {
				typeMap.remove(l.type());
				System.err.println("interrupting.");
				l.queue.interrupt();
				System.err.println("done interrupting.");
				try {
					l.queue.join();
				} catch (InterruptedException e) {
					System.err.println("huh? " + e.getMessage());
				}
				System.err.println("remove");
			}
			*/
		}

		return rc;
	}

	private OrderedMap typeMap;
	private OrderedMap listenerMap;

	public Services core;
}
