import ccacore.*;
import connection.*;


class FilteringEventChannel_impl {

	FilteringEventChannel_impl(EventQueueManager eqm) {
		eventQueueManager = eqm;
	}

	synchronized void registerListener(ComponentID listener, String port,
	 String type) {

		try {
			System.err.println("Registering " + listener + " p " + port
			 + " t " + type);
			
			StringBuffer my_port = new StringBuffer();
			boolean new_port = eventQueueManager.addListener(((ComponentIDregistry) listener).toMyString(), port, type, my_port);

			if (new_port) {
				core.registerUsesPort(new DefaultPortInfo(my_port.toString(),
				 "EventPort_idl"));
			}

			connectionService.connect(core.getComponentID(), my_port.toString(),
			 listener, port);
		} catch (nexusrmi.RemoteException e) {
			System.err.println("Nexus error.");
			System.exit(1);
		} catch (exceptions.ConnectionException e) {
			System.err.println("connection except.");
			System.exit(1);
		}
	}

	synchronized int registerPublisher(ComponentID publisher, String his_port) {

		
		try {
			connectionService.connect(publisher, his_port,
			 core.getComponentID(), "notify");
		} catch (exceptions.ConnectionException e) {
			System.err.println("connection except.");
			System.exit(1);
		}

		return 0;
	}

	synchronized void unregister(ComponentID compid, String port) {

		StringBuffer my_port = new StringBuffer();

		try {

			if (eventQueueManager.removeListener(((ComponentIDregistry) compid).toMyString(), port,
			 my_port)) {

				connectionService.disconnect(core.getComponentID(),
				 my_port.toString(), compid, port, 999999);

			} else {

				connectionService.disconnect(compid, port,
					core.getComponentID(), "notify", 99999);
			}
		} catch (nexusrmi.RemoteException e) {
			System.err.println("Nexus error.");
			System.exit(1);
        } catch (exceptions.DisconnectionException e) {
            System.err.println("connection except.");
            System.exit(1);
        }

	}

	private EventQueueManager eventQueueManager;

	public Services core;
	public ConnectionService connectionService;
}
