import com.objectspace.jgl.*;
import idl.eventPort.*;

class Queue {

	Queue() {
		nEvents = 0;
		deque = new Deque();
	}

	public synchronized void put(CCATEvent ev) {

		deque.pushBack(ev);
		if (nEvents++ == 0) {
			notify();
		}
	}

	public synchronized CCATEvent get() throws InterruptedException {

		while (nEvents == 0) {
			wait();
		}

		nEvents--;

		return (CCATEvent) deque.popFront();
	}

	private int nEvents;
	private Deque deque;
}
