package eventChannel;

import ccacore.*;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import registry.*;
import util.EnvObj;
import util.NexusConnectionClient;

public class EventChannelServer {

  private static int creationServicePORT = -1024;
  private static String creationServiceHost = null;
  private static String localHost = "DEFAULT";
  public static final String RELEASE = "$Revision: 1.2 $ by $Author: chiuk $ on $Date: 1999/11/01 08:44:21 $ (GMT)";

  public static void main(String args[]) {
    System.out.println(RELEASE);
    parseCommandLineArgs(args);
    EventChannelServer EventChannelServer = new EventChannelServer();
    EventChannelServer.initialize();
    System.runFinalizersOnExit(true);
    System.runFinalization();
  }

  public EventChannelServer() {
  }
  
  
  private static void parseCommandLineArgs(String argv[]) {
    System.out.println("\nEventChannelServer:: " + argv.length + " CommandLineArgs found ");
    creationServiceHost = argv[0];
    creationServicePORT = Integer.parseInt(argv[1]);
    String blank = " ";
    System.out.println("\nEventChannelServer:: " + creationServiceHost + blank + creationServicePORT);
  }
  
  
  public void initialize() {

    Services eventChannelCore = null;
    FilteringEventChannelComponent eventChannel = new FilteringEventChannelComponent();
    try {
      eventChannelCore = new ServicesImpl();
      eventChannel.setServices(eventChannelCore);
    } catch (Exception e) {
	  e.printStackTrace();
      System.out.println("EventChannelServer.java:: unable to set  core "+ e);
    }
    
    try {
      ComponentID eventChannelCompID = eventChannelCore.getComponentID();
      if (eventChannelCore == null) {
	throw new NullPointerException("EventChannelServer:: eventChannelCore is null !!\n");
      }
      NexusConnectionClient nexusConnectionClient = new NexusConnectionClient();
      nexusConnectionClient.sendMyComponentID(creationServiceHost, creationServicePORT, eventChannelCompID);

      // Make the component run
      // This is *NOT-A-VALID-CCA* call. However, I
      // am using it just for testing purposed. Obviously
      // this will go away once I am sure that the framework
      // is stable.
      ((ServicesPrivate) eventChannelCore).startRunning();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }  
}


/*
class Main {
	public static void main(String args[]) {

		EventQueueManager eqm = new EventQueueManager();
		FilteringEventChannel_impl ec = new FilteringEventChannel_impl(eqm);
		EventPort_impl ep = new EventPort_impl(eqm);

		ec.registerListener("comp1", "port1", "ccaevent");
		ec.registerListener("comp2", "port1", "ccaevent");

		Event ev = new Event("e1", "ccaevent.connect");
		ep.notify(ev);
		ep.notify(ev);

		ec.unregister("comp1", "port1");

		ep.notify(ev);

		ec.unregister("comp2", "port1");

		System.err.println("done");
	}
}
*/
