package eventChannel;
import ccacore.*;
import connection.*;
import idl.*;

public class FilteringEventChannelComponent {

	public FilteringEventChannelComponent() {

		try {
			eventQueueManager = new EventQueueManager();
			filteringEventChannel = new FilteringEventChannel_impl(eventQueueManager);
			eventPort = new EventPort_impl(eventQueueManager);
		} catch (nexusrmi.RemoteException e) {
			e.printStackTrace();
			System.err.println("Nexus error.");
			System.exit(1);
		}
	}

	public void setServices(Services core_) {

		core = core_;
		filteringEventChannel.core = core_;
		eventQueueManager.core = core_;

		try {

			core.addProvidesPort(filteringEventChannel,
			 new DefaultPortInfo("register", "FilteringEventChannel_idl"));
			core.addProvidesPort(eventPort,
			 new DefaultPortInfo("notify", "EventPort_idl"));
			connectionService = (ConnectionService)
			 core.getPort("ConnectionService");

		} catch (Exception e) {

			e.printStackTrace();
			System.err.println("Some exception, who knows what? (sorry nirmal)");
			System.exit(1);
		}

		filteringEventChannel.connectionService = connectionService;
	}

	private EventQueueManager eventQueueManager;
	private FilteringEventChannel_impl filteringEventChannel;
	private EventPort_impl eventPort;
	private Services core;
	private ConnectionService connectionService;
}
