package eventChannel;
import ccacore.*;
import connection.*;
import idl.filteringEventChannel.*;


public class FilteringEventChannel_impl extends ProvidesFilteringEventChannelImpl {

	public FilteringEventChannel_impl(EventQueueManager eqm) throws nexusrmi.RemoteException {
		super();
		eventQueueManager = eqm;
	}

	public synchronized int registerListener(ComponentID listener, String port,
	 String type) throws nexusrmi.RemoteException {

		System.out.println("***** registering listener. ***** " + type);
		System.out.flush();

		if (listener == null) {
			throw new NullPointerException("listener is null");
		}

// 		System.out.println("\nregisterListener::Attempting to recreateStringfiedRef ");
// 		System.out.flush();
// 		ComponentID stringifiedRef = ComponentIDFactory.create(port);
// 		listener =  stringifiedRef;
// 		System.out.flush();
// 		System.out.println("\nAttempting to recreateStringfiedRef done ");
// 		String refName = ((ComponentIDregistry)stringifiedRef).getName();
// 		System.out.println("\nrefName = " + refName);
// 		System.out.flush();
			
// 		port = "listen";
		try {
			System.err.println("Registering " + listener + " p " + port
			 + " t " + type);
			
			StringBuffer my_port = new StringBuffer();
			boolean new_port = eventQueueManager.addListener(
			 ((ComponentIDregistry) listener).toMyString(), port, type,
			 my_port);

			if (new_port) {
				core.registerUsesPort(new DefaultPortInfo(my_port.toString(),
				 "EventPort_idl"));
			}

			connectionService.connect(core.getComponentID(), my_port.toString(),
			 listener, port);
		} catch (nexusrmi.RemoteException e) {
			System.err.println("Nexus error.");
			System.exit(1);
		} catch (exceptions.ConnectionException e) {
			System.err.println("connection except.");
			System.exit(1);
		}

		return 0;
	}

	public synchronized int registerPublisher(ComponentID publisher,
	 String his_port) throws nexusrmi.RemoteException {

		System.out.println("***** registering publisher " + his_port +
		 " *****");
		System.out.flush();

		if (publisher == null) {
			throw new NullPointerException("publisher is null");
		}

// 		System.out.println("\nAttempting to recreateStringfiedRef ");
// 		System.out.flush();
// 		ComponentID stringifiedRef = ComponentIDFactory.create(his_port);
// 		publisher = stringifiedRef;
// 		System.out.flush();
// 		System.out.println("\nAttempting to recreateStringfiedRef done ");
// 		String refName = ((ComponentIDregistry)stringifiedRef).getName();
// 		System.out.println("\nrefName = " + refName);
// 		System.out.flush();
		
// 		his_port = "publish";

		try {
			connectionService.connect(publisher, his_port,
			 core.getComponentID(), "notify");
		} catch (exceptions.ConnectionException e) {
			System.err.println("connection except.");
			System.exit(1);
		}

		return 0;
	}

	public synchronized int unregister(ComponentID compid, String port)
	 throws nexusrmi.RemoteException {

		StringBuffer my_port = new StringBuffer();

		try {

			if (eventQueueManager.removeListener(
			 ((ComponentIDregistry) compid).toMyString(), port, my_port)) {

				connectionService.disconnect(core.getComponentID(),
				 my_port.toString(), compid, port, 999999);

			} else {

				connectionService.disconnect(compid, port,
					core.getComponentID(), "notify", 99999);
			}
		} catch (nexusrmi.RemoteException e) {
			System.err.println("Nexus error.");
			System.exit(1);
        } catch (exceptions.DisconnectionException e) {
            System.err.println("connection except.");
            System.exit(1);
        }

		return 0;
	}

	private EventQueueManager eventQueueManager;

	public Services core;
	public ConnectionService connectionService;
}
