package compositiontool.view;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.BorderLayout;
import ids.InformationDirectoryService;
import registry.RegistryService;
import creation.CreationService;
import connection.ConnectionService;

public class MainCompositionToolWindow extends JFrame {
    public static String CONFIG_DIR = "../../images/";

    public MainCompositionToolWindow(CreationService creationService,
				     ConnectionService connectionService,
				     RegistryService registryService,
				     InformationDirectoryService idsService,
				     EventListener eventListener,
				     ComponentCommunicator communicator) {
	// create container panel and all components
	JPanel topPanel = new JPanel(new BorderLayout());
	WorkingAreaView workingAreaView = new WorkingAreaView(communicator);
	StatusBarView statusBar = new StatusBarView();
	// create the controller
	WorkingAreaController controller = new WorkingAreaController(creationService,
								     connectionService,
								     registryService,
								     idsService,
								     workingAreaView,
								     statusBar,
								     eventListener);
	// add all the things that go in the GUI window
	topPanel.add(workingAreaView,"Center");
	topPanel.add(statusBar,"South");
	topPanel.add(new ToolbarView(registryService,idsService,controller),"North");
	// catch window destroy event 
	this.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	});
	this.setTitle("CCAT");
	setContentPane(topPanel);
	this.pack();
	this.setVisible(true);
    }
}	
