package compositiontool.view;

import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.JTextArea;

/**
 * Simple class to manage the status bar at the bottom of the main window.
 */
public class StatusBarView extends JPanel {
    private JTextArea statusWindow;

    /** 
     * Create a status bar 
     */
    public StatusBarView() {
	super();
	statusWindow = new JTextArea(2,50);
	add(statusWindow);
	setBorder(javax.swing.border.LineBorder.createGrayLineBorder());
	statusWindow.setBackground(this.getBackground());
	setPreferredSize(new Dimension(500,50));
    }
    
    /**
     * Clear the status bar of any information that is displayed.
     */
    public void clearStatusBar() {
	statusWindow.setText("");
    }

    /**
     * Display the specified text on the status bar.
     * @param text the text to be displayed.
     */
    public void setText(String text) {
	statusWindow.setText(text);
    }
}
