/**
 * This class is used to choose an icon for an information 
 * object in the registry tree. 
 * @author Nirmal (nmukhi)
 * @see RegistryIconChooserFactory
 */

package registrybrowser;

import javax.swing.Icon;
import registry.RegistryNode;

public interface RegistryIconChooser {

    /**
     * Choose an icon for an info object 
     * @param infoNode the registry tree node object for which an icon is desired
     * @expanded whether this info object has been expanded or not
     * in the tree
     * @return the icon to be used for this info object
     */
    public Icon getMatchingIcon(RegistryNode infoNode, boolean expanded);
}

