package matlab;

import ccacore.ComponentID;

public interface ComponentCommunicator {
    // set the params of the component with the specified
    // component id and param port name
    // paramValue is what the params should be set to
    public  void setComponentParams(ComponentID componentID,
				    String paramPortClassName,
				    String parameterPortName,
				    String parameterMethodName,
				    String instanceID,
				    Object paramValue);
    
    // make the component with the specifed component id stop
    public  void stopComponent(ComponentID componentID, 
			       String controlPortClassName, 
			       String controlPortName,
			       String instanceId);
    
    // make the component with the specifed component id start
    public  void startComponent(ComponentID componentID, 
				String controlPortClassName, 
				String controlPortName,
				String instanceId);
    
    // kill the component
    public  void killComponent(ComponentID componentID, 
			       String controlPortClassName, 
			       String controlPortName,
			       String instanceId);
}
