package servlet;

public class ConnectionModel {
    private ComponentModel usesInstance;
    private String usesPortName;
    private ComponentModel providesInstance;
    private String providesPortName;
    private String id;
    private static int idGenerator = 0;

    public ConnectionModel(ComponentModel usesInstance,String usesPortName,
			   ComponentModel providesInstance, String providesPortName) {
	this.usesInstance = usesInstance;
	this.usesPortName = usesPortName;
	this.providesInstance = providesInstance;
	this.providesPortName = providesPortName;
	idGenerator++;
	id = usesInstance.getName()+providesInstance.getName()+idGenerator;
    }

    public String getId() {
	return id;
    }

    public String getUsesPortName() {
	return usesPortName;
    }
    
    public String getProvidesPortName() {
	return providesPortName;
    }

    public ComponentModel getUsesInstance() {
	return usesInstance;
    }

    public ComponentModel getProvidesInstance() {
	return providesInstance;
    }
}
