import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class FreshImage extends HttpServlet {
    public void init() { 
	try {
	    System.out.println("Fresh image servlet ready for requests");
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {
	// figure out which image file is being asked for 
	String imageFileName = request.getParameter("filename");
	if (imageFileName==null) {
	    // assume the user wants the session image
	    imageFileName = "/u/drseuss/session/images/"+request.getSession(false).getId()+".jpg";
	}
	response.setContentType("image/jpeg");
	// make sure client refreshes session image all the time
	response.setDateHeader("Expires",System.currentTimeMillis()-1);
	response.setDateHeader("Date",System.currentTimeMillis());
	System.out.println("Setting headers");
	PrintStream out = new PrintStream(response.getOutputStream());
	System.out.println("Getting image file "+imageFileName);
	// get the contents of the image 
	FileInputStream in = new FileInputStream(imageFileName);
	int currentByte = in.read();
	while(currentByte != -1) {
	    out.write(currentByte);
	    currentByte = in.read();
	}
	System.out.println("Done handling request");
    }
}
