
package ccacore;

import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.reflect.*;
import nexus.*;
import nexusrmi.*;
import nexusrmi.server.*;

public class ComponentIDFactory {

  public static ComponentID create(String stringifiedReference) throws nexusrmi.RemoteException {
    System.out.println("Creating a component ID with reference "+stringifiedReference);
    // parse the string to extract integers
    StringTokenizer tokenizer = new StringTokenizer(stringifiedReference,":");
    byte [] barray = new byte[tokenizer.countTokens()];
    int currentByteNumber = 0;
    while(tokenizer.hasMoreTokens()) {
	//	Integer intValueOfByte = new Integer(tokenizer.nextToken());
	//	barray[currentByteNumber++] = intValueOfByte.byteValue();
	barray[currentByteNumber++] = new Byte(tokenizer.nextToken()).byteValue();
    }
    // get byte array from string
    //    byte [] barray = stringifiedReference.getBytes();
    
    // create byte array input stream
    ByteArrayInputStream bstream = new ByteArrayInputStream (barray,1,barray.length-1);
    
    // unpack "packing" format
    //    int format = bstream.read();
    //byte format = (byte) bstream.read();  // SMD: TEST
    System.out.println("\nComponentIDFactory:: packing format is " + barray[0]);

    // test, printing out everything in stringified reference
    //ByteArrayInputStream inStream = new ByteArrayInputStream(barray,1,barray.length-1);
    //int currentByte = inStream.read();
    //int i=0;
    //while(currentByte!=-1) {
    //System.out.println("Byte #"+(i+1)+" is "+currentByte);
    //	currentByte = inStream.read();
    //i++;
    //}

    // first create a startpoint from the bstream. 
    Nexus mynexus =  Communication.getNexus();
    Startpoint sp = null;
    
    try {
	sp = new Startpoint (mynexus, bstream, (int)barray[0]); // SMD: TEST
    } catch (Exception exp) {
      System.out.println ("ComponentIDFactory::Exception while creating startpoint");
      exp.printStackTrace ();
    }
    
//     // other things that are needed for creating the stub
//     String fullStubName = "ccacore.ComponentIDImpl_Stub";
//     String serprot = "nexusrmi.Nexusize";
//     String codebase = "";

//     ComponentIDImpl_Stub cStub = new ComponentIDImpl_Stub(mynexus, sp, serprot, codebase);
//     return cStub;
    
    if (sp == null)
      throw new NullPointerException("ComponentIDFactory::toMyString: Startpoint is null!! ");
//     // Create a stub pointing to the remote services object
//     System.out.println("\n ComponentIDFactory::stub is " + fullStubName);
//     System.out.println("\n ComponentIDFactory::sp is " + sp);
//     System.out.println("\n ComponentIDFactory::ser is " + serprot);
//     System.out.println("\n ComponentIDFactory::codebase is " + codebase);
    
//     //    nexusrmi.Remote mystub = (Remote)UnicastRemoteObject.createStub(fullStubName, sp, serprot, codebase);

//     Object stub = null;
//     // Create the stub using the reflection classes.

//     try {
//     Nexus nexus = Communication.getNexus();
//     Class[] type = new Class[4];
//     Object[] param = new Object[4];
//     type[0] = Class.forName("nexus.Nexus");
//     type[1] = Class.forName("nexus.Startpoint");
//     type[2] = Class.forName("java.lang.String");
//     type[3] = Class.forName("java.lang.String");
//     param[0] = mynexus;
//     param[1] = sp;
//     param[2] = serprot;
//     param[3] = codebase;
//     // 	    Class StubClass = Class.forName(stubName);
//     URL cburl = null;
//     try {
// 	cburl = new URL(codebase);
//     } catch(Exception e) {
//       cburl = null;
//     }

//       System.out.println("\nComponentIDFactory::loading stub class  ");
//       //Class StubClass = RMIClassLoader.loadClass(cburl, fullStubName);
//       Class StubClass = Class.forName(fullStubName);
//       System.out.println("\nComponentIDFactory::StubClass is " + StubClass);
//       Constructor StubCons = StubClass.getConstructor(type);
//       stub = StubCons.newInstance(param);
//       System.out.println("\nComponentIDFactory::stub is " +stub);
//       System.out.println("\nComponentIDFactory::getName() : " + ((ComponentIDregistry)stub).getName());
//       ((ComponentIDregistry)stub).setName("Testing ComponentID ");
//        System.out.println("\nComponentIDFactory::getName() : " + ((ComponentIDregistry)stub).getName());
//       System.out.println("\nComponentIDFactory attempting to bind to registry");

      
//       try {
// 	String registryHost = "bread.extreme.indiana.edu";
// 	int PORT = 1255;
// 	String rmiURL = "rmi://" + registryHost + ":" + PORT + "/testCompID";
// 	System.out.println("ComponentIDFactory:: printerCompID binding in registry");
// 	Naming.rebind(rmiURL, (nexusrmi.Remote)stub);
//       } catch (Exception e) {
//       e.printStackTrace();
//       }
    Object stub = null;
    try {
      String fullStubName = "ccacore.ComponentIDImpl_Stub";
      String serprot = "nexusrmi.Nexusize";
      String codebase = "";
      System.out.flush();
      stub = nexusrmi.server.UnicastRemoteObject.createStub(fullStubName, sp, serprot, codebase);
    } catch (Exception e) {
      e.printStackTrace();
    }
    return (ComponentID)stub;
    //return (ComponentID)returnRef;
    //    return (ComponentID)mystub;
    // now create and return a componentID
//     ComponentID newcid = null;
//     try {
//       newcid = new ComponentIDImpl(mystub);
//     } catch (RemoteException exp) {
//       System.out.println ("RemoteException while creating startpoint");
//       exp.printStackTrace ();		
//     }
//     return newcid;
  }
}

