
package ccacore;

import java.lang.reflect.*;
import creation.CreationServicePrivate;
import connection.ConnectionServicePrivate;
import creation.CreationService;
import creation.CreationServiceImpl;
import connection.ConnectionService;
import connection.ConnectionServiceImpl;
import idl.eventPort.UsesEventPortSkel;
import registry.RegistryService;
import registry.RegistryServiceImplementation;
import ids.InformationDirectoryService;
import ids.InformationDirectoryServiceImplementation;


public final class FrameworkServicesSingletonFactory {
  private static CreationService creationService = null;
  private static ConnectionService connectionService = null;
  private static RegistryService registryService = null;
  private static InformationDirectoryService directoryService = null;
  private static boolean connectionsDone = false;

  public synchronized static CreationService getCreationService() {
    if (creationService == null) {
      System.out.println("\nFrameworkSingleton:creationService is null ");
      creationService = new CreationServiceImpl();
    }
    return creationService;
  }

  public synchronized static ConnectionService getConnectionService() {
    if (connectionService == null) {
      System.out.println("\nFrameworkSingleton:connectionService is null ");
      connectionService = new ConnectionServiceImpl();
    }
    return connectionService;
  }
  


//   // attempting some c++ style obfuscated stuff. Not really
//   // complicated. But just sth that is not obvious.
//   public synchronized static ConnectionService getConnectionService() {
//     return (connectionService == null) ?
//       connectionService = new ConnectionServiceImpl()
//     : connectionService;
//   }
  
   public synchronized static RegistryService getRegistryService() {
       if (registryService == null) {
	   registryService = new RegistryServiceImplementation();
       }
       return registryService;
   }

 public synchronized static InformationDirectoryService getInformationDirectoryService() {
     if (directoryService == null) {
	 directoryService = new InformationDirectoryServiceImplementation();
     }
     return directoryService;
 }

  
  public synchronized static void makeEventPortConnections (ComponentID eventCompID) {
    if (!connectionsDone) {
      connectionsDone = true;
      
      // create a uses port that is connected to the
      // event channel's publish provides port and stick
      // that into all the pseudo components. The pseudo
      // components need to use this Uses port to publish
      // their events to the standard event channel. So, in
      // essence, all the pseudo components share
      
      // Create an UsesPort of type EventPort_idl
      // This usesPort will be connected to the
      // provides port of the eventChannel

      String fqn = "idl.eventPort.UsesEventPortSkel";
      // if you catch an exception, do sth different.
      // don't just go on as if nothing happened.
      // FIXME FIXME
      Class className = null;
      try {
	className = Class.forName(fqn);
      } catch (java.lang.ClassNotFoundException ex) {
	ex.printStackTrace();
      }

      // if you catch an exception, do sth different.
      // don't just go on as if nothing happened.
      // and change it to UsesEventPort
      // FIXME FIXME
      UsesEventPortSkel usesPortForEventChannel = null;
      try {
	usesPortForEventChannel = (UsesEventPortSkel)(className.newInstance());
      } catch (java.lang.IllegalAccessException eiacc) {
	eiacc.printStackTrace();
      } catch (java.lang.InstantiationException einst) {
	einst.printStackTrace();
      }

      // ccatGetProvidesPort really needs to
      // throw a more specific exception
      // FIXME FIXME 
      Port eventProvidesPortForServices = null;
      try {
	eventProvidesPortForServices = ((ComponentIDconnection)eventCompID).ccatGetProvidesPort("notify");
      } catch (Exception egen) {
	egen.printStackTrace();
      }
      if (eventProvidesPortForServices == null)
	throw new NullPointerException("FrameworkServicesSingletonFactory:: received a null pointer for evenChannelProvidesPort");
      usesPortForEventChannel.addListener((ProvidesPort)eventProvidesPortForServices);
      // get the pseudo components, and add the event uses port
      CreationService cr = getCreationService();
      ConnectionService co = getConnectionService();
      ((CreationServicePrivate)cr).setEventUsesPort(usesPortForEventChannel);
      ((ConnectionServicePrivate)co).setEventUsesPort(usesPortForEventChannel);
    }
  }
}



