
//   ServicesPrivate interface is used by
//   the componentID to make remote calls.
//   A componentID in our implementation acts
//   as a proxy that can live in a remote address
//   space. To provide services like connection
//   and disconnection (amongst others) it uses
//   this interface of the ServicesImpl object.
//   Remember that each componentID points to
//   a ServicesImpl instance. This interface is
//   not exposed to the user.
//   --Madhu

package ccacore;
import exceptions.*;

public interface ServicesPrivate extends nexusrmi.Remote {
  public int ccatConnect(String usesPortName, Port providesPort) throws Exception;
  public int ccatDisconnect(String usesPortName, Port providesPort) throws Exception;
  public Port ccatGetProvidesPort(String providesPortName) throws Exception;
  public int ccatExportAs(DefaultPortInfo newPortInfo, Port providesPort) throws Exception;
  public int ccatProvideTo(String usesPortName, Port providesPort) throws Exception;
  public String ccatGetPortTypeForPortName(String portName) throws Exception;

  // this was a TEMPORARY addition
  // Will definitely be removed very soon.
  // Right now only the eventChannel server
  // uses it. -Madhu
  public void startRunning() throws Exception;
}
