
//   Every usesPort instantiated by the framework
//   needs to have the functionality to add and remove
//   listeners. So, it is better to put this in a
//   base class.
//   --Madhu
  
package ccacore;

import java.util.Vector;

public class UsesPortImpl implements  UsesPort {
  private boolean allVoids;
  private int refCount;
  protected Vector portList;

  public UsesPortImpl(boolean allVoids_) {
    allVoids = allVoids_;
    refCount = 0;
    portList = new Vector();
  }

  public UsesPortImpl() {
    this(false);
  }
  
  public int addListener(ProvidesPort in ) {
    System.out.println("\nUsesPortImpl::addListener added an element to the list: " + in);
    portList.addElement((nexusrmi.Remote)in);
    return 0;
  }
  
  public int removeListener(ProvidesPort out) {
    System.out.println("\nUsesPortImpl::removeListener removed an element from the list: " 
				   + out);
    portList.removeElement(out);
    return 0;
  }

  public boolean hasAllVoidMethods() {
    return allVoids;
  }

  public boolean isConnected() {
    return (portList.size() > 0);
  }

  public void incrRefCount () {
    refCount++;
  }

  public void decrRefCount () {
    refCount--;
  }

  public int getRefCount () {
    return refCount;
  }
}
