
package compositionEngine;

import ccacore.*;
import creation.*;
import connection.*;
import registry.*;
import util.*;
import idl.filteringEventChannel.UsesFilteringEventChannel;
import idl.filteringEventChannel.UsesFilteringEventChannelSkel;
import idl.control.UsesControl;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import nexusrmi.server.*;

public class TestEvents {

  private String contextName = "http";
  public static final String RELEASE = "$Revision: 1.4 $ by $Author: mgovinda $ on $Date: 1999/11/11 07:40:56 $ (GMT)";
  
  public void runit() {
    try {
      long t1, t2;
    
      t1 = System.currentTimeMillis();
      // initialize the creation env for an instance
      EnvObj envEventGen = new EnvObj();

      // Some of the keys that I am adding here
      // are not not used to create the Info Object.
      // However that's okay. The extra elements
      // are used only by the creation service 
//       envEventGen.put("username","mgovinda");
//       envEventGen.put("LD_LIBRARY_PATH","/foo");
//       envEventGen.put("PATH",".:/bin:/usr/bin:/usr/local/bin");
//       envEventGen.put("WD","/l/extreme/components/workingdir");
//       envEventGen.put("TMPDIR","/tmp");
//       envEventGen.put("SHELL","/bin/sh");
//       envEventGen.put("registry-host","lookout.extreme.indiana.edu");
//       envEventGen.put("registry-port","4242");
//       String creationTime = new java.util.Date().toString().replace(' ','_');
//       envEventGen.put("creation-time",creationTime);
//       envEventGen.put("creation-mech","rsh");
//       envEventGen.put("creation-mech-path","/usr/bin/rsh");
//       envEventGen.put("host","school.cs.indiana.edu");
//       envEventGen.put("exec-path", "/tmp/madhu/java/JavaEventGeneratorComponent.sh");
//       envEventGen.put("context-name", contextName);
//       envEventGen.put("instance-name", "stringEventGenInstance");
//       envEventGen.put("port-for-component-callback", "1234");
      System.out.println("TestEvents:: Creation env is "+envEventGen);
    

      // Some of the keys that I am adding here
      // are not not used to create the Info Object.
      // However that's okay. The extra elements
      // are used only by the creation service 
      EnvObj envEventChannel = new EnvObj();
//       envEventChannel.put("username","mgovinda");
//       envEventChannel.put("LD_LIBRARY_PATH","/foo");
//       envEventChannel.put("PATH",".:/bin:/usr/bin:/usr/local/bin");
//       envEventChannel.put("WD","/l/extreme/components/workingdir");
//       envEventChannel.put("TMPDIR","/tmp");
//       envEventChannel.put("SHELL","/bin/sh");
//       envEventChannel.put("registry-host","lookout.extreme.indiana.edu");
//       envEventChannel.put("registry-port","4242");
//       String creationTime1 = new java.util.Date().toString().replace(' ','_');
//       envEventChannel.put("creation-time",creationTime1);
//       envEventChannel.put("creation-mech","rsh");
//       envEventChannel.put("creation-mech-path","/usr/bin/rsh");
//       envEventChannel.put("host","school.cs.indiana.edu");
//       envEventChannel.put("exec-path", "/tmp/madhu/java/JavaEventChannelComponent.sh");
//       envEventChannel.put("context-name", contextName);
//       envEventChannel.put("instance-name", "eventChannelInstance");
//       envEventChannel.put("port-for-component-callback", "2345");
      System.out.println("TestEvents:: Creation env is "+envEventChannel);
    
      Services core = new ServicesImpl();
      CreationService creationService = (CreationService)core.getPort("CreationService");
      System.out.println("\nTestEvents::calling creation Service for eventGenerator ");
      ComponentID eventGenCompID = creationService.createInstance(envEventGen);
      System.out.println("\nTestEvents::testing eventGenerator compID");
      System.out.println(" eventGenCompID name is " + ((ComponentIDregistry) eventGenCompID).getName());

      
      System.out.println("\nTestEvents::calling creation Service for eventChannel ");
      ComponentID eventChannelCompID = creationService.createInstance(envEventChannel);


      //       // Binding is optional. The composition engine needs to decide whether
      //       // or not to bind these references to the registry. Right now these are
      //       // placed here to make sure that the bind and lookup calls work.

      //       // Bind the printer instance
      //       RegistryService registryService = (RegistryService)core.getPort("RegistryService");
      //       String printerRegistryContextName = envEventChannel.get("context-name") + "://" + envEventChannel.get("registry-host") + "/testdir";
      //       RegistryContext printerContext = registryService.getContext(printerRegistryContextName);
      //       printerContext.bind(printerCompID, envEventChannel, envEventChannel.get("instance-name"));
      
      
      //       // Bind the stringGenerator instance
      //       RegistryService registryService = (RegistryService)core.getPort("RegistryService");
      //       String stringGenRegistryContextName = envEventGen.get("context-name") + "://" + envEventGen.get("registry-host") + "/testdir";
      //       RegistryContext stringGenContext = registryService.getContext(stringGenRegistryContextName);
      //       strinGenContext.bind(stringGenCompID, envEventGen, envEventGen.get("instance-name"));
			   

      //       // Lookup the printer instance 
      //       printerCompID lookupComponentInstance(printerRegistryContext, envEventChannel.get("instance-name"), envEventChannel.get("username"));

      //       // Lookup the string Generatorinstance 
      //       stringGenCompID lookupComponentInstance(stringGenRegistryContext, envEventGen.get("instance-name"), envEventGen.get("username"));
      


      // get the componentID specific to this compositionEngine
      // and register a uses port, so that it can connect to the
      // eventChannel

      ComponentID testEventsComponentID = core.getComponentID();
      core.registerUsesPort(new DefaultPortInfo("filteringEventChannelPort", "FilteringEventChannel_idl"));
      
      ConnectionService connectionService = (ConnectionService)core.getPort("ConnectionService");
      
      System.out.println("\nTestEvents::calling connection Service connect ");
      connectionService.connect(testEventsComponentID, "filteringEventChannelPort", eventChannelCompID, "register");
      System.out.println("\nTestEvents::connection Service connect succeeded ");

      System.out.println("\nTestEvents::core.getPort(filteringEventChannel)");

      UsesFilteringEventChannelSkel outputPort = (UsesFilteringEventChannelSkel)core.getPort("filteringEventChannelPort");
      System.out.println("\nTestEvents::core.getPort(filteringEventChannel) done " + outputPort.getClass());

      if (outputPort == null) 
	throw new NullPointerException("Its too late in the night for such errors  !!!!!!!!!");

//       String stringifiedRemoteRef = ((ComponentIDregistry)eventGenCompID).getRef();

      System.out.println("\nTestEvents::Attempting outputPort.registerPublisher()");
      outputPort.registerPublisher(eventGenCompID, "publish");
      //outputPort.registerPublisher(eventGenCompID, stringifiedRemoteRef);
      System.out.println("\nTestEvents::outputPort.registerPublisher() succeeded ");

      System.out.println("\nTestEvents::Attempting outputPort.registerListener()");
      outputPort.registerListener(eventGenCompID, "listen", "ASTEROID");
      //outputPort.registerListener(eventGenCompID, stringifiedRemoteRef, "ASTEROID");
      System.out.println("\nTestEvents::outputPort.registerListener() succeeded ");
      System.out.flush();

      core.releasePort("filteringEventChannel");

//       double timeout = 300;
//       connectionService.disconnect(testEventsComponentID, "filteringEventChannel", eventChannelCompID, "register", timeout);
//       System.out.println("\nTestEvents::calling connection Service disconnect done ");
      
      // how else do I start the upstream component ? The old CAT controlled
      // every component's execution. Now the control is not so centralized.
      // The composition engine just connects the components and asks the top
      // component (most upstream) to start executing. Its a data flow model
      // from that point on. 
      core.registerUsesPort(new DefaultPortInfo("control", "Control_idl"));
      
      System.out.println("\nTestEvents::Connection service connecting control ports");
      connectionService.connect(testEventsComponentID, "control", eventGenCompID, "control");
      System.out.println("\nTestEvents::Connection service connecting control ports ... succeeded");
      
      UsesControl controlPort = (UsesControl) (core.getPort("control"));
      System.out.println("\nTestEvents::controlPort.startExecuting()");
      controlPort.startExecuting();
      System.out.println("\nTestEvents::controlPort.startExecuting() done");
      core.releasePort("control");

      t2 = System.currentTimeMillis();
      System.out.println("TestEvents::Elapsed time: " + (t2 - t1) + " msec.");
    }  catch(Exception e) {
      e.printStackTrace();
      System.out.println("TestEvents::run exception"+e);
    }
  }


  ComponentID lookupComponentInstance(RegistryContext context, String instanceName, String currentUser) {
    //     boolean foundInstance = false;
    //     ComponentID componentInstance = null;
    //     try {
    // 	InstanceInfo [] instances = context.lookup(instanceName);
    // 	System.out.println("There are "+instances.length+" instances with that
    // name in this context, trying to get the one created by " + currentUser);
    // 	for (int i=0; i<instances.length; i++) {
    // 	  InstanceInfo currentInstance = instances[i];
    // 	  String userName = currentInstance.getInfo("instance-info")[0].getValue("creator")[0];
    // 	  if (userName.equals(currentUser)) {
    // 	    System.out.println("Instance #"+(i+1)+" created by " + currentUser + ", details on instance are\n"+currentInstance);
    // 	    foundInstance = true;
    // 	    componentInstance =  currentInstance.getComponentID();
    // 	    break;
    // 	  }
    // 	}
    //       } catch (Exception e) {
    // 	System.out.print("CreationServiceImpl::lookupComponentInstance Exception received searching for instanceName : " + instanceName);
    //       }
    //       if (foundInstance) {
    // 	System.out.print("CreationServiceImpl::lookupComponentInstance: Failed in search for instanceName : " + instanceName);
    //       }
    //      return componentInstance;
    return null;
  }
  
  public static void main(String[] args){
    System.out.println(RELEASE);
    TestEvents testEvents = new TestEvents();
    testEvents.runit();
    System.out.println("\n TestEvents: End of test \n");
    System.runFinalizersOnExit(true);
    System.runFinalization();
  }
}









