package contactgrok;

import java.util.*;
import org.globus.mds.*;
import org.globus.common.*;

public class MDSGrok {
    
    static MDSResult mdsResult;
    static Hashtable v;
    
    public static String getContactString(String host) {
	
	MDS mds = new MDS("mds11.globus.org", "391");
	String result=null;
	String dn;

	try {
	    mds.connect();
	}
	catch (MDSException e) {
	    System.err.println("MDS error:" + e.getMessage() + " " + e.getLdapMessage());
	}
	
	mds.setSearchLimit(1);
	try {
	    v = mds.search("o=globus, c=us", 
			   "(&(hn=" + host + ")(objectclass=globusservicejobmanager)(contact=*))", 
			   new String[]{"contact"}, 
			   MDS.SUBTREE_SCOPE);
	}
	catch (MDSException e) {
	    System.err.println("MDS error:" + e.getMessage() + " " + e.getLdapMessage());
	    return null;
	}
	
	Enumeration enum = v.keys();
	while(enum.hasMoreElements()) {
	    dn = (String)enum.nextElement();
	    mdsResult = (MDSResult)v.get(dn);
	    result= (String)mdsResult.getFirstValue("contact");
	}
	
	try {
	    mds.disconnect();
	}
	catch (MDSException e) {
	    System.err.println("MDS error:" + e.getMessage() + " " + e.getLdapMessage());
	    return null;
	}
	return result;
    }
}









