
//  The implementation of the creationService
//  is not complete. It will be changed later
//  once we are in a position to integrate it
//  with the registry service.
//  --Madhu
 
package creation;

import java.io.*;
import java.net.*;
import nexusrmi.*;
import exceptions.InstantiateException;
import ccacore.UsesPort;
import ccacore.ComponentID;
import util.EnvObj;
import util.Fork;
import util.NexusConnectionServer;
import idl.eventPort.CCATEvent;
import idl.eventPort.UsesEventPortSkel;
import contactGrok.*;
import org.globus.gram.*;

public class CreationServiceImpl implements CreationService, CreationServicePrivate {

  private UsesEventPortSkel usesEventPort = null;

  public void setEventUsesPort(UsesEventPortSkel usesEventPort_) {
    //    usesEventPort = (UsesEventPort)usesEventPort_;
    usesEventPort = usesEventPort_;
  }

  public ComponentID createInstance(EnvObj env)  throws InstantiateException {

    String localHost = "DEFAULT";
    System.out.println("Creation env is "+env);
    String creationProto = env.get("creation-mech");
    String creationMechPath = env.get("creation-mech-path");
    String execHost = env.get("host");
    String execPath = env.get("exec-path");
    String execName = env.get("exec-name");
    String globusRunScriptPath = env.get("globus-run-script-path");

    // Note this is now deprecated !!!!!
    String portForComponentCallBack = env.get("port-for-component-callback");

    System.out.println("\n Creation:: creationProto " + creationProto);
    System.out.println("\n Creation:: creationMechpath " + creationMechPath);

    // FIXME FIXME 
    // What is the appropriate thing to do
    // when such an exception is thrown ?
    // I assume that the flow of control
    // can continue if the localHost is
    // set to a default value
    try {
      localHost = InetAddress.getLocalHost().getHostName();
    } catch (java.net.UnknownHostException e) {
      e.printStackTrace();
      System.out.println("\nCreationServiceImpl:createInstance: Assuming local host is bread ");
      localHost = "bread";
    }

    // It is important to do this before forking
    // of the components. So that by the nexus_allow_attach()
    // takes place bofore the instantiated component tries
    // to contact back.
    NexusConnectionServer nexusConnectionServer = new NexusConnectionServer();
    portForComponentCallBack = ""+nexusConnectionServer.getPortForComponentCallBack();

    if (creationProto.equals("ssh")) {
      createInstanceUsingSSHorRSH(creationMechPath, execHost, execPath, localHost, portForComponentCallBack);
    } else if (creationProto.equals("rsh")) {
      createInstanceUsingSSHorRSH(creationMechPath, execHost, execPath, localHost, portForComponentCallBack);
    } else if (creationProto.equals("gram")) {
      createInstanceUsingCog(creationMechPath, localHost, globusRunScriptPath, execHost, execPath, execName, localHost, portForComponentCallBack);
    } else {
      throw new InstantiateException("CreationServiceImpl::createInstance instantiation doesn't exist for this protocol: " + creationProto);
    }

    ComponentID componentIDofInstantiatedComponent  = nexusConnectionServer.getInstantiatedComponentID();
    nexusConnectionServer.shutDown(true);

    // send an event to the eventChannel that
    // the component was successfully created.
    // If the usesEventPort is not set then a
    // null pointer exception will be thrown.
    // I don't want to catch this run time exception.
    String details = "EXEC_HOST:" + execHost + "::EXEC_PATH:" + execPath + "::CREATION_MECHANISM:" + creationProto;
    String source = env.get("instance-name");
    String type = "cca.creation";
    String key = "GET A LOCK FIRST"; // not used now
    long seqNum = 007; // not used now
    CCATEvent ccatEvent = new CCATEvent(source, type, key, seqNum, details);
    // FIXME FIXME
    // Need to catch a more
    // specialized exception and
    // then do sth more useful
    try {
      int reply = usesEventPort.notify(ccatEvent);
    } catch (Exception exGen) {
      exGen.printStackTrace();
    }

    return componentIDofInstantiatedComponent;
  }
    
  private void createInstanceUsingSSHorRSH(String creationMechPath, String execHost, String execPath, String creationServiceHost, String creationServicePort) {

    final String blank = " ";
    final String fullcmd = creationMechPath + blank + execHost + blank + execPath + blank + creationServiceHost + blank + creationServicePort;
    //    try {
      // Thread.currentThread().sleep(20000);
      // Process pr = Runtime.getRuntime().exec(fullcmd);
      (new Fork()).forkProcess(fullcmd);
      //    } catch (Exception e) {
      //      e.printStackTrace();
      //    }
  }

  // creationMechPath : /usr/bin/ssh
  // execGlobusRunHost: run globusrun on this host
  // globusRunScriptPath: path for globusRunScript on the execGlobusRunHost
  // execHost: host on which to exec the c++ component
  // excPath: path to executable directory on the the execHost
  // execName: name of the executable on the exec directory
  // String localHost: host on which this creation service is waiting
  //                   for a callback from the instantiated c++ component
  // String portForComponentCallback: port for same reason as above. 
  private void createInstanceUsingCog(String creationMechPath, String execGlobusRunHost, String globusRunScriptPath, String execHost, String execPath, String execName, String localHost, String portForComponentCallBack) {

    final String blank = " ";
    String contact;
    String rsl;
    GramJob theJob;

    // The line of code below checks first for the ~/.globus/.mdshosts file.
    // If it exists, it searches it for your hostname and if it is there it
    // returns the corresponding contact string.  Failing this (meaning, either
    // the file is not there or the hostname isn't in your contacts list)
    // it then goes to the MDS and tries to look up your contact string for
    // you.  This takes longer, but will work if:
    // a) the MDS is actually running today
    // b) the contact string is in there for your hostname.
    //
    // I have done the work of turning something like "bread" into
    // "bread.extreme.indiana.edu" for you.  Pass whatever you want, as long
    // as it's a machine name somewhere.
    
    contact=GetContactString.getContactString(execHost);

    // This sets the RSl string, which we don't really have to do
    // seperately, just for the sake of printing out for diagnostic
    // purposes.
    rsl="&(executable=" + execName + ")(directory=" + execPath + ")(environment=(CALLBACK_HOST " + localHost + ")(CALLBACK_PORT " + portForComponentCallBack + ")(PROCESS_SEQ 1))(stdout=$(HOME)/ # \"" +execName + ".out\")(stderr=$(HOME)/ # \"" +execName + ".err\")(count=1)";

    // Set up the job
    theJob=new GramJob(rsl);
	
    System.out.println("\nCreationServiceImpl:: rsl is: " + rsl);
    System.out.println("\nCreationServiceImpl:: contact is: " + contact);

    // Make the request
    // NOTE : we could be doing all sorts of nifty stuff like adding a
    // listener to theJob and getting the updates as to process creation that
    // way - I'm going to try to futz about in code to see if I can see where
    // we do this.  HOWEVER, this part of the CoG kit seems to be broken in
    // the solaris build.  Yeah, multi-platform, woohoo.
    try {
	theJob.request(contact);
    }
    catch (GramException e) {
	System.out.println(e);
    }
  }
  
    // FIXME FIXME
  // to be implemented 
  public void deleteInstance(ComponentID id) throws InstantiateException {
  }
  
}




