package idl.basicInfoParms;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class UsesBasicInfoParmsSkel extends UsesPortImpl implements UsesBasicInfoParms {

    // consructors
    public UsesBasicInfoParmsSkel() {
	   super();
    }
    
    // remote methods
    public int sendBasicInfoParms(BasicInfoParms bip) throws RemoteException {

	   System.out.println("UsesBasicInfoParmsSkel::sendBasicInfoParms called");
	   System.out.flush();	   

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesBasicInfoParmsSkel::sendBasicInfoParms" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesBasicInfoParms)remoteRef).sendBasicInfoParms (bip);
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;	   
    }

    public int start() throws RemoteException {
	   System.out.println("UsesBasicInfoParmsSkel:: start called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesBasicInfoParmsSkel::start" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesBasicInfoParms)remoteRef).start ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int stop() throws RemoteException {
	   System.out.println("UsesBasicInfoParmsSkel:: stop called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesBasicInfoParmsSkel::stop" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesBasicInfoParms)remoteRef).stop ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int kill() throws RemoteException {
	   System.out.println("UsesBasicInfoParmsSkel:: kill called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesBasicInfoParmsSkel::kill" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesBasicInfoParms)remoteRef).kill ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public String getOutputURL() throws RemoteException {
	System.out.println("UsesBasicInfoParmsSkel:: getOutputURL called");
	System.out.flush();
	
	String result="";
	for(int i = 0; i < portList.size(); i++) {
	    ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	    System.out.println("UsesBasicInfoParmsSkel::getOutputURL" +
			       " retrieved providesPort" + remoteRef.getClass());
	    try {
		result = 
		    ((ProvidesBasicInfoParms)remoteRef).getOutputURL ();
	    } catch (Exception e) {
		System.out.println(e);
	    }
	}
	return result;
    }
}

