package idl.control;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class ProvidesControlSkel extends UnicastRemoteObject implements ProvidesControl {

  private ProvidesControl thePort;
  private boolean isProxy;
  public ProvidesControlSkel() throws RemoteException {
    super();
    isProxy = false;
  }
  
  public void setProxy(ProvidesPort _thePort) throws Exception {
    // initialize the implementing port reference
    System.out.println("\n ProvidesControlSkel::setProxy() called");
    thePort = (ProvidesControl) _thePort;
    isProxy = true;
  }
  
  public int startExecuting() throws RemoteException {
    int result = 0;
    if(isProxy){
      try{
	result = thePort.startExecuting();
	return result;
      } catch (Exception e){
	System.out.println(e);
      }
    } else {
      System.out.println("ProvidesControlSkel::Nothing to provide!");
    }
    return result;
  }

  public int kill() throws RemoteException {
    int result = 0;
    if(isProxy){
      try{
	result = thePort.kill();
	return result;
      } catch (Exception e){
	System.out.println(e);
      }
    } else {
      System.out.println("ProvidesControlSkel::Nothing to provide!");
    }
    return result;
  }
}


