package idl.filteringEventChannel;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class ProvidesFilteringEventChannelSkel extends UnicastRemoteObject implements ProvidesFilteringEventChannel {

  private ProvidesFilteringEventChannel thePort;
  private boolean isProxy;
  public ProvidesFilteringEventChannelSkel() throws RemoteException {
    super();
    isProxy = false;
  }
  
  public void setProxy(ProvidesPort _thePort) throws Exception {
    // initialize the implementing port reference
    System.out.println("\n ProvidesFilteringEventChannelSkel::setProxy() called");
    thePort = (ProvidesFilteringEventChannel) _thePort;
    isProxy = true;
  }
  
  public int registerListener(ComponentID listener, String listenerProvidesPort, String type) throws RemoteException {
	System.out.println("\nProvidesFilteringEventChannelSkel::registerListener called ");
	System.out.flush();
    int result = 0;
    if(isProxy){
      try{
	result = thePort.registerListener(listener, listenerProvidesPort, type);
	return result;
      } catch (Exception e){
	System.out.println(e);
      }
    } else {
      System.out.println("ProvidesFilteringEventChannelSkel::registerListener() Nothing to provide!");
    }
    return result;
  }

    public int registerPublisher(ComponentID publisher, String publisherUsesPort) throws RemoteException {
	System.out.println("\nProvidesFilteringEventChannelSkel::registerPublisher called ");
	System.out.flush();
    int result = 0;
    if(isProxy){
      try{
	result = thePort.registerPublisher(publisher, publisherUsesPort);
	return result;
      } catch (Exception e){
	System.out.println(e);
      }
    } else {
      System.out.println("ProvidesFilteringEventChannelSkel::registerPublisher() Nothing to provide!");
    }
    return result;
  }
  
  public int unregister(ComponentID component, String portName) throws RemoteException {
    int result = 0;
    if(isProxy){
      try{
	result = thePort.unregister(component, portName);
	return result;
      } catch (Exception e){
	System.out.println(e);
      }
    } else {
      System.out.println("ProvidesFilteringEventChannelSkel::unregister() Nothing to provide!");
    }
    return result;
  }
}


