package idl.reorderParms;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class UsesReorderParmsSkel extends UsesPortImpl 
    implements UsesReorderParms {

    // consructors
    public UsesReorderParmsSkel() {
	   super();
    }
    
    // remote methods
    public int sendReorderParms(ReorderParms bip) 
	   throws RemoteException {

	   System.out.println("UsesReorderParmsSkel::sendReorderParms called");
	   System.out.flush();	   

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesReorderParmsSkel::reorderParms" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesReorderParms)remoteRef).sendReorderParms (bip);
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;	   
    }

    public int start() throws RemoteException {
	   System.out.println("UsesReorderParmsSkel:: start called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesReorderParmsSkel::start" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesReorderParms)remoteRef).start ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int stop() throws RemoteException {
	   System.out.println("UsesReorderParmsSkel:: stop called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesReorderParmsSkel::stop" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesReorderParms)remoteRef).stop ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int kill() throws RemoteException {
	   System.out.println("UsesReorderParmsSkel:: kill called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesReorderParmsSkel::kill" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesReorderParms)remoteRef).kill ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }
}

