package idl.scaleParms;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class UsesScaleParmsSkel extends UsesPortImpl 
    implements UsesScaleParms {

    // consructors
    public UsesScaleParmsSkel() {
	   super();
    }
    
    // remote methods
    public int sendScaleParms(ScaleParms bip) 
	   throws RemoteException {

	   System.out.println("UsesScaleParmsSkel::sendScaleParms called");
	   System.out.flush();	   

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesScaleParmsSkel::scaleParms" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesScaleParms)remoteRef).sendScaleParms (bip);
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;	   
    }

    public int start() throws RemoteException {
	   System.out.println("UsesScaleParmsSkel:: start called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesScaleParmsSkel::start" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesScaleParms)remoteRef).start ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int stop() throws RemoteException {
	   System.out.println("UsesScaleParmsSkel:: stop called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesScaleParmsSkel::stop" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesScaleParms)remoteRef).stop ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }

    public int kill() throws RemoteException {
	   System.out.println("UsesScaleParmsSkel:: kill called");
	   System.out.flush();

	   int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
		  ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
		  System.out.println("UsesScaleParmsSkel::kill" +
						 " retrieved providesPort" + remoteRef.getClass());
		  try {
			 result = 
				((ProvidesScaleParms)remoteRef).kill ();
		  } catch (Exception e) {
			 System.out.println(e);
		  }
	   }
	   return result;
    }
}

