package idl.timeStepParms;

import ccacore.*;
import java.util.*;
import java.io.*;
import nexusrmi.*;
import nexusrmi.server.*;


public class UsesTimeStepParmsSkel extends UsesPortImpl 
    implements UsesTimeStepParms {

    // consructors
    public UsesTimeStepParmsSkel() {
	   super();
    }
    
    // remote methods
    public int sendTimeStepParms(TimeStepParms tsp) 
       throws Exception {
	 System.out.println("UsestimeStepParmsSkel::sendtimeStepParms called");
	 System.out.flush();	   
	 
	 int result = 0;
	 for(int i = 0; i < portList.size(); i++) {
	   ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	   System.out.println("UsestimeStepParmsSkel::timeStepParms" +
			      " retrieved providesPort" + remoteRef.getClass());
	   try {
	     result = 
	       ((ProvidesTimeStepParms)remoteRef).sendTimeStepParms (tsp);
	   } catch (Exception e) {
	     System.out.println(e);
	   }
	 }
	 return result;	   
    }

    public int start() throws Exception {
      System.out.println("UsestimeStepParmsSkel:: start called");
      System.out.flush();
      
      int result = 0;
      for(int i = 0; i < portList.size(); i++) {
	ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	System.out.println("UsesTimeStepParmsSkel::start" +
			   " retrieved providesPort" + remoteRef.getClass());
	try {
	  result = 
	    ((ProvidesTimeStepParms)remoteRef).start ();
	} catch (Exception e) {
	  System.out.println(e);
	}
      }
      return result;
    }
      
    public int stop() throws Exception {
      System.out.println("UsestimeStepParmsSkel:: stop called");
      System.out.flush();
      
      int result = 0;
      for(int i = 0; i < portList.size(); i++) {
	ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	System.out.println("UsestimeStepParmsSkel::stop" +
						 " retrieved providesPort" + remoteRef.getClass());
	try {
	  result = 
	    ((ProvidesTimeStepParms)remoteRef).stop ();
	} catch (Exception e) {
	  System.out.println(e);
	}
      }
      return result;
    }

  public int kill() throws Exception {
    System.out.println("UsestimeStepParmsSkel:: kill called");
    System.out.flush();
    
    int result = 0;
	   for(int i = 0; i < portList.size(); i++) {
	     ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	     System.out.println("UsestimeStepParmsSkel::kill" +
						 " retrieved providesPort" + remoteRef.getClass());
	     try {
	       result = 
		 ((ProvidesTimeStepParms)remoteRef).kill ();
	     } catch (Exception e) {
	       System.out.println(e);
	     }
	   }
	   return result;
  }

    public String getOutputURL() throws RemoteException {
	System.out.println("UsesTimeStepParmsSkel:: getOutputURL called");
	System.out.flush();
	
	String result="";
	for(int i = 0; i < portList.size(); i++) {
	    ProvidesPort remoteRef = (ProvidesPort) portList.elementAt(i);		  
	    System.out.println("UsesTimeStepParmsSkel::getOutputURL" +
			       " retrieved providesPort" + remoteRef.getClass());
	    try {
		result = 
		    ((ProvidesTimeStepParms)remoteRef).getOutputURL ();
	    } catch (Exception e) {
		System.out.println(e);
	    }
	}
	return result;
    }
}

