/**
 * This represents an item of information in the directory. This may refer
 * to information or just a context in which other nodes are stored. 
 * @author Nirmal (nmukhi)
 */

package ids;

public interface InformationDirectoryNode {

    /**
     * Gets the name of this node
     * @return the name of this node
     */
    public String getName();

    /**
     * @return 1 if this node refers to information,
     * 0 otherwise
     */
    public int isInformation();

    /**
     * @return 1 if this node refers to a context,
     * 0 otherwise
     */
    public int isContext();
}
           
