/**
 * This class encapsulates an exception indicating that a given
 * name did not point to a context node in some information
 * hierarchy (usually the registry or information directory
 * service).
 * @author Nirmal (nmukhi)
 * @see RegistryService
 * @see RegistryContext
 *
 */

package registry;

public class BadContextNameException extends Exception {
    /**
     * Create an exception with no message
     *
     */
    public BadContextNameException() {
	super();
    }

    /**
     * Create an exception with a message describing the nature
     * of the problem
     * @param message the description of the exception that 
     * took place.
     *
     */
    public BadContextNameException(String message) {
	super(message);
    }
}
