/**
 * This is an interface to an instance stored in the registry.
 * Instance information can be accessed using the appropriate key.
 * some of the information is just in the form of name-value
 * pairs, other information is accessed by providing a name which
 * returns a list of <var>Info</var> objects.
 * The following information can be obtained from an instance:
 * <table>
 * <tr><th>Key</th><th>Values</th></tr>
 * </table>
 * @author Nirmal (nmukhi)
 */
package registry;
import util.Info;
import ccacore.ComponentID;

public interface InstanceInfo extends RegistryNode, Info {
    /**
     * Gets a handle to the component instance this object 
     * refers to.
     * @return the <var>ComponentID</var> for the instance
     *
     */
    public ComponentID getComponentID();
}
