/**
 * This class encapsulates an exception indicating that a context
 * became invalid due to an unknown error. This could mean that
 * the network link to the server containing the context was broken
 * or that the context was deleted at the server.
 * @author Nirmal (nmukhi)
 * @see RegistryContext
 *
 */

package registry;

public class InvalidContextException extends Exception {
    /**
     * Create an exception with no message
     *
     */
    public InvalidContextException() {
	super();
    }

    /**
     * Create an exception with a message describing the nature
     * of the problem
     * @param message the description of the exception that 
     * took place.
     *
     */
    public InvalidContextException(String message) {
	super(message);
    }
}
