/**
 * This class encapsulates an exception indicating that a resource
 * could not found in some information service (suually the registry
 * or information directory service).
 * @author Nirmal (nmukhi)
 * @see RegistryService
 * @see RegistryContext
 *
 */

package registry;

public class NotFoundException extends Exception {
    /**
     * Create an exception with no message
     *
     */
    public NotFoundException() {
	super();
    }

    /**
     * Create an exception with a message describing the nature
     * of the problem
     * @param message the description of the exception that 
     * took place.
     *
     */
    public NotFoundException(String message) {
	super(message);
    }
}
