/**
 * This represents an item of information in the registry. This may refer
 * to a component instance or just a context in which other nodes are 
 * stored. 
 * @author Nirmal (nmukhi)
 *
 */
package registry;

public interface RegistryNode {

    /**
     * Gets the name of this node
     * @return the name of the node.
     *
     */
    public String getName();

    /**
     * @return 1 if this node refers to an instance, 0 otherwise.
     *
     */
    public int isInstance();

    /**
     * @return 1 if this node refers to a context, 0 otherwise.
     *
     */
    public int isContext();
}
              
