// -*- Mode: Java -*-

package util;

import java.io.*;

/*
 * Utility for forking off processes (in the background); ASYNCHRONOUS!!!
 */

public class Fork {
  public static boolean debugOutput=true;
  String fd;
  Process pr;
  String cmd;

  static {
    System.out.println("\n Forking ....");
  }

  public Fork() {
    super();
    fd = System.getProperty("file.separator");
    //    System.out.println("\n ***** INSIDE CONSTRUCTOR! \n");
  }

  void println(String msg) {
    if (debugOutput) {
      System.out.flush();
      System.out.println("[Fork] "+msg);
      System.out.flush();
    }
  }

  class ForkProcess implements Runnable {
    String fullcmd;
    ForkProcess(String c, String args) {
      //      System.out.println("\n **** within ForkProcess constructor\n");
      cmd = c;
      fullcmd = cmd + " " + args;
    }
    public void run() {
      println("exec: "+fullcmd);
      try {
	pr = Runtime.getRuntime().exec(fullcmd);
      } catch (Exception e1) {
	pr = null;
	println("Exception: "+e1);
      }
      //      System.out.println("\n***** ForkProcess: run() \n");
    }
  }

  class ForkProcessIO extends Thread {
    BufferedReader br;
    String s,prefix;
    ForkProcessIO(String px, InputStream is) {
      //      System.out.println("\n **** inside ForkProcessIO constructor\n");
      prefix = px;
      try {
	   br = new BufferedReader(new InputStreamReader(is),256);
      } catch (Exception e0) {
	   System.out.println("\n **** Exception:="+e0+"\n");
	   br = null;
      }
      s = null;
      //	 System.out.println("\n **** br="+br+"\n");
    }
    public void run() {
      //	 System.out.println("\n ***** BR="+br+"\n");
      if (br==null) return;
      for (;;) {
	try {
	  // System.out.println("\n ***** HEY s="+s+"\n");
	  s = br.readLine();
	  // System.out.println("\n **** s="+s+"\n");
	  if (s==null) break;
	  println(prefix+": "+s);
	} catch (Exception e) {
	  println(prefix+" Exception: "+e);
	  break;
	}
      }
    }
  }

  public void forkProcess(String cmd) {
    forkProcess(">>>>>>", "", cmd, "");
  }
  
  public void forkProcess(String prefix, String precmd, String cmd, String args) {
    System.out.println("\n ****** HEY INSIDE\n");
    // determine the "real" command to execute
    if ((cmd==null)||(cmd.trim().length()<1)) {
      cmd = precmd;
    } else {
      cmd = precmd + " " + cmd;
    }
    cmd = cmd.trim();
    // parse for positional parameters
    int i = cmd.indexOf("%s");
    if (i>=0) {
      cmd = cmd.substring(0,i) + args + cmd.substring(i+2);
      args = "";
    }
    System.out.println("\n ***** forkProcess: cmd="+cmd+", args="+args+"\n");
    // create the process in a (blocking) thread
    (new ForkProcess(cmd,args)).run();
    if (pr==null) {
      println("ERROR:  Unable to execute "+cmd+" !");
    } else {
      // print the output in a separate (non-blocking) thread
      (new ForkProcessIO(prefix,pr.getInputStream())).start();
      //      System.out.println("\n ***** OutputStream!\n");
      // print the error in a separate (non-blocking) thread
      (new ForkProcessIO(prefix+" (ERR)",pr.getErrorStream())).start();
      //      System.out.println("\n ****** ErrorStream \n");
    }
  }
}
