
package util;

import nexus.*;
import ccacore.ComponentID;
import nexusrmi.server.UnicastRemoteObject;
import ccacore.ComponentIDregistry;
import nexusrmi.Communication;
import java.lang.reflect.*;


public class NexusConnectionClient {

  private Nexus nexus;
  private Startpoint creationServiceStartpoint;
  private Endpoint ep;
  AttachReturn attachReturn;
  private boolean receivedKillSignal = false;
  private int HANDLER_ID_FOR_SSH_OR_RSH = 155;
  public void NexusConnectionClient() {
    nexus = new Nexus();
    (new Thread() {
      public void run() {
	waitForKillSignal();
      }
    }).start();
  }

  public void sendMyComponentID(String creationServiceHost_, int creationServicePort_, ComponentID componentID) {

    String creationServiceHost = creationServiceHost_;
    int creationServicePort = creationServicePort_;

    nexus = nexusrmi.Communication.getNexus();
    
    try {
      String url = "http://" + creationServiceHost + ":" + creationServicePort + "/";
      attachReturn = nexus.attach(url);
      if (attachReturn.status !=0 ) {
	System.out.println("NexusConnectClient::Failed to attach to " + url.toString() + ".");
      } else {
// 	System.out.println("NexusConnectionClient::Attached to \""+url.toString() +"\".");
      }
//       System.out.println("\nNexusConnectionClient::nexus.attach() returned ");
    } catch (Exception e) {
      e.printStackTrace();
    }
      
      // this serverStartpoint is bound to an endpoint in the server
      creationServiceStartpoint = attachReturn.sp;
      if (creationServiceStartpoint == null) {
	throw new NullPointerException("NexusConnectionClient::received null creationServiceStarptpoint !");
      }

      Startpoint instantiatedComponentStartpoint = UnicastRemoteObject.getStartpoint((nexusrmi.Remote)componentID);
      //  testComponentIDStartpoint(instantiatedComponentStartpoint);
      if (instantiatedComponentStartpoint == null) {
	throw new NullPointerException("NexusConnectionClient::received null instantiatedComponentStarptpoint !");
      }
//       System.out.println("\nNexusConnectionClient:creationServiceStartpoint is " + creationServiceStartpoint);
//       System.out.println("\nNexusConnectionClient:instantiatedComponentStartpoint is " + instantiatedComponentStartpoint);
      PutBuffer buffer;    

      int size = instantiatedComponentStartpoint.sizeof();
      buffer = nexus.buffer_init(size,0);
      
      try {
	instantiatedComponentStartpoint.put(buffer);

      } catch ( Exception e ) {
	System.out.println ("NexusConnectionClient::Could not append startpoint to the buffer");
	e.printStackTrace();
      }
//       System.out.println("NexusConnectionClient:: sending startpoint to the creationService");
      boolean destroy_context = false;
      try {
	nexus.send_rsr(buffer, creationServiceStartpoint, HANDLER_ID_FOR_SSH_OR_RSH, destroy_context);
// 	System.out.println ( "NexusConnetionClient:: sent a starpoint to the creationService" );
	nexus.destroy_current_context(false);
      } catch ( Exception e ) {
	e.printStackTrace();
      System.out.println( "NexusConnectionClient:: failed in the process of sending componentIDstartpoint to the creation service ! " );
    }
  }


  private synchronized void waitForKillSignal() {
    while (!receivedKillSignal) { 
      try {
// 	System.out.println( "NexusConnectionClient:: Waiting for kill signal" );
	wait();
// 	System.out.println( "NexusConnectionServer:: Received kill signal" );
       } catch ( Exception e ) {
	 e.printStackTrace();
       } 
    }
  }
  
  private synchronized void kill (boolean MesgFromHandler) {
    receivedKillSignal = MesgFromHandler;
    try {
      notifyAll();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  
  private void testComponentIDStartpoint(Startpoint componentIDstartpoint) {
    if (componentIDstartpoint == null)
      throw new NullPointerException("NexusConnectionClient::createStubFromStarpoint: Startpoint is null!! ");
    
    // other things that are needed for creating the stub
    String fullStubName = "ccacore.ComponentIDImpl_Stub";
    String serprot = "nexusrmi.Nexusize";
    String codebase = "";

    // Create the stub using the reflection classes.
    Object stub = null;
    try {
      Nexus nexus = Communication.getNexus();
      Class[] type = new Class[4];
      Object[] param = new Object[4];
      type[0] = Class.forName("nexus.Nexus");
      type[1] = Class.forName("nexus.Startpoint");
      type[2] = Class.forName("java.lang.String");
      type[3] = Class.forName("java.lang.String");
      param[0] = nexus;
      param[1] = componentIDstartpoint;
      param[2] = serprot;
      param[3] = codebase;
      
      Class StubClass = Class.forName(fullStubName);
      Constructor StubCons = StubClass.getConstructor(type);
      stub = StubCons.newInstance(param);
      System.out.println("\nNexusConnectionClient::stub is " +stub);
      System.out.flush();
      System.out.println("\nNexusConnectionClient::getName() : " + ((ComponentIDregistry)stub).getName());
      ((ComponentIDregistry)stub).setName("Testing ComponentID ");
      System.out.println("\nNexusConnectionClient::getName() : " + ((ComponentIDregistry)stub).getName());
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
