/**
 * This class encapsulates an exception indicating that a DAV server
 * could not find some resource in the process of trying to satisfy a 
 * request.
 * @author Nirmal (nmukhi)
 * @see DAVServerResponse
 * @see DAVConnection
 *
 */

package util.webdav.client;

public class DAVResourceNotFoundException extends Exception {
    /**
     * Create an exception with no message
     *
     */
    public DAVResourceNotFoundException() {
	super();
    }

    /**
     * Create an exception with a message describing the nature
     * of the problem
     * @param message the description of the exception that 
     * took place.
     *
     */
    public DAVResourceNotFoundException(String message) {
	super(message);
    }
}
