/**
 * This class tests the basic HTTP 1.1 client functionality in
 * class HTTPConnection to make requests according to the WebDAV
 * protocol. 
 *
 * @see HTTPConnection
 * @author Nirmal (nmukhi)
 */

package HTTPClient;

import java.io.IOException;
import HTTPClient.HTTPConnection;
import HTTPClient.HTTPResponse;
import HTTPClient.AuthSchemeNotImplException;
import HTTPClient.ModuleException;
import HTTPClient.NVPair;

public class WebDAVConnection {
    public static void main(String [] args) {
	try {
	    HTTPConnection connection = new HTTPConnection("lookout.extreme.indiana.edu",4242);
	    // get something
	    System.out.println("Attempting to get myr2.htm...");
	    HTTPResponse response = connection.Get("/myr2.htm");
	    System.out.println("Response from server: \n"+response);
	    // make a collection
	    System.out.println("Attempting to make a collection testcollection...");
	    response = connection.ExtensionMethod("MKCOL","/testcollection",(byte [])null,null);
	    System.out.println("Response from server: \n"+response);
	    // attempt to put something in the collection
	    System.out.println("Attempting to put stuff into the collection...");
	    response = connection.Put("/testcollection/foo","hello world");
	    System.out.println("Response from server: \n"+response);
	    // delete what was put
	    System.out.println("Attempting to remove stuff from the collection...");
	    response = connection.Delete("/testcollection/foo");
	    System.out.println("Response from server: \n"+response);
	    // remove the collection
	    response = connection.Delete("/testcollection");
	    System.out.println("Response from server: \n"+response);
	} catch (Exception exception) {
	    System.err.println("Got exception "+exception);
	    System.exit(1);
	}
    }
}
