package nexus;

public class Chunk
{
    public static final int CHUNK_SIZE = 1024; //bytes
    
    private byte[] data;
    private int size;
    private int start;
    private Chunk next;
    
    public Chunk()
    {
	data = new byte[Chunk.CHUNK_SIZE];
	start = 0;
	size = 0;
	next = null;
    }

    //Special constructor used for header chunk only
    public Chunk(int size)
    {
	data = new byte[size];
	start = 0;
	size = 0;
	next = null;
    }
    
    public void setNext(Chunk nc)
    {
	next = nc;
    }
    public Chunk getNext()
    {
	return next;
    }

    public void setStart(int start)
    {
	this.start = start;
    }
    public int getStart()
    {
	return start;
    }
    
    public void setSize(int size)
    {
	this.size = size;
    }
    public int getSize()
    {
	return size;
    }
    
    public int available()
    {
	return Chunk.CHUNK_SIZE - size;
    }
    
    public byte[] getData()
    {
	return data;
    }

    public int put_byte(byte b)
    {
	//	System.out.println("writing " + DataConversion.sizeof_byte(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_byte(b, data, size);
	int sz = DataConversion.SIZEOF_BYTE;
	size += sz;
	return sz;
    }
    public int put_char(char c)
    {
	//	System.out.println("writing " + DataConversion.sizeof_char(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_char(c, data, size);
	int sz = DataConversion.SIZEOF_CHAR;
	size += sz;
	return sz;
    }
    public int put_short(short s)
    {
	//	System.out.println("writing " + DataConversion.sizeof_short(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_short(s, data, size);
	int sz = DataConversion.SIZEOF_SHORT;
	size += sz;
	return sz;
    }
    public int put_int(int i)
    {
	//	System.out.println("writing " + DataConversion.sizeof_int(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_int(i, data, size);
	int sz = DataConversion.SIZEOF_INT;
	size += sz;
	return sz;
    }
    public int put_long(long l)
    {
	//	System.out.println("writing " + DataConversion.sizeof_long(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_long(l, data, size);
	int sz = DataConversion.SIZEOF_LONG;
	size += sz;
	return sz;
    }
    public int put_float(float f)
    {
	//	System.out.println("writing " + DataConversion.sizeof_float(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_float(f, data, size);
	int sz = DataConversion.SIZEOF_FLOAT;
	size += sz;
	return sz;
    }
    public int put_double(double d)
    {
	//	System.out.println("writing " + DataConversion.sizeof_double(1) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_double(d, data, size);
	int sz = DataConversion.SIZEOF_DOUBLE;
	size += sz;
	return sz;
    }
    public int put_byte(byte[] b, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_byte(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_byte(b, off, len, data, size);
	int sz = DataConversion.sizeof_byte(len);
	size += sz;
	return sz;
    }
    public int put_char(char[] c, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_char(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_char(c, off, len, data, size);
	int sz = DataConversion.sizeof_char(len);
	size += sz;
	return sz;
    }
    public int put_short(short[] s, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_short(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_short(s, off, len, data, size);
	int sz = DataConversion.sizeof_short(len);
	size += sz;
	return sz;
    }
    public int put_int(int[] i, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_int(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_int(i, off, len, data, size);
	int sz = DataConversion.sizeof_int(len);
	size += sz;
	return sz;
    }
    public int put_long(long[] l, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_long(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_long(l, off, len, data, size);
	int sz = DataConversion.sizeof_long(len);
	size += sz;
	return sz;
    }
    public int put_float(float[] f, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_float(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_float(f, off, len, data, size);
	int sz = DataConversion.sizeof_float(len);
	size += sz;
	return sz;
    }
    public int put_double(double[] d, int off, int len)
    {
	//	System.out.println("writing " + DataConversion.sizeof_double(len) + " byte(s) at " + size + " to " + this + ", " + available() + " avail)");
	DataConversion.put_double(d, off, len, data, size);
	int sz = DataConversion.sizeof_double(len);
	size += sz;
	return sz;
    }
}
