package nexus;

public class Handler extends Object
{
    public String		name;
    public int			id;
    public int			type;
    public HandlerInterface	object;
    public int			object_local_id;
	
    public static final int NEXUS_HANDLER_TYPE_NONTHREADED = 0;
    public static final int NEXUS_HANDLER_TYPE_THREADED = 1;

    /*
     * Handler()
     */
    public Handler(String name,
		   int id,
		   int type,
		   HandlerInterface object,
		   int object_local_id)
    {
	this.name = name;
	this.id = id;
	this.type = type;
	this.object = object;
	this.object_local_id = object_local_id;
    } /* Handler() */
    

    /*
     * Handler()
     */
    public Handler(String name,
		   int id)
    {
	this(name, id, 0, null, 0);
    } /* Handler() */
    

    /*
     * set()
     */
    public void set(String name,
		    int id)
    {
	this.name = name;
	this.id = id;
    } /* set() */


    /*
     * hashCode()
     */
    public int hashCode()
    {
	return(id);
    } /* hashCode() */

    
    /*
     * equals()
     */
    public boolean equals(Object o)
    {
	Handler h = (Handler) o;
	return(h.name.equals(name));
    } /* equals() */


    /*
     * toString()
     */
    public String toString()
    {
	return(new String(name+"/"+id));
    } /* toString() */
}
