
package nexus;

/*
 * TotemInfo - Totem specific protocol information
 */
public class TotemInfo
  extends ProtoInfo {

  public String host;    // IPv4 address or hostname of host running totem server
  public int    port;    // totem server port
  public int    pgid;    // process group id
  public int    msgType; // AGREED or SAFE - not yet supported
                         // - all messages of type AGREED

  /*
   * TotemInfo
   */
  public TotemInfo(int pgid) {
    this.pgid = pgid;
    protoType = Nexus.PROTO_TYPE_TOTEM; 
  }
  public TotemInfo(String host,
                   int pgid) {
    this.host = host;
    this.pgid = pgid;
    protoType = Nexus.PROTO_TYPE_TOTEM; 
  }
  public TotemInfo(int port,
                   int pgid) {
    this.port = port;
    this.pgid = pgid;
    protoType = Nexus.PROTO_TYPE_TOTEM; 
  }
  public TotemInfo(String host,
                   int port,
                   int pgid) {
    this.host = host;
    this.port = port;
    this.pgid = pgid;
    protoType = Nexus.PROTO_TYPE_TOTEM; 
  }

} /* TotemInfo */
  
