
package nexus;

/*
 *
 * TotemOutgoing
 *
 * The sole purpose of this class is to associate a
 * pgid with an outgoing message from a startpoint.
 * All messages go through the TotemProto's connection
 * to the Totem server.
 */ 
public class TotemOutgoing
implements OutgoingInterface {

    private TotemProto totem;
    private int        pgid;

    /*
     * TotemOutgoing()
     */
    public TotemOutgoing(TotemProto totem, int pgid)
    {
	this.totem = totem;
	this.pgid = pgid;
	System.out.println("TotemOutgoing.TotemOutgoing(): pgid = " + pgid);
    } /* TotemOutgoing() */

    /*
     * get_Protocol_Version()
     */
    public
    int
    get_Protocol_Version()
    {
	return TotemProto.PROTOCOL_VERSION;
    }
      
    /*
     * send_rsr()
     */
    public void send_rsr(byte[] buffer)
    {
	totem.send_rsr(buffer, pgid);
    } /* send_rsr() */

    public void send_rsr(PutBuffer buffer)
    {
	System.err.println("TotemProto: send_rsr(PutBuffer) not implemented yet.");
    }
} /* TotemOutgoing */
