
package nexus;

import java.net.*;

/*
 * UdpInfo - UDP specific protocol information
 */
public class UdpInfo extends ProtoInfo {

  public static final byte RESTRICT_TO_HOST      = 0x00;
  public static final byte RESTRICT_TO_SUBNET    = 0x01;
  public static final byte RESTRICT_TO_SITE      = 0x20;
  public static final byte RESTRICT_TO_REGION    = 0x40;
  public static final byte RESTRICT_TO_CONTINENT = (byte)0x80;
  public static final byte UNRESTRICTED          = (byte)0xFF;

  public int         port;
  public InetAddress address;
  public byte        ttl;

  public UdpInfo() {
    protoType = Nexus.PROTO_TYPE_UDP; 
    port = 0;
    address = null;
    ttl = RESTRICT_TO_SUBNET;
  }

  public UdpInfo(String address,
		 int port,
		 byte ttl) {
    try {
      this.address = InetAddress.getByName(address);
    }
    catch (UnknownHostException hostX) {
      System.err.println("UdpInfo.UdpInfo(): Could not resolve address "
                         + address);
      this.address = null;
    }
    finally {
      this.port = port;
      this.ttl = ttl;
      protoType = Nexus.PROTO_TYPE_UDP; 
    }
  }
} /* UdpInfo */
  
