
package nexus;

import java.net.*;

/*
 * class UdpPacket
 */
public class UdpPacket {

  private long           endpointID;
  private DatagramPacket packet;

  /*
   * UdpPacket()
   */
  public UdpPacket(DatagramPacket packet, long endpointID) {
    this.endpointID = endpointID;
    this.packet = packet;
  } /* UdpPacket() */

  /*
   * getEndpointID()
   */ 
  public long getEndpointID() {
    return endpointID;
  } /* getEndpointID() */

  /*
   * getAddress()
   */ 
  public InetAddress getAddress() {
    return packet.getAddress();
  } /* getAddress() */

  /*
   * getPort()
   */ 
  public int getPort() {
    return packet.getPort(); 
  } /* getPort() */

  /*
   * getLength()
   */ 
  public int getLength() {
    return packet.getLength();
  } /* getLength() */

  /*
   * getData()
   */ 
  public byte[] getData() {
    return packet.getData();
  } /* getData() */

} /* UdpPacket */
