/* 
 * NexusRMI
 *
 * Copyright (c) 1999
 * Fabian Breg
 * Indiana University/Leiden University
 * All Rights Reserved
 *
 * Please refer to the LICENSE file provided in this
 * distribution for full licensing terms and
 * conditions.
 *
 * Please report all bugs/problems to
 * breg@cs.indiana.edu
 *
 ******************************************************
 *
 * SerialObject.java
 *
 */


package nexusrmi;

import java.util.Vector;

// This interface is implemented by all serializable objects.
// Its declaration is added to these objects by nexusrmis (javar).
public interface SerialObject
{
    // Write this object to the NexusBuffer. If this object has already been
    // serialized, write the index of the object in SerTab.
    public void serializeWrite(Serialize ser);

    // Read an object from the NexusBuffer and return it. If an index is read,
    // return the object at that index in the SerTab.
    public Object serializeRead(Serialize ser);
}
