/* 
 * NexusRMI
 *
 * Copyright (c) 1999
 * Fabian Breg
 * Indiana University/Leiden University
 * All Rights Reserved
 *
 * Please refer to the LICENSE file provided in this
 * distribution for full licensing terms and
 * conditions.
 *
 * Please report all bugs/problems to
 * breg@cs.indiana.edu
 *
 ******************************************************
 *
 * Registry.java
 *
 */


package nexusrmi.registry;

import nexusrmi.*;

// unchanged
// Actually, registry port should be used wherever portnumber 7000 is used
// Things work fine this way however.
public interface Registry extends Remote
{
    public static final int REGISTRY_PORT = 1099;

    public Remote lookup(String name) throws RemoteException, NotBoundException, AccessException;
    public void bind(String name, Remote obj) throws RemoteException, AlreadyBoundException, AccessException;
    public void unbind(String name) throws RemoteException, NotBoundException, AccessException;
    public void rebind(String name, Remote obj) throws RemoteException, AccessException;
    public String[] list() throws RemoteException, AccessException;
}
