#!/bin/sh
#
# Execute a HPC++ CCAT Component using
# globusrun protocol. Note that this script
# is specific to the machine baldy.extreme.indiana.edu
# This is so because the context for that machine has
# been hardwired into this script. I think it is better
# to do this as opposed to storing this information as
# part of the creationService implementation. Eventually
# these scripts won't be needed as we will used the Cog kits. 
#
#
# execHost: The host on which globusrun should instantiate
#           the component. eg: baldy.extreme.indiana.edu
# execPath: The complete path to the directory in which 
#           the executable resides. eg: /tmp/madhu/c++/
# execName: The name of the executable to be instantiated.
#	    eg: splib (note this should be in execPath)
# localHost: The host name on which the creationService
#            waits to get the startpoint of the
#            instantiated component
# port...back: The port on which the creationSrvice 
#              waits for the component to contact
#
U="usage:  $0 execHost execPath execName localHost portForComponentCallBack"

EXEC_HOST=$1
echo "ExecHost :" $EXEC_HOST
shift
EXEC_PATH=$1
echo "ExecPath :" $EXEC_PATH
shift
EXEC_NAME=$1
echo "EchoName :" $EXEC_NAME
shift
LOCAL_HOST=$1
echo "LocalHost :" $LOCAL_HOST
shift
PORT_FOR_CALLBACK=$1
echo "PortForCallBack :" $PORT_FOR_CALLBACK

## should be able to read this from the env
#USER_HOME=$HOME
USER_HOME="/u/nmukhi"
echo " HOME is "$USER_HOME
STDOUT=$USER_HOME/${EXEC_NAME}.out
echo "STDOUT is "$STDOUT
STDERR=$USER_HOME/${EXEC_NAME}.err
echo "STDERR "$STDERR


#RSL="+( &( directory=\"$EXEC_PATH\") ( executable=\"$EXEC_NAME\") ( stdout=\"$STDOUT\") ( stderr=\"$STDERR\") ( count=1) (environment=(CALLBACK_PORT $PORT_FOR_CALLBACK)(CALLBACK_HOST $LOCAL_HOST) (PROCESS_SEQ 1)) (resourceManagerContact = \"bread.extreme.indiana.edu:754/jobmanager-fork:/C=US/O=Globus/O=Indiana University/OU=Extreme Lab/CN=bread.extreme.indiana.edu\"))"

RSL="+( &( directory=\"$EXEC_PATH\") ( executable=\"$EXEC_NAME\") ( stdout=\"$STDOUT\") ( stderr=\"$STDERR\") ( count=1) (environment=(CALLBACK_PORT $PORT_FOR_CALLBACK)(CALLBACK_HOST $LOCAL_HOST) (PROCESS_SEQ 1)) (resourceManagerContact = \"bread.extreme.indiana.edu:754/jobmanager-fork:/C=US/O=Globus/O=Indiana University/OU=Extreme Lab/CN=bread.extreme.indiana.edu\"))"

CMD="/usr/local/globus/tools/mips-sgi-irix6.5/bin/globusrun"
echo "INSIDE $0"

exec $CMD "$RSL"

