CFLAGS_MOD = ${CFLAGS_MOD_PLAT} ${CFLAGS_MOD_LOC} ${CFLAGS_MOD_PLATLOC}
CFLAGS_GLOB = ${CFLAGS_PLAT} ${CFLAGS_LOC} ${CFLAGS_PLATLOC}
CFLAGS = ${CFLAGS_GLOB} ${CFLAGS_MOD}

CXXFLAGS_MOD = ${CXXFLAGS_MOD_PLAT} ${CXXFLAGS_MOD_LOC} ${CXXFLAGS_MOD_PLATLOC}
CXXFLAGS_GLOB = ${CXXFLAGS_PLAT} ${CXXFLAGS_LOC} ${CXXFLAGS_PLATLOC}
CXXFLAGS = ${CXXFLAGS_GLOB} ${CXXFLAGS_MOD}

CXXLFLAGS_MOD = ${CXXLFLAGS_MOD_PLAT} ${CXXLFLAGS_MOD_LOC} ${CXXLFLAGS_MOD_PLATLOC}
CXXLFLAGS_GLOB = ${CXXLFLAGS_PLAT} ${CXXLFLAGS_LOC} ${CXXLFLAGS_PLATLOC}
CXXLFLAGS = ${CXXLFLAGS_GLOB} ${CXXLFLAGS_MOD}

CXXARCH = ${CXXARCH_PLAT}

CPPFLAGS_MOD = ${CPPFLAGS_MOD_PLATLOC} ${CPPFLAGS_MOD_PLAT} ${CPPFLAGS_MOD_LOC} ${CPPFLAGS_MOD_IND}
CPPFLAGS_GLOB = ${CPPFLAGS_PLAT} ${CPPFLAGS_LOC} ${CPPFLAGS_PLATLOC}
CPPFLAGS = ${CPPFLAGS_GLOB} ${CPPFLAGS_MOD}

LIBPATHS_MOD = ${LIBPATHS_MOD_PLATLOC} ${LIBPATHS_MOD_LOC} ${LIBPATHS_MOD_PLAT}
LIBPATHS_GLOB = ${LIBPATHS_PLATLOC} ${LIBPATHS_LOC} ${LIBPATHS_PLAT}
LIBPATHS = ${LIBPATHS_MOD} ${LIBPATHS_GLOB}

LIBS_MOD = ${LIBS_MOD_PLATLOC} ${LIBS_MOD_LOC} ${LIBS_MOD_PLAT}
LIBS_GLOB = ${LIBS_PLATLOC} ${LIBS_LOC} ${LIBS_PLAT}
LIBS = ${Libs} ${LIBS_MOD} ${LIBS_GLOB}

CLASSPATH=${CLASSPATH_MOD}:${CLASSPATH_GLOB}

COMPILE.c = ${CC} ${CFLAGS} ${CPPFLAGS} -c
COMPILE.C = ${CXX} ${CPPFLAGS} ${CXXFLAGS} ${CXXFLAGS_LOCAL} ${CXXFLAGS_MOD}  -c
COMPILE.f = ${FC} ${FFLAGS}  -c

.SUFFIXES:
.SUFFIXES: .tmp .d .java .ser .o .c .c++ .cxx .C .cpp .f .f90 .F .F90 .y .Y .yxx .l .L .lxx

# Single suffix rules
.C:
	exit 1
.c:
	exit 1
.c++:
	exit 1
.cpp:
	exit 1
.cxx:
	exit 1
.F:
	exit 1
.f:
	exit 1
.F90:
	exit 1
.f90:
	exit 1

# Double suffix rules
.c.d:
	@touch $@

.C.d:
	${COMPILE.d}

.F.d:
	@touch $@

.f.d:
	@touch $@

.java.d:
	@touch $@

.ser.d:
	@echo "$*.java: $<" >$@

.C.o:
	$(COMPILE.C) $<

.c.o:
	$(COMPILE.c) $<
	
.c++.o:
	$(COMPILE.C) $<

.cpp.o:
	$(COMPILE.C) $<

.cxx.o:
	$(COMPILE.C) $<

.F.o:
	${F77} ${FFLAGS} -c $*.F

.f.o:
	${F77} ${FFLAGS} -c $*.f

.F90.o:
	$(F90) $(F90FLAGS) -c $*.F90

.f90.o:
	$(F90) $(F90FLAGS) -c $*.f90

.java.tmp:
	@echo $< >>out-of-date_java
	@touch $@

.ser.java:
	cp $< $*.java
	CLASSPATH=${CLASSPATH} ${JAVAC} $*.java
	CLASSPATH=${CLASSPATH}:${UZCPATH} ${BUILD_TOP}/tools/javar -ox $*.java
	rm -f $*.orig

.y.o:
	$(YACC) $(YFLAGS) $<
	$(CC) $(YACCMKDEPFLAGS) $(CFLAGS) -c y.tab.c
	-rm -f y.tab.c
	mv -f y.tab.o $@

.Y.o:
	$(YACC) $(YFLAGS) $<
	$(CXX) $(YACCMKDEPFLAGS) $(CXXFLAGS) -c y.tab.c
	-rm -f y.tab.c
	mv -f y.tab.o $@
	
.yxx.o:
	$(YACC) $(YFLAGS) $<
	$(CXX) $(YACCMKDEPFLAGS) $(CXXFLAGS) -c y.tab.c
	-rm -f y.tab.c
	mv -f y.tab.o $@
	
.l.o:
	$(LEX) $(LFLAGS) $<
	$(CC) $(LEXMKDEPFLAGS) $(CFLAGS) -c lex.yy.c
	-rm -f lex.yy.c; mv -f lex.yy.o $@

.L.o:
	$(LEX) $(LFLAGS) $<
	$(CXX) $(LEXMKDEPFLAGS) $(CXXFLAGS) -c lex.yy.c
	-rm -f lex.yy.c; mv -f lex.yy.o $@

.lxx.o:
	$(LEX) $(LFLAGS) $<
	$(CXX) $(LEXMKDEPFLAGS) $(CXXFLAGS) -c lex.yy.c
	-rm -f lex.yy.c; mv -f lex.yy.o $@


Objs1 = ${Srcs}
Objs2 = ${Objs1:.c=.o}
Objs3 = ${Objs2:.C=.o}
Objs4 = ${Objs3:.f=.o}
Objs5 = ${Objs4:.F=.o}
Objs6 = ${Objs5:.java=.tmp}
Objs7 = ${Objs6:.ser=.tmp}
Objs = ${Objs7}

Deps1 = ${Srcs}
Deps2 = ${Deps1:.c=.d}
Deps3 = ${Deps2:.C=.d}
Deps4 = ${Deps3:.f=.d}
Deps5 = ${Deps4:.F=.d}
Deps6 = ${Deps5:.java=.d}
Deps7 = ${Deps6:.ser=.d}
Deps = ${Deps7}


# The for loop garbage is necessary for IRIX make, which can't follow a
# path of more than one implicit rule.
both: subdirs
	@pwd
	@rm -f out-of-date_java
	@if [ "${MANUAL}" = "true" ]; then \
		${MAKE} ${JOBS} -f ${TOP}/Makefile deps; \
	else \
		${MAKE} ${JOBS} deps; \
	fi
	@if [ "${MANUAL}" = "true" ]; then \
		${MAKE} ${JOBS} -f ${TOP}/Makefile target; \
	else \
		${MAKE} ${JOBS} target; \
	fi

#	@pwd
#	@for i in ${Srcs} dummy; do \
#		b=`basename $$i ser`; \
#		case $$i in \
#			*.ser) \
#				echo "$${b}java: $$i" >>.d \
#				;; \
#		esac \
#	done
#	@exec ${MAKE} ${JOBS} target

clean::
	@for i in ${SubDirs} .dummy; do \
		if [ $$i != .dummy ]; then \
			if [ "${MANUAL}" = "true" ]; then \
				(cd $$i >/dev/null; ${MAKE} -f ../${TOP}/Makefile clean); \
			else \
				(cd $$i >/dev/null; ${MAKE} clean); \
			fi \
		fi \
	done
	@pwd
	@for i in ${Srcs} dummy; do \
		b=`basename $$i ser`; \
		case $$i in \
			*.ser) \
				echo /bin/rm -f $${b}java; \
				/bin/rm -f $${b}java; \
				;; \
		esac \
	done
	rm -rf *.a *.o *.class *.tmp *_Stub.java *_Skel.java ii_files SunWS_cache *.a *.d .d .deps out-of-date_java java_timestamp ${Objs} dummy.*
	@touch .deps

#	for i in *.d; do \
#		if [ "$$i" != '*.d' ]; then \
#			rm -f $$i; touch $$i; \
#		fi \
#	done

# Be careful not to name the dependency the same thing as the include
# file.  This triggers a bug in Solaris make.   Solaris make is smart
# enough to try to make the include file, but not smart enough to use
# the suffix rules we have defined.

target: ${Target}

# Use different .dummy to keep pmake quiet.
dummy1 ${Target}: dummy.${Type}
	@echo	# no-op.  Prevents GNU make from using default rule.

dummy.none:

dummy.c-exe: ${Objs}
	${CC} -o ${Target} ${Objs}
	@rm -f $@
	@ln ${Target} $@

dummy.cxx-exe: ${Objs}
	${CXX} ${CPPFLAGS} ${CXXFLAGS} ${CXXLFLAGS} -o ${Target} ${Objs} ${Mods} ${LIBPATHS} ${LIBS}
	@rm -f $@
	@ln ${Target} $@

dummy.cxx-lib: ${Objs}
	@rm -f ${Target}
	${ARCHIVE.C}
	@rm -f $@
	@ln ${Target} $@

dummy.lib: ${Objs}
	rm -f ${Target}
	${ARCHIVE.c}
	rm -f $@
	ln ${Target} $@

dummy.java-mod: java_timestamp
	@set +e; if [ "${RMIComp}" ]; then \
		for i in ${RMIComp} dummy; do \
			if [ "$$i" != "dummy" ]; then \
				p=`echo $$i | cut -f 1 -d:`; \
				o=`echo $$i | cut -f 2 -d:`; \
				b=`echo $$p | awk -F. '{print $$NF}'`; \
				CLASSPATH=${CLASSPATH} ${JAVAC} $${b}.java; \
				if [ $$? -ne 0 ]; then  exit 1; fi; \
				echo CLASSPATH=${CLASSPATH}:${UZCPATH} ${BUILD_TOP}/tools/javas -o $$o $$p; \
				CLASSPATH=${CLASSPATH}:${UZCPATH} ${BUILD_TOP}/tools/javas -o $$o $$p; \
				if [ $$? -ne 0 ]; then  exit 1; fi; \
			fi \
		done; \
		echo CLASSPATH=${CLASSPATH} ${JAVAC} *_Stub.java *_Skel.java; \
		CLASSPATH=${CLASSPATH} ${JAVAC} *_Stub.java *_Skel.java; \
		if [ $$? -ne 0 ]; then  exit 1; fi; \
	fi
	@set +e; if [ -s out-of-date_java ]; then \
		echo CLASSPATH=${CLASSPATH} ${JAVAC} `cat out-of-date_java`; \
		CLASSPATH=${CLASSPATH} ${JAVAC} `cat out-of-date_java`; \
		ec=$$?; \
		rm -f *.tmp; \
		for i in ${Objs}; do \
			c=`basename $$i tmp`class; \
			if [ -f $${c} ]; then \
				/bin/cp -p $${c} $${i}; \
			fi \
		done; \
		if [ $$ec -ne 0 ]; then  exit 1; fi \
	fi
	@touch java_timestamp
	@touch $@
	@echo ${CLASSPATH} >.classpath
	@echo ${JAVA} >.java

java_timestamp: ${Objs}
	@touch $@

# The .dummy is to prevent syntax errors when there are no Srcs
dummy2 ${Srcs} ${Hdrs}:
	@if [ -f $@ ]; then \
		echo "Not removing $@ because it is not a symblic link."; \
		exit 1; \
	else \
		echo "Linking $@."; \
		rm -f $@; \
		ln -s .src/$@ $@; \
	fi

# Hdrs need to  get linked here, because many of them might not be a dependency.
subdirs: ${Hdrs}
	@for i in ${SubDirs} .dummy; do \
		if [ "$$i" = ".dummy" ]; then \
			cat /dev/null; \
		elif [ "${MANUAL}" = "true" ]; then \
			cd "$$i" >/dev/null; \
			${MAKE} ${JOBS} -f ../${TOP}/Makefile; ec=$$?; \
			if [ "$$ec" -ne 0 ]; then exit $$ec; fi; \
			cd ".."; \
		else \
			cd "$$i" >/dev/null; \
			${MAKE} ${JOBS}; ec=$$?; \
			if [ "$$ec" -ne 0 ]; then exit $$ec; fi; \
			cd ".."; \
		fi \
	done

# Using .d for the file name of the dependencies file triggers a bug
# in IRIX make.
#
# Using the name of the include file for the target triggers a bug
# in Solaris make.
#
# /dev/null to prevent cat from trying to read from stdin in case there
# are no deps.
# Why the .d here?  I think it's for the intermod deps.
deps: ${Deps}
	@if [ "${Target}" ]; then \
		cat ${Deps} /dev/null >.deps; \
		touch .d; \
		sed "s/^${Target}:/dummy.${Type}:/" .d >>.deps; \
		echo dummy.${Type}: ${Mods} >>.deps; \
	fi

include .deps
