Target = all

Type = none

javas_obj = \
	javas.o \
	readclass.o

javar_obj = \
	ast.o \
	driver.o \
	html.o \
	lex.yy.o \
	nexusize.o \
	readclass.o \
	semantic.o \
	symbol.o \
	unparse.o \
	y.tab.o

all: javar javas

javas: ${javas_obj}
	${CC} ${CFLAGS} -o $@ ${javas_obj} 
	@rm -f ../$@
	@ln $@ ../$@

javar: ${javar_obj}
	${CC} ${CFLAGS} -o $@ $(javar_obj) -lm
	@rm -f ../$@
	@ln $@ ../$@

ast.o: ast.c global.h y.tab.h
	${CC} ${CFLAGS} -c ast.c -o ast.o
driver.o: driver.c global.h
	${CC} ${CFLAGS} -c driver.c -o driver.o
html.o: html.c global.h
	${CC} ${CFLAGS} -c html.c -o html.o
javas.o: javas.c class.h
	${CC} ${CFLAGS} -c javas.c -o javas.o
lex.yy.o: lex.yy.c y.tab.h global.h
	${CC} ${CFLAGS} -c lex.yy.c -o lex.yy.o
nexusize.o: nexusize.c class.h global.h y.tab.h
	${CC} ${CFLAGS} -c nexusize.c -o nexusize.o
parallel.o: parallel.c global.h y.tab.h
	${CC} ${CFLAGS} -c parallel.c -o parallel.o
readclass.o: readclass.c class.h
	${CC} ${CFLAGS} -c readclass.c -o readclass.o
semantic.o: semantic.c y.tab.h global.h
	${CC} ${CFLAGS} -c semantic.c -o semantic.o
symbol.o: symbol.c global.h y.tab.h
	${CC} ${CFLAGS} -c symbol.c -o symbol.o
unparse.o: unparse.c global.h y.tab.h
	${CC} ${CFLAGS} -c unparse.c -o unparse.o
y.tab.o: y.tab.c global.h
	${CC} ${CFLAGS} -c y.tab.c -o y.tab.o

y.tab.c y.tab.h: 
	bison -d -y parser.y

lex.yy.c: 
	flex scanner.l

clean::
	rm -f javar javas y.tab.c y.tab.h lex.yy.c
